#ifndef _dsp_h
#define _dsp_h

/* $Header: /rosie/src/ccd_utilities/include/RCS/dsp.h,v 1.10 1997/01/03 22:27:49 gumrukcu Exp $
 */

#include	<sys/mman.h>

#define		DSP_ERROR		-1
#define		DSP_ABORTED		-2
#define		DSP_OK			-3
#define		DSP_WAITING		-4
#define		DSP_NO_EXPECTED_REPLY	-5

#define		DSP_ACTUAL_VALUE	-1

#define		DSP_DO_NOTHING		10
#define		DSP_SHOW_NOTHING	0
#define		DSP_SHOW_ERRORS		1
#define		DSP_SHOW_COMMANDS	2
#define		DSP_SHOW_REPLYS		3
#define		MAX_DSP_BAD_REPLY_HEADERS 10	

#ifdef	SBUSTOOL
#	define	SBUS_OPEN_ERROR		1
#else	/* VMETOOL */
#	define		VME_OPEN_ERROR	1
#	define		VME_MMAP_ERROR	2
#endif	/* SBUSTOOL */
#define		DSP_CLOSE_ERROR		3
#define		DSP_BAD_REPLY_HEADER	4
#define		DSP_REPLY_ERROR		5
#define		DSP_REPLY_TIMEOUT	6
#define		DSP_MALLOC_ERROR	7
#define		DSP_DOWNLOAD_OPEN_ERROR 8
#define		DSP_DOWNLOAD_TYPE_ERROR 9
#define		DSP_DOWNLOAD_FILE_ERROR 10 
#define		DSP_SET_ERROR		11

#ifdef	SBUSTOOL
#	define	SBUS_DEVICE_ZERO	1
#	define	SBUS_DEVICE_ONE		2
#	define	SBUS_REQUEST		3
#else	/* VMETOOL */
#	define		VME_DEV		1
#	define		VME_MEM_START	2
#	define		VME_MEM_OFFSET	3
#	define		VME_MEM_SIZE	4
#	define		VME_SEND_START	5
#	define		VME_DATA_START	6
#	define		VME_REC_START	7
#	define		VME_REC_SIZE	8
#	define		DATA_ADDR	9
#endif	/* SBUSTOOL */

#define		REPLY_ACTION		10
#define		REPLY_FUNC_PTR		11
#define		DSP_PRINT_PTR		12
#define		DSP_ABORT		13
#define		DSP_DEBUG_LEVEL		14
#define		DSP_LAST_HEADER		15
#define		DSP_LAST_REPLY		16
#define		DSP_FIRST_DONE		17

#ifndef	SBUSTOOL
#	define		VME_REVISION	18
#endif	/* SBUSTOOL */

#define		REPLY_WAIT		100
#define		REPLY_NO_WAIT		101
#define		CALL_REPLY_FUNC		102

#define		MAX_DEV_SIZE		255
#ifndef	SBUSTOOL
#	define		MAX_VME_REV_SIZE	80
#endif	/* SBUSTOOL */

#ifdef	SBUSTOOL
#	define         MAX_EXPOSURE_BYTES      10240000
#	define         SBUS_DMA_FIFO_RESET     0x90000180
#	define         SBUS_BUFFER_SIZE        64
#	define         SBUS_REPLY_SIZE         8
 
#	define         SBUS_REQUEST_WRITE_CSR  0x80040000
#	define         SBUS_REQUEST_WORD_WIDTH 0x80040004
#	define         SBUS_REQUEST_READ_ADR   0x40040001
#	define         SBUS_REQUEST_READ_BCR   0x40040002
#       define         SBUS_REQUEST_TIMEOUT    0x80040007
#	define         SBUS_REQUEST_READ_CSR   0x40040000
/*henry uwo version:   #define	SBUS_RESET	0x80000010*/
#	define		SBUS_RESET		0x80000009
#endif	/* SBUSTOOL */

#define		P_MASK			0x00100000
#define		X_MASK			0x00200000
#define		Y_MASK			0x00400000

#define		HIGH_MASK		(unsigned) 0xffff0000
#define		LOW_MASK		0x0000ffff
#define		REPLY_MASK		0x00ffffff

#ifdef	SBUSTOOL
#	define	SBUS_ID			1
#else	/* VMETOOL */
#	define 	VME_ID			1
#endif	/* SBUSTOOL */
#define		TIM_ID			2
#define		UTIL_ID			3
#define   	MANUAL			4


#define		P			'P'
#define		X			'X'
#define		Y			'Y'


/* boot commands */
#define		LDA			0x4c4441        /* LDA */
#define         RDM                     0x52444d        /* RDM */
#define         RST                     0x525354        /* RST */
#define         TDL                     0x54444c        /* TDL */
#define         WRM                     0x57524d        /* WRM */
#define		SET			0x534554	/* SET */
 
#ifdef	SBUSTOOL
/* SBUS board commands */
#	define         CSR              0x435352        /* CSR */
#	define         ADR              0x414452        /* ADR */
#	define         BCR              0x424352        /* BCR */
#	define         Reset            0x526573        /* Res */
#else	/* VMETOOL */
/* VME board commands */
#	define         ABR              0x414252        /* ABR */
#	define         IRQ              0x495251        /* IRQ */
#	define         SRA              0x535241        /* SRA */
#	define         Boot             0x426f6f74      /* Boot */
#endif	/* SBUSTOOL */
 
/* timing board commands */
#define         CLR                     0x434c52        /* CLR */
#define         HGN                     0x48474e        /* HGN */
#define         IDL                     0x49444c        /* IDL */
#define         LGN                     0x4c474e        /* LGN */
#define         RAD                     0x524144        /* RAD */
#define         RDC                     0x524443        /* RDC */
#define         SBV                     0x534256        /* SBV */
#define         STP                     0x535450        /* STP */
#define         TCK                     0x54434b        /* TCK */
#define         TDC                     0x544443        /* TDC */
 
/* utility board commands */
#define		ABR			0x414252	/* ABR */
#define         AEX                     0x414558        /* AEX */
#define         CSH                     0x435348        /* CSH */
#define         OSH                     0x4f5348        /* OSH */
#define         PEX                     0x504558        /* PEX */
#define         PON                     0x504f4e        /* PON */
#define         CON                     0x434f4e        /* PON */
#define         REX                     0x524558        /* REX */
#define         SEX                     0x534558        /* SEX */
#define         RRR                     0x525252        /* RRR */
#define         SYR                     0x535952        /* SYR */
#define         TAD                     0x544144        /* TAD */
#define         TDA                     0x544441        /* TDA */
#define         TDG                     0x544447        /* TDG */
 
 
#ifdef	IRTOOL
/* additional utility board commands for use in irtool */
#define		MM1			0x4d4d31	/* MM1 */
#define		MH1			0x4d4831	/* MH1 */
#define		MM2			0x4d4d32	/* MM2 */
#define		MH2			0x4d4832	/* MH2 */

/* steps between filters on the stepper motors */
#define		IR_MOTOR_STEPS		400

#endif	IRTOOL

#define         DON                     0x444f4e        /* DON */
#define         ERR                     0x455252        /* ERR */
#define         COK                     0x434f4b        /* COK */

typedef unsigned long	dsp_opaque;

typedef struct _dsp_attr {
#ifdef	SBUSTOOL
	char		sbus_dev0[MAX_DEV_SIZE+1];
	char		sbus_dev1[MAX_DEV_SIZE+1];
	int		sbus_request;
	int		sbus_fd;
#else	/* VMETOOL */
	char		vme_dev[MAX_DEV_SIZE+1];
	int		vme_mem_start;
	int		vme_mem_offset;
	int		vme_mem_size;
	int		vme_send_start;
	int		vme_data_start;
	int		vme_rec_start;
	int		vme_rec_size;
	char		vme_revision[MAX_VME_REV_SIZE+1];
	int		mem_fd;
	int		command_fd;
	caddr_t		mem_ptr;
	caddr_t		command_ptr;
	int		*send_addr;
	int		*rec_addr;
	int		*data_addr;
	int		rec_offset;
#endif	/* SBUSTOOL */
	int		reply_action;
	int		(*reply_func_ptr)();
	int		(*print_ptr)();
	int		debug_level;
	int		abort;
	int		last_header;
	int		last_reply;
	int		first_done;
} DSP_ATTR;

#ifdef	__STDC__
extern dsp_opaque	*dsp_create(void);
extern int		dsp_set(...);
extern dsp_opaque	dsp_get(...);
extern int		dsp_open(DSP_ATTR *attr);
extern int		dsp_command(DSP_ATTR *attr, ...);
extern int		dsp_close(DSP_ATTR *attr);
extern void		dsp_update_offset(DSP_ATTR *attr);
extern void		dsp_perror(char *s);
extern int		image_transfer(...);

#else	/* K&R C */
extern dsp_opaque	*dsp_create();
extern int		dsp_set();
extern dsp_opaque	dsp_get();
extern int		dsp_open();
extern int		dsp_command();
extern int		dsp_close();
extern void		dsp_update_offset();
extern void		dsp_perror();
extern int		image_transfer();

#endif	/* __STDC__ */

extern	int		dsp_errno;

/*
 * $Log: dsp.h,v $
 * Revision 1.10  1997/01/03 22:27:49  gumrukcu
 * ***ABDUL***
 * minor changes.
 *
 * Revision 1.9  1996/03/01 04:03:45  gumrukcu
 * MAX_ERORS are 10.
 *
 * Revision 1.8  1996/02/06  19:06:39  gumrukcu
 * MAX_DSP_BAD_REPLY_HEADERS is changed back to 10.
 *
 * Revision 1.8  1996/02/06  19:06:39  gumrukcu
 * MAX_DSP_BAD_REPLY_HEADERS is changed back to 10.
 *
 * Revision 1.7  1995/12/12  22:33:17  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.6  1995/08/23  00:06:25  moore
 * ANSI conversion
 *
 * Revision 1.5  1995/08/22 22:25:06  tjk
 * Typecasted HIGH_MASK as (unsigned).
 *
 * Revision 1.4  1995/08/11  03:28:21  tjk
 * converting to ANSI C standards
 *
 * Revision 1.3  1995/08/11  03:14:09  tjk
 * converting to ANSI C standards
 *
 * Revision 1.2  1995/08/10  16:13:56  tjk
 * Added IR stuff
 *
 * Revision 1.1  1995/02/10  03:26:09  tjk
 * Initial revision
 *
 *
 */

#endif /* _dsp_h */
