#ifndef _expctl_h
#define _expctl_h

#include "mydb.h"

#define	NUM_EXPCTL_TAGS		11
#define	NUM_EXPCTL_STRINGS	10

#define	MIN_TIMER_VALUE		5

typedef	unsigned long	expctl_opaque;

typedef struct _expctl_attr {
	gfm_popup_objects	*Gfm;
	mydb_opaque		*db;
	int			do_flush_ccd;
	int			do_dual_image;
	int			do_readout_ccd;
	int			do_save;
	int 			do_beep;
	int			do_display;
	int			do_plot;
	int			do_auto_increment;
	int			exposure_time;
	int			msecs;
	char			*directory;
	char			*filename;
} EXPCTL_OBJ;

typedef enum expctl_tags {
	DO_FLUSH_CCD=1,
	DO_DUAL_IMAGE,
	DO_READOUT_CCD,
	DO_SAVE_IMAGE,
	DO_BEEP,
	DO_DISPLAY_IMAGE,
	DO_PLOT_IMAGE,
	DO_AUTO_INCREMENT,
	EXPOSURE_TIME,
	IMAGE_DIRECTORY,
	IMAGE_FILENAME,
	EXPCTL_DB,
} EXPCTL_TAGS;

extern	char		*expctl_io_strings[NUM_EXPCTL_TAGS];

#ifdef	__STDC__
extern	int		set_expctl_value(...);
extern expctl_opaque get_expctl_value(EXPCTL_OBJ *obj, EXPCTL_TAGS expctl_item);
extern	void		store_expctl_settings();
#else	/* K&R C */
extern	int		set_expctl_value();
extern	expctl_opaque	get_expctl_value();
extern	void		store_expctl_settings();
#endif	/* __STDC__ */

/*
 * $Log: expctl.h,v $
 * Revision 1.7  1996/11/25 21:27:21  peker
 * Test.
 *
 * Revision 1.6  1996/01/03  01:10:59  gumrukcu
 *  Some additions were made for N_setting.
 *
 * Revision 1.5  1995/12/15  00:08:47  gumrukcu
 * The definition of N is added.
 *
 * Revision 1.4  1995/08/21  18:43:47  tjk
 * more ANSI C conversion stuff...
 *
 * Revision 1.3  1995/08/11  03:28:21  tjk
 * converting to ANSI C standards
 *
 * Revision 1.2  1995/08/11  03:14:10  tjk
 * converting to ANSI C standards
 *
 * Revision 1.1  1995/02/10  03:22:42  tjk
 * Initial revision
 *
 *
 */

#endif /* _expctl_h */

