#ifndef	IR_H
#define	IR_H

/* $Header: /rosie/src/ccd_utilities/include/RCS/ir.h,v 1.4 1996/03/05 18:33:42 tjk Exp $ */

#define	FILTER_WHEEL_1		1
#define	FILTER_WHEEL_2		2

/* Filters in the FILTER_WHEELS */
#define	IR_FILTER_POSITION_0	0
#define	IR_FILTER_POSITION_1	1
#define	IR_FILTER_POSITION_2	2
#define	IR_FILTER_POSITION_3	3
#define	IR_FILTER_POSITION_4	4
#define	IR_FILTER_POSITION_5	5
#define	IR_FILTER_POSITION_6	6
#define	IR_FILTER_POSITION_7	7

#define IR_FILTER_HOME		IR_FILTER_POSITION_0
#define	IR_FILTER_OPEN		IR_FILTER_POSITION_7

/* The 1.064um continuum filter requires an additional blocking filter
 * on filter wheel 2.  IR_CONTINUUM_FILTER is defined as the filter
 * position on filter wheel 1; IR_BLOCKING_FILTER is the filter position
 * of the blocking filter on wheel 2.
 */
#define	IR_CONTINUUM_FILTER	IR_FILTER_POSITION_6
#define	IR_BLOCKING_FILTER	IR_FILTER_POSITION_0



typedef unsigned long	ir_opaque;

typedef	struct	_ir_obj {
	int filter_wheel1;
	int filter_wheel2;
} IR_OBJ;

/*>>>>> Global Flags <<<<<*/
extern int filter_position_known;

/*>>>>> Function Prototypes <<<<<*/
#ifdef	__STDC__
extern ir_opaque set_ir_panel_value(...);
extern ir_opaque get_ir_panel_value(...);
extern void reset_ir_panel(IR_OBJ *obj);
extern void store_fw1_value(void);
extern void store_fw2_value(void);
extern void init_ir_defaults(IR_OBJ *obj);
extern int set_ir_value(...);
extern ir_opaque get_ir_value(IR_OBJ *obj, int ir_item);
extern void move_to_filter(int filter_wheel, int new_position,
	int old_position);
extern void init_filter_wheels(IR_OBJ *obj);
extern void deactivate_buttons(int value);

#else	/* K&R C */
extern ir_opaque set_ir_panel_value();
extern ir_opaque get_ir_panel_value();
extern void reset_ir_panel();
extern void store_fw1_value();
extern void store_fw2_value();
extern void init_ir_defaults();
extern int set_ir_value();
extern ir_opaque get_ir_value();
extern void move_to_filter();
extern void init_filter_wheels();
extern void deactivate_buttons();

#endif	/* __STDC__ */

/*
 * $Log: ir.h,v $
 * Revision 1.4  1996/03/05 18:33:42  tjk
 * Added IR_CONTINUUM_FILTER and IR_BLOCKING_FILTER for special 1.064 um case.
 *
 * Revision 1.3  1995/08/21  18:31:21  tjk
 * Changed set_ir_panel_value() function prototype to variable.
 *
 * Revision 1.2  1995/08/11  03:14:13  tjk
 * converting to ANSI C standards
 *
 *
 */

#endif	IR_H
