#ifndef _setup_h
#define _setup_h

#include "mydb.h"
#include "temperature.h"

#define		NUM_SETUP_TAGS		13		
#define		NUM_SETUP_STRINGS	11	

#define		CCD_LDA_SETTING		0
#define		CCD_FILENAME_SETTING	1
#define		NO_SETTING		1
#define		YES_SETTING		0
#define		HIGH_SETTING		0
#define		LOW_SETTING		1

typedef	unsigned long	setup_opaque;

typedef struct _setup_attr {
	gfm_popup_objects	*Gfm;
	mydb_opaque		*db;
	int			do_hardware_test;
	int			hardware_test_setting;
	int			do_camera_on;
	int			do_timing_board;
	int 			do_reset_timing;
	int			do_dimensions;
	int			timing_setting;
	int			timing_lda;
	char			*timing_filename;
	int			ncols;
	int			nrows;
	int			ccd_setup_complete;
} SETUP_OBJ;

#ifdef	SBUSTOOL
typedef enum setup_tags {
	DO_HARDWARE_TEST=1,
	HARDWARE_TEST_SETTING,
	DO_TIMING_BOARD,
	DO_CAMERA_ON,
	DO_RESET_TIMING,
	DO_DIMENSIONS,
	TIMING_SETTING,
	TIMING_LDA,
	TIMING_FILENAME,
	NCOLS,
	NROWS,
	CCD_SETUP_COMPLETE,
        DB
} SETUP_TAGS;

#else	/* VMETOOL */
typedef enum setup_tags {
	DO_HARDWARE_TEST=1,
	HARDWARE_TEST_SETTING,
	DO_TIMING_BOARD,
	DO_CAMERA_ON,
	DO_DIMENSIONS,
	TIMING_SETTING,
	TIMING_LDA,
	TIMING_FILENAME,
	NCOLS,
	NROWS,
	CCD_SETUP_COMPLETE,
        DB
} SETUP_TAGS;
#endif	/* SBUSTOOL */

extern	char	*setup_io_strings[NUM_SETUP_TAGS+1];

/*
 * $Log: setup.h,v $
 * Revision 1.6  1997/01/03 22:26:52  gumrukcu
 * ***ABDUL***
 * adding reset stuff.
 *
 * Revision 1.5  1996/06/19 21:30:08  peker
 * commented out the nccds and twos' complement definitions.
 *
 * Revision 1.4  1995/12/12 22:33:20  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.3  1995/08/21  19:04:50  moore
 * ANSI standard
 *
 * Revision 1.2  1995/05/23 21:55:13  tjk
 * completed temperature upgrade.
 *
 * Revision 1.1  1995/02/10  02:46:16  tjk
 * Initial revision
 *
 *
 */

#endif /* _setup.h */
