/* $Header: /rosie/src/ccd_utilities/src/libfits/RCS/fits_io.c,v 1.4 1996/05/07 17:19:49 tjk Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/param.h>
#include <sys/types.h>
#include <unistd.h>
#ifndef	__STDC__
#include <varargs.h>
#endif	/* __STDC__ */
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "setup_io.h"
#include "gfm.h"
#include "conversion.h"
#include "message.h"
#include "fits.h"

/*>>>>> Function Prototypes <<<<<*/
#ifdef	__STDC__
void	load_fits(void);
int	load_fits_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
void	extract_fits(FITS_OBJ *fits, FILE *ifp);
void	save_as_fits(void);
int	save_as_fits_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
int	extract_fits_value(FITS_TAGS fits_item, char *value);
void	save_fits(char *filename, int append);
char	*insert_fits(FITS_OBJ *obj, FITS_TAGS fits_item);
void	fits_create_card(...);
void	get_fits_string(char value[], char str_value[]);

#else	/* K&R C */
void	load_fits();
int	load_fits_gfm_proc();
void	extract_fits();
void	save_as_fits();
int	save_as_fits_gfm_proc();
int	extract_fits_value();
int	save_fits();
char	*insert_fits();
void	fits_create_card();
void	get_fits_string();
#endif __STDC__

/*>>>>> FITS IO Functions <<<<<*/
#ifdef	__STDC__
void load_fits(void)
#else	/* K&R C */
void
load_fits()
#endif __STDC__
{

	xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, "Load FITS Header", NULL);
	gfm_activate(ccd_obj->Gfm, NULL, "", NULL, load_fits_gfm_proc,
		NULL, GFM_LOAD);
}

#ifdef	__STDC__
int load_fits_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
load_fits_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif __STDC__
{
	char		filename[255];
	char		old_filename[255];
	FITS_OBJ	*fits;
	FILE		*ifp;

	sprintf(filename, "%s/%s", dir, file);

	message_write("Loading CCD FITS Header file: %s\n", filename);

	fits = (FITS_OBJ *) fits_create();
	strcpy(old_filename, fits->filename);
	strcpy(fits->filename, file);

	if ((fits->fd = open(filename, O_RDWR, 0666)) == -1)
	{
		message_popup(Fits->fits_popup,
			MESSAGE, "Cannot open the specified",
			MESSAGE, "configuration file.",
		NULL);
		message_write("Load ABORTED.\n");
		strcpy(fits->filename, old_filename);
	}
	else
	{
		extract_fits(fits, ifp);
		message_write("Load complete.\n");
	}

	return(GFM_OK);
}


#ifdef	__STDC__
void extract_fits(FITS_OBJ *fits, FILE *ifp)
#else	/* K&R C */
void
extract_fits(fits, ifp)
FITS_OBJ	*fits;
FILE *ifp;
#endif	__STDC__
{
	int 	i,
		user_keywords=FITS_USER_KEYWORD1,
		user_keyword_values=FITS_USER_KEYWORD_VALUE1,
		extracted=0;
	static	char	buffer[81];
	char	fits_label[10], value[72];

	read(fits->fd, buffer, 80);
	buffer[80] = '\0';
	strncpy(fits_label, buffer, 8);
	fits_label[9] = '\0';
	strncpy(value, buffer+10, 70);
	value[71] = '\0';

	while (strncmp("END", fits_label, 3) != 0)
	{
		extracted = 0;

		for (i = 0; i < MAX_FITS_TAGS; i++)
		{
			if (strncmp(fios[i].string, fits_label, 8) == 0)
			{
				extract_fits_value(fios[i].tag, value);
				extracted = 1;
				break;
			}
		}
		if ((!extracted) && (user_keywords < FITS_USER_KEYWORDS))
		{
			extract_fits_value(user_keywords, fits_label);
			extract_fits_value(user_keyword_values, value);

			user_keywords++;
			user_keyword_values++;
		}


		read(fits->fd, buffer, 80);
		buffer[80] = '\0';
		strncpy(fits_label, buffer, 8);
		fits_label[9] = '\0';
		strncpy(value, buffer+10, 70);
		value[71] = '\0';
	}

	reset_fits_panel(ccd_obj->fits_obj);
}


#ifdef	__STDC__
void save_as_fits(void)
#else	/* K&R C */
void
save_as_fits()
#endif
{

	xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, "Save FITS Header As...",
	       NULL);
	gfm_activate(ccd_obj->Gfm, NULL, "", NULL, save_as_fits_gfm_proc,
		     NULL, GFM_SAVE);
}

#ifdef	__STDC__
int save_as_fits_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
save_as_fits_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif __STDC__
{
	char	full_filename[255], *value;

	FITS_OBJ	*fits;

	fits = (FITS_OBJ *) ccd_obj->fits_obj;

	strcpy(fits->directory, dir);
	strcpy(fits->filename, file);

	sprintf(full_filename, "%s/%s", dir, file);

	save_fits(full_filename, FALSE);
	return(GFM_OK);
}


#ifdef	__STDC__
int extract_fits_value(FITS_TAGS fits_item, char *value)
#else	/* K&R C */
int
extract_fits_value(fits_item, value)
FITS_TAGS	fits_item;
char		*value;
#endif
{
	int	int_value;
	float	float_value;
	char	str_value[71],
		char_value;

	switch (fits_item)
	{
		/* Logicals -- True/False */
		case FITS_SIMPLE:
			sscanf(value, "%1s", str_value);
			char_value = str_value[0];
			fits_set(ccd_obj->fits_obj, fits_item,
			       char_value, NULL);
			break;

		/* Integer Values */
		case FITS_BITPIX:
		case FITS_ISTART:
		case FITS_JSTART:
		case FITS_NAXIS:
		case FITS_NAXIS1:
		case FITS_NAXIS2:
		case FITS_POSTSCAN:
		case FITS_PRESCAN:
			int_value = char2int(value);
			fits_set(ccd_obj->fits_obj, fits_item,
			       int_value, NULL);
			break;

		/* Character Strings */
		case FITS_DATE_OBS:
		case FITS_DEC:
		case FITS_DETECTOR:
		case FITS_EXPTYPE:
		case FITS_FILTER:
		case FITS_INSTRUMENT:
		case FITS_IRAFNAME:
		case FITS_OBJECT:
		case FITS_OBSERVATORY:
		case FITS_OBSERVER:
		case FITS_RA:
		case FITS_SIDEREAL_TIME:
		case FITS_TELESCOPE:
		case FITS_UTSTART:
		case FITS_USER_KEYWORD1:
		case FITS_USER_KEYWORD2:
		case FITS_USER_KEYWORD3:
		case FITS_USER_KEYWORD4:
		case FITS_USER_KEYWORD5:
		case FITS_USER_KEYWORD6:
		case FITS_USER_KEYWORD7:
		case FITS_USER_KEYWORD8:
		case FITS_USER_KEYWORD9:
		case FITS_USER_KEYWORD_VALUE1:
		case FITS_USER_KEYWORD_VALUE2:
		case FITS_USER_KEYWORD_VALUE3:
		case FITS_USER_KEYWORD_VALUE4:
		case FITS_USER_KEYWORD_VALUE5:
		case FITS_USER_KEYWORD_VALUE6:
		case FITS_USER_KEYWORD_VALUE7:
		case FITS_USER_KEYWORD_VALUE8:
		case FITS_USER_KEYWORD_VALUE9:
			get_fits_string(value, str_value);
			fits_set(ccd_obj->fits_obj, fits_item,
				str_value, NULL);
			break;

		/* Floating point numbers */
		case FITS_AIRMASS:
		case FITS_EPOCH:
		case FITS_EXPTIME:
			float_value = (float) atof(value);
			fits_set(ccd_obj->fits_obj, fits_item,
					(double) float_value, NULL);
			break;

		/* Invalid FITS Parameter */
		default:
			fprintf(stderr,
			"\nInvalid FITS tag in extract_fits_value():  %d\n",
			fits_item);
			break;
	}
}

#ifdef	__STDC__
void save_fits(char *filename, int append)
#else	/* K&R C */
save_fits(filename, append)
char	*filename;
int	append;
#endif	__STDC__
{
	int	num_bytes, total_size, i;

	FITS_TAGS	fits_item;
	char		*value;
	FITS_OBJ	*fits;

	fits = (FITS_OBJ *) ccd_obj->fits_obj;

	message_write("Saving CCD FITS header as: %s\n", filename);
	store_fits_settings(fits);

	fits_open(fits);

	total_size = FITS_HEADER_SIZE;
/*
	lseek(fits->fd, total_size - 1, SEEK_SET);
	write(fits->fd, "", 1);
*/
	lseek(fits->fd, 0, SEEK_SET);

	put_fits_header(fits);

	fits_close(fits);
}

#ifdef	__STDC__
char *insert_fits(FITS_OBJ *obj, FITS_TAGS fits_item)
#else	/* K&R C */
char
*insert_fits(obj, fits_item)
FITS_OBJ	*obj;
FITS_TAGS	fits_item;
#endif __STDC__
{
	char	*value;
	int	int_value;
	float	float_value;

	switch (fits_item)
	{
		/* Logicals -- True/False */
		case FITS_SIMPLE:
			int_value = (int)fits_get(obj, fits_item);
			return (boolean2char(int_value));

		/* Integer Values */
		case FITS_BITPIX:
		case FITS_NAXIS:
		case FITS_NAXIS1:
		case FITS_NAXIS2:
		case FITS_POSTSCAN:
		case FITS_PRESCAN:
			int_value = (int)fits_get(obj, fits_item);
			if (int_value == UNDEFINED)
				return NULL;
			else
				return (int2char(int_value));

		/* Character Strings */
		case FITS_DATE_OBS:
		case FITS_DEC:
		case FITS_DETECTOR:
		case FITS_FILTER:
		case FITS_INSTRUMENT:
		case FITS_IRAFNAME:
		case FITS_OBJECT:
		case FITS_OBSERVATORY:
		case FITS_OBSERVER:
		case FITS_RA:
		case FITS_SIDEREAL_TIME:
		case FITS_TELESCOPE:
		case FITS_UTSTART:
		case FITS_USER_KEYWORD1:
		case FITS_USER_KEYWORD2:
		case FITS_USER_KEYWORD3:
		case FITS_USER_KEYWORD4:
		case FITS_USER_KEYWORD5:
		case FITS_USER_KEYWORD6:
		case FITS_USER_KEYWORD7:
		case FITS_USER_KEYWORD8:
		case FITS_USER_KEYWORD9:
		case FITS_USER_KEYWORD_VALUE1:
		case FITS_USER_KEYWORD_VALUE2:
		case FITS_USER_KEYWORD_VALUE3:
		case FITS_USER_KEYWORD_VALUE4:
		case FITS_USER_KEYWORD_VALUE5:
		case FITS_USER_KEYWORD_VALUE6:
		case FITS_USER_KEYWORD_VALUE7:
		case FITS_USER_KEYWORD_VALUE8:
		case FITS_USER_KEYWORD_VALUE9:
			return (char *)fits_get(obj, fits_item);

		/* Floating point numbers */
		case FITS_AIRMASS:
		case FITS_EPOCH:
		case FITS_EXPTIME:
			return (char *)fits_get(obj, fits_item);

		/* Invalid FITS Parameter */
		default:
			fprintf(stderr,
			"\nInvalid FITS tag in insert_fits():  %d\n",
			fits_item);
			break;

	}
}

#ifdef	__STDC__
void fits_create_card(...)
#else	/* K&R C */
void fits_create_card(va_alist)
va_dcl
#endif __STDC__
{
	va_list	ap;

	extern FIOS fios[];

	int tag, modifier;
	char	buffer[81],
		card[81];

	char	char_value,
		string_value[81],
		user_tag_value[10];
	int	int_value;
	float	float_value;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	strcpy(card, strdup(va_arg(ap, char *)));
	modifier = va_arg(ap, int);

	for (tag = 0; tag < MAX_FITS_TAGS; tag++)
	{
		if (fios[tag].tag == modifier)
			break;
	}

	switch (modifier)
	{
		/* Logicals -- True/False */
		case FITS_SIMPLE:
			char_value = va_arg(ap, char);
			sprintf(buffer, "%8s= %20c", fios[tag].string,
				char_value);
			break;

		/* Integer Values */
		case FITS_BITPIX:
		case FITS_NAXIS:
		case FITS_NAXIS1:
		case FITS_NAXIS2:
		case FITS_POSTSCAN:
		case FITS_PRESCAN:
			int_value = va_arg(ap, int);
			sprintf(buffer, "%8s= %20d", fios[tag].string,
				int_value);
			break;

		/* Character Strings */
		case FITS_DATE_OBS:
		case FITS_DEC:
		case FITS_DETECTOR:
		case FITS_FILTER:
		case FITS_INSTRUMENT:
		case FITS_IRAFNAME:
		case FITS_OBJECT:
		case FITS_OBSERVATORY:
		case FITS_OBSERVER:
		case FITS_RA:
		case FITS_SIDEREAL_TIME:
		case FITS_TELESCOPE:
		case FITS_UTSTART:
			strncpy(string_value, strdup(va_arg(ap, char *)),
				67);
			string_value[68]= '\0';
			if (string_value[0] != '\'')
			{
				sprintf(buffer, "%8s= '%-67s'",
					fios[tag].string, string_value);
			}
			else
			{
				sprintf(buffer, "%8s= %-67s",
					fios[tag].string, string_value);
			}
			break;

		/* These values are for the variable user comments
		 * fields.  Both the keywords and the values are
		 * necessary when reading in the data.
		 */
		case FITS_USER_KEYWORD1:
		case FITS_USER_KEYWORD2:
		case FITS_USER_KEYWORD3:
		case FITS_USER_KEYWORD4:
		case FITS_USER_KEYWORD5:
		case FITS_USER_KEYWORD6:
		case FITS_USER_KEYWORD7:
		case FITS_USER_KEYWORD8:
		case FITS_USER_KEYWORD9:
			strncpy(user_tag_value, strdup(va_arg(ap, char *)),
				8);
			user_tag_value[8]= '\0';
			strncpy(string_value, strdup(va_arg(ap, char *)),
				67);
			string_value[68]= '\0';
			if (string_value[0] != '\'')
			{
				sprintf(buffer, "%8s= '%-67s'",
					user_tag_value, string_value);
			}
			else
			{
				sprintf(buffer, "%8s= %-67s",
					user_tag_value, string_value);
			}
			break;


		/* Floating point numbers */
		case FITS_AIRMASS:
		case FITS_EPOCH:
		case FITS_EXPTIME:
			float_value = (float) va_arg(ap, double);
			sprintf(buffer, "%8s= %20.6e", fios[tag].string,
				float_value);
			break;

		/* User Comments Field */
		case FITS_HISTORY:
		case FITS_COMMENT:
			strcpy(string_value, strdup(va_arg(ap, char *)));
			sprintf(buffer, "%8s %71s", fios[tag].string,
				string_value);
			break;

		/* Invalid FITS Parameter */
		default:
			fprintf(stderr,
			  "\nInvalid FITS tag in fits_create_card():  %d\n",
			  modifier);
			break;

	}

	sprintf(card, "%-80s", buffer);

	return;
}


#ifdef	__STDC__
void get_fits_string(char value[], char str_value[])
#else	/* K&R C */
void
get_fits_string(value, str_value)
char	value[81];
char	str_value[81];
#endif	__STDC__
{
	int	i=0, j=0, end_of_string=0;
	char	temp, previous, next;

	/* Check for beginning of string character:  "'" */
	temp = value[i];
	while ((temp != '\'') && (i < 81))
	{
		i++;
		temp = value[i];
	}

	/* Get the next characters until a single "'" is reached */
	previous = temp;
	temp = value[++i];
	next = value[++i];

	while ((!end_of_string) && (i < 81))
	{
		if ((temp == '\'') &&
		    ((previous == '\'') || (next == '\'')) &&
		    (j != 0))
		{
			str_value[j] = temp;
			j++;
			previous = temp;
			temp = next;
			next = value[++i];
		}
		else if (temp != '\'')
		{
			str_value[j] = temp;
			j++;
			previous = temp;
			temp = next;
			next = value[++i];
		}
		else
			end_of_string = 1;
	}

	str_value[j] = '\0';

	return;
}

/*
 * $Log: fits_io.c,v $
 * Revision 1.4  1996/05/07 17:19:49  tjk
 * Added user supplied keywords.
 *
 * Revision 1.3  1995/08/22 00:09:21  tjk
 * Updated log for new RCS version.
 *
 * Revision 1.2  1995/08/21  23:57:39  tjk
 * Corrected ANSI errors...
 *
 * Revision 1.1  1995/08/10  16:37:25  tjk
 * Initial revision
 *
 *
 */
