/* $Header: /rosie/src/ccd_utilities/tool/RCS/ccd_utils.c,v 1.6 1996/03/08 23:40:29 tjk Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <X11/cursorfont.h>
#include "ccd.h"
#include "ccd_ui.h"
#include "setup_ui.h"
#include "direct_dsp_ui.h"
#include "expctl_ui.h"
#include "ccd_utils.h"
#include "gfm.h"
#include "message.h"

#ifndef	SBUSTOOL
#include "vme_ui.h"
#endif	/* SBUSTOOL */

#ifdef	__STDC__
int busy_window(Xv_object *frame, Xv_object *panel, int value);
int ccdtool_busy(int value);
void ccdtool_debug_level(int level);
void load_ccdtool_config(void);
void save_ccdtool_config(void);
int load_ccdtool_config_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
int save_ccdtool_config_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);

#else	/* K&R C */
int	busy_window();
int	ccdtool_busy();
void	ccdtool_debug_level();
void	load_ccdtool_config();
void	save_ccdtool_config();
int	load_ccdtool_config_gfm_proc();
int	save_ccdtool_config_gfm_proc();
#endif	/* __STDC__ */

#ifdef	__STDC__
int busy_window(Xv_object *frame, Xv_object *panel, int value)
#else	/* K&R C */
int
busy_window(frame, panel, value)
Xv_object	*frame;
Xv_object	*panel;
int		value;
#endif	/* __STDC__ */
{

	Display		*dpy;
	Window		win;

	dpy = (Display *)xv_get((Xv_object) frame, XV_DISPLAY);
	win = xv_get((Xv_object) panel, XV_XID);

	if (value == TRUE) {
		XDefineCursor(dpy, win, XCreateFontCursor(dpy, XC_watch));
	}
	else {
		XDefineCursor(dpy, win, XCreateFontCursor(dpy, XC_top_left_arrow));
	}
}


#ifdef	__STDC__
int ccdtool_busy(int value)
#else	/* K&R C */
int
ccdtool_busy(value)
int	value;
#endif	/* __STDC__ */
{
	busy_window((Xv_object *) Setup->setup_popup,
		    (Xv_object *) Setup->controls1, value);
	xv_set(Setup->apply_button, PANEL_INACTIVE, value, NULL);

	busy_window((Xv_object *) Expctl->expctl_popup,
		    (Xv_object *) Expctl->controls1, value);
	busy_window((Xv_object *) Expctl->expctl_popup,
		    (Xv_object *) Expctl->controls2, value);
	busy_window((Xv_object *) Expctl->expctl_popup,
		    (Xv_object *) Expctl->controls3, value);
	busy_window((Xv_object *) Expctl->expctl_popup,
		    (Xv_object *) Expctl->controls4, value);
	xv_set(Expctl->save_to_disk_button, PANEL_INACTIVE, value, NULL);
	xv_set(Expctl->readout_ccd_button, PANEL_INACTIVE, value, NULL);

	xv_set(Direct_dsp->direct_dsp_popup, FRAME_BUSY, value, NULL);
}


#ifdef	__STDC__
void ccdtool_debug_level(int level)
#else	/* K&R C */
void
ccdtool_debug_level(level)
int	level;
#endif	/* __STDC__ */
{
	if (ccdtool_debug) {
		dsp_set(ccd_obj->dsp_obj, DSP_DEBUG_LEVEL, DSP_DO_NOTHING, NULL);
	}
	else {
		ccd_obj->debug_level = level;
		dsp_set(ccd_obj->dsp_obj, DSP_DEBUG_LEVEL, level, NULL);
	}
}


#ifdef	__STDC__
void load_ccdtool_config(void)
#else	/* K&R C */
void load_ccdtool_config()
#endif	/* __STDC__ */
{
#ifdef	IRTOOL
        xv_set(ccd_obj->Gfm->popup, FRAME_LABEL,
		"Load IRTool Configuration", NULL);
#else	/* CCDTOOL */
        xv_set(ccd_obj->Gfm->popup, FRAME_LABEL,
		"Load CCDTool Configuration", NULL);
#endif	/* IRTOOL */
        gfm_activate(ccd_obj->Gfm, NULL, "", NULL, load_ccdtool_config_gfm_proc, NULL, GFM_LOAD);

}


#ifdef	__STDC__
void save_ccdtool_config(void)
#else	/* K&R C */
void
save_ccdtool_config()
#endif	/* __STDC__ */
{
#ifdef	IRTOOL
        xv_set(ccd_obj->Gfm->popup, FRAME_LABEL,
		"Save IRTool Configuration", NULL);
#else	/* CCDTOOL */
        xv_set(ccd_obj->Gfm->popup, FRAME_LABEL,
		"Save CCDTool Configuration", NULL);
#endif	/* IRTOOL */
        gfm_activate(ccd_obj->Gfm, NULL, "", NULL, save_ccdtool_config_gfm_proc, NULL, GFM_SAVE);
}


#ifdef	__STDC__
int load_ccdtool_config_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
load_ccdtool_config_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif	/* __STDC__ */
{
	char		filename[255];

	sprintf(filename, "%s/%s", dir, file);

	if ((load_config_db(filename)) == -1) {
		message_popup(Ccd->ccd, 
			MESSAGE, "Cannot load config file.",
		NULL);
		message_write("Load ABORTED.\n");
	}
	else {
		message_write("Load complete.\n");
	}
}


#ifdef	__STDC__
int save_ccdtool_config_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
save_ccdtool_config_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif	/* __STDC__ */
{
	char	filename[255];

	sprintf(filename, "%s/%s", dir, file);

#ifndef	SBUSTOOL
	save_vme_setup(filename, FALSE);
#endif	/* SBUSTOOL */

	save_setup(filename, TRUE);
}


/*
 * $Log: ccd_utils.c,v $
 * Revision 1.6  1996/03/08 23:40:29  tjk
 * Changed CCDTool to IRTool for gfm popup windows.
 *
 * Revision 1.5  1996/02/09  22:31:50  gumrukcu
 * When the ccdtool is busy like when taking an exposure the new buttons added in expctl
 * window are also made inactive.
 *
 * Revision 1.4  1995/12/12  22:33:28  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.3  1995/08/21  18:42:09  tjk
 * converting to ANSI C.  Typecasted frame/panel in busy_window()
 *
 * Revision 1.2  1995/04/05  17:18:36  tjk
 * Added temperature button in Exposure Control
 *
 * Revision 1.1  1995/02/10  03:52:39  tjk
 * Initial revision
 *
 *
 */
