/* $Header: /rosie/src/ccd_utilities/tool/RCS/conversion.c,v 1.2 1995/08/21 18:42:09 tjk Exp $
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "setup_io.h"

#ifdef	__STDC__
int	board_setting2int(char *value);
char	*int2board_setting(int value);
int	yes_no2int(char *value);
char	*int2yes_no(int value);
int	high_low2int(char *value);
char	*int2high_low(int value);
int	char2boolean(char *value);
char	*boolean2char(int value);
int	char2int(char *value);
char	*int2char(int value);
int	char2hex(char *value);
char	*hex2char(int value);
double	char2float(char *value);
char	*float2char(double value);
static int match(char *s1, char *s2);

#else	/* K&R C */
int     board_setting2int();
char    *int2board_setting();
int     yes_no2int();
char    *int2yes_no();
int     high_low2int();
char    *int2high_low();
int     char2boolean();
char    *boolean2char();
int     char2int();
char    *int2char();
int     char2hex();
char    *hex2char();
double  char2float();
char    *float2char();
static int match();

#endif	/* __STDC__ */



#ifdef	__STDC__
int board_setting2int(char *value)
#else	/* K&R C */
int
board_setting2int(value)
char	*value;
#endif	/* __STDC__ */
{
	if (match(value, LDA_VALUE))
		return(CCD_LDA_SETTING);
	else if (match(value, FILENAME_VALUE))
		return(CCD_FILENAME_SETTING);
	else return UNDEFINED;
}


#ifdef	__STDC__
char *int2board_setting(int value)
#else	/* K&R C */
char
*int2board_setting(value)
int	value;
#endif	/* __STDC__ */
{
	if (value == CCD_LDA_SETTING)
		return LDA_VALUE;
	else if (value == CCD_FILENAME_SETTING)
		return FILENAME_VALUE;
	else return NULL;
}

#ifdef	__STDC__
int yes_no2int(char *value)
#else	/* K&R C */
int
yes_no2int(value)
char	*value;
#endif	/* __STDC__ */
{
	if (match(value, YES_VALUE))
		return(YES_SETTING);
	else if (match(value, NO_VALUE))
		return(NO_SETTING);
	else return UNDEFINED;
}


#ifdef	__STDC__
char *int2yes_no(int value)
#else	/* K&R C */
char
*int2yes_no(value)
int	value;
#endif	/* __STDC__ */
{
	if (value == YES_SETTING)
		return YES_VALUE;
	else if (value == NO_SETTING)
		return NO_VALUE;
	else return NULL;
}

#ifdef	__STDC__
int high_low2int(char *value)
#else	/* K&R C */
int
high_low2int(value)
char	*value;
#endif	/* __STDC__ */
{
	if (match(value, HIGH_VALUE))
		return (HIGH_SETTING);
	else if (match(value, LOW_VALUE))
		return (LOW_SETTING);
	else return UNDEFINED;
}


#ifdef	__STDC__
char *int2high_low(int value)
#else	/* K&R C */
char
*int2high_low(value)
int	value;
#endif	/* __STDC__ */
{
	if (value == HIGH_SETTING)
		return HIGH_VALUE;
	else if (value == LOW_SETTING)
		return LOW_VALUE;
	else return NULL;
}


#ifdef	__STDC__
int char2boolean(char *value)
#else	/* K&R C */
int
char2boolean(value)
char	*value;
#endif	/* __STDC__ */
{
	if (match(value, TRUE_VALUE))
		return TRUE;
	else if (match(value, FALSE_VALUE))
		return FALSE;
	else return UNDEFINED;
}


#ifdef	__STDC__
char *boolean2char(int value)
#else	/* K&R C */
char
*boolean2char(value)
int	value;
#endif	/* __STDC__ */
{
	if (value == TRUE)
		return TRUE_VALUE;
	else if (value == FALSE)
		return FALSE_VALUE;
	else return NULL;
}

#ifdef	__STDC__
int char2int(char *value)
#else	/* K&R C */
int
char2int(value)
char	*value;
#endif	/* __STDC__ */
{
	if (*value == '\0') {
		return UNDEFINED;
	}
	return (atoi(value));
}


#ifdef	__STDC__
char *int2char(int value)
#else	/* K&R C */
char
*int2char(value)
int	value;
#endif	/* __STDC__ */
{
	static char	buffer[255];

	if (value == UNDEFINED)
		return NULL;
	else {
		sprintf(buffer, "%d", value);
		return buffer;
	}
}


#ifdef	__STDC__
int char2hex(char *value)
#else	/* K&R C */
int
char2hex(value)
char	*value;
#endif	/* __STDC__ */
{
	int	result;

	if (*value == '\0') {
		return UNDEFINED;
	}
	sscanf(value, "%x", &result);
	return result;
}


#ifdef	__STDC__
char *hex2char(int value)
#else	/* K&R C */
char
*hex2char(value)
int	value;
#endif	/* __STDC__ */
{
	static char	buffer[255];

	if (value == UNDEFINED)
		return NULL;
	else {
		sprintf(buffer, "%08x", value);
		return buffer;
	}
}

#ifdef	__STDC__
double char2float(char *value)
#else	/* K&R C */
double
char2float(value)
char	*value;
#endif	/* __STDC__ */
{
	static double	result;
	if (*value == '\0') {
		return (double)0.0;
	}
	sscanf(value, "%lf", &result);
	return result;
}


#ifdef	__STDC__
char *float2char(double value)
#else	/* K&R C */
char
*float2char(value)
double	value;
#endif	/* __STDC__ */
{
	static char	buffer[255];

	if (value == (double)0.0)
		return NULL;
	else {
		sprintf(buffer, "%lf", value);
		return buffer;
	}
}


#ifdef	__STDC__
static int match(char *s1, char *s2)
#else	/* K&R C */
static int
match(s1, s2)
char	*s1, *s2;
#endif	/* __STDC__ */
{
	char	c1, c2;

	while (*s2) {
		c1 = tolower(*s1);
		c2 = tolower(*s2);
		if (c1 != c2)
			return FALSE;
		s1++;
		s2++;
	}
	return TRUE;
}



/*
 * $Log: conversion.c,v $
 * Revision 1.2  1995/08/21 18:42:09  tjk
 * converting to ANSI C standard
 *
 * Revision 1.1  1995/02/10  03:53:03  tjk
 * Initial revision
 *
 *
 */
