/* $Header: /rosie/src/ccd_utilities/tool/RCS/direct_dsp.c,v 1.12 1996/02/05 18:26:24 gumrukcu Exp $
 */

#include <stdio.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <group.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "dsp.h"
#include "dsp_conf.h"
#include "message.h"

#define DSP_END	-123456

extern int send_command(DSP_ATTR *attr, ...);
extern int dsp_get_reply(DSP_ATTR *attr, int board_id,
                              int expected_reply, int timeout);
extern setup_opaque
      get_direct_dsp_value(DIRECT_DSP_OBJ *obj, DIRECT_DSP_TAGS dsp_item);



/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void change_board(int value);
void change_boot_command(int value);
void change_utility_command(int value);
void change_timing_command(int value);
int panel2board(int value);
int panel2boot_command(int value);
int panel2utility_command(int value);
int panel2timing_command(int value);
int board2panel(int value);
int boot_command2panel(int command);
int utility_command2panel(int command);
int timing_command2panel(int command);
int mem_space2panel(char value);
char panel2mem_space(int value);
int send_direct_dsp_command(void);
int send_manual_command(void);
int abort_send(void);
int send_busy(int value);
#	ifdef	SBUSTOOL
void change_sbus_command(int value);
int panel2sbus_command(int value);
int sbus_command2panel(int command);
#	else	/* VMETOOL */
void change_vme_command(int value);
int panel2vme_command(int value);
int vme_command2panel(int command);
#	endif	/* SBUSTOOL */

#else	/* K&R C */
void change_board();
void change_boot_command();
void change_utility_command();
void change_timing_command();
int panel2board();
int panel2boot_command();
int panel2utility_command();
int panel2timing_command();
int board2panel();
int boot_command2panel();
int utility_command2panel();
int timing_command2panel();
int mem_space2panel();
char panel2mem_space();
int send_direct_dsp_command();
int send_abort();
int send_busy();
#	ifdef	SBUSTOOL
void change_sbus_command();
int panel2sbus_command();
int sbus_command2panel();
#	else	/* VMETOOL */
void change_vme_command();
int panel2vme_command();
int vme_command2panel();
#	endif	/* SBUSTOOL */

#endif	/* __STDC__ */

/*>>>>>  End Function Prototypes <<<<<*/


#ifdef	__STDC__
void change_board(int value)
#else	/* K&R C */
void
change_board(value)
int	value;
#endif	/* __STDC__ */
{
	int	board;

	board = panel2board(value);
	set_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_BOARD, board, NULL);
	update_direct_dsp_panel(ccd_obj->direct_dsp_obj, DSP_BOARD);
}


#ifdef	__STDC__
void change_boot_command(int value)
#else	/* K&R C */
void
change_boot_command(value)
int	value;
#endif	/* __STDC__ */
{
	int	command;

	command = panel2boot_command(value);
	set_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_COMMAND,
		command, NULL);
	update_direct_dsp_panel(ccd_obj->direct_dsp_obj, DSP_COMMAND);
}


#ifdef	__STDC__
void change_utility_command(int value)
#else	/* K&R C */
void
change_utility_command(value)
int	value;
#endif	/* __STDC__ */
{
	int	command;

	command = panel2utility_command(value);
	set_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_COMMAND,
		command, NULL);
	update_direct_dsp_panel(ccd_obj->direct_dsp_obj, DSP_COMMAND);
}


#ifdef	__STDC__
void change_timing_command(int value)
#else	/* K&R C */
void
change_timing_command(value)
int	value;
#endif	/* __STDC__ */
{
	int	command;

	command = panel2timing_command(value);
	set_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_COMMAND,
		command, NULL);
	update_direct_dsp_panel(ccd_obj->direct_dsp_obj, DSP_COMMAND);
}


#ifdef	__STDC__
int panel2boot_command(int value)
#else	/* K&R C */
int
panel2boot_command(value)
int	value;
#endif	/* __STDC__ */
{
        switch (value) {
                case -1:  /* NO_COMMAND */
			return(NO_COMMAND);
                case 0:  /* LDA */
                        return(LDA);
                case 1:  /* RDM */
                        return(RDM);
                case 2:  /* RST */
                        return(RST);
                case 3:  /* TDL */
                        return(TDL);
                case 4:  /* WRM */
                        return(WRM);
		default:
			return(NO_COMMAND);
        }
}


#ifdef	__STDC__
int panel2utility_command(int value)
#else	/* K&R C */
int
panel2utility_command(value)
int	value;
#endif	/* __STDC__ */
{
        switch (value) {
                case -1:  /* NO_COMMAND */
                        return(NO_COMMAND);
                case 0: /* AEX */
                        return(AEX);
                case 1: /* CSH */
                        return(CSH);
                case 2: /* OSH */
                        return(OSH);
                case 3: /* PEX */
                        return(PEX);
                case 4: /* PON */
                        return(PON);
                case 5: /* REX */
                        return(REX);
                case 6: /* SEX */
                        return(SEX);
                case 7: /* SYR */
                        return(SYR);
#ifdef	IRTOOL
                case 8: /* MM1 */
                        return(MM1);
                case 9: /* MH1 */
                        return(MH1);
                case 10: /* MM2 */
                        return(MM2);
                case 11: /* MH2 */
                        return(MH2);
#endif	/* IRTOOL */
                default:
                        return(NO_COMMAND);
        }
}


#ifdef	__STDC__
int panel2timing_command(int value)
#else	/* K&R C */
int
panel2timing_command(value)
int	value;
#endif	/* __STDC__ */
{
        switch (value) {
                case -1:  /* NO_COMMAND */
                        return(NO_COMMAND);
                case 0:  /* CLR */
                        return(CLR);
                case 1:  /* HGN */
                        return(HGN);
                case 2:  /* IDL */
                        return(IDL);
                case 3:  /* LGN */
                        return(LGN);
                case 4:  /* RAD */
                        return(RAD);
                case 5:  /* RDC */
                        return(RDC);
                case 6:  /* SBV */
                        return(SBV);
                case 7:  /* STP */
                        return(STP);
                default:
                        return(NO_COMMAND);
        }
}


#ifdef	__STDC__
int board2panel(int value)
#else	/* K&R C */
int
board2panel(value)
int	value;
#endif	/* __STDC__ */
{
	switch (value) {
#	ifdef	SBUSTOOL
		case SBUS_ID:
			return 0;
#	else	/* VMETOOL */
		case VME_ID:
			return 0;
#	endif	/* SBUSTOOL */

		case TIM_ID:
			return 1;
		case UTIL_ID:
			return 2;
		default:
			return -1;
	}
}


#ifdef	__STDC__
int boot_command2panel(int command)
#else	/* K&R C */
int
boot_command2panel(command)
int	command;
#endif	/* __STDC__ */
{
	switch (command) {
		case NO_COMMAND:
			return -1;
		case LDA:
			return 0;
		case RDM:
			return 1;
		case RST:
			return 2;
		case TDL:
			return 3;
		case WRM:
			return 4;
		default:
			return -1;
	}
}


#ifdef	__STDC__
int utility_command2panel(int command)
#else	/* K&R C */
int
utility_command2panel(command)
int	command;
#endif	/* __STDC__ */
{
	switch (command) {
		case NO_COMMAND:
			return -1;
		case AEX:
			return 0;
		case CSH:
			return 1;
		case OSH:
			return 2;
		case PEX:
			return 3;
		case PON:
			return 4;
		case REX:
			return 5;
		case SEX:
			return 6;
		case SYR:
			return 7;
#ifdef	IRTOOL
		case MM1:
			return 8;
		case MH1:
			return 9;
		case MM2:
			return 10;
		case MH2:
			return 11;
#endif	/* IRTOOL */
		default:
			return -1;
	}
}


#ifdef	__STDC__
int timing_command2panel(int command)
#else	/* K&R C */
int
timing_command2panel(command)
int	command;
#endif	/* __STDC__ */
{
	switch (command) {
		case NO_COMMAND:
			return -1;
		case CLR:
			return 0;
		case HGN:
			return 1;
		case IDL:
			return 2;
		case LGN:
			return 3;
		case RAD:
			return 4;
		case RDC:
			return 5;
		case SBV:
			return 6;
		case STP:
			return 7;
		default:
			return -1;
	}
}


#ifdef	__STDC__
int mem_space2panel(char value)
#else	/* K&R C */
int
mem_space2panel(value)
char	value;
#endif	/* __STDC__ */
{
	switch (value) {
		case 'P':
			return 0;
		case 'X':
			return 1;
		case 'Y':
			return 2;
		default:
			return -1;
	}
}


#ifdef	__STDC__
char panel2mem_space(int value)
#else	/* K&R C */
char
panel2mem_space(value)
int	value;
#endif	/* __STDC__ */
{
	switch (value) {
		case 0:
			return 'P';
		case 1:
			return 'X';
		case 2:
			return 'Y';
		default:
			return (char)-1;
	}
}


#ifdef	__STDC__
int send_direct_dsp_command(void)
#else	/* K&R C */
int
send_direct_dsp_command()
#endif	/* __STDC__ */
{
	int		command;
	int		board;
	int		address;
	int		data;
	int		return_value;
	char		mem_space;
	char		string[255];
	dsp_opaque	*dsp;
	int		dma_value=0;


	send_busy(TRUE);
	board = (int)get_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_BOARD);
	if (board == MANUAL) {
	  send_manual_command();
	  return;
	}
	command = (int)get_direct_dsp_value(ccd_obj->direct_dsp_obj,
		DSP_COMMAND);
	mem_space = (char)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj,
		DSP_MEM_SPACE);
	address = (int)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj,
		DSP_ADDRESS);
	data = (int)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj,
		DSP_DATA);
	dsp = ccd_obj->dsp_obj;

	if (command != CSR && command != BCR && command != ADR && command != Reset)
	  send_reset(dsp);

	switch (command)
	{
		case LDA:
		case TDL:
			if (data == UNDEFINED)
			{
				message_popup(Direct_dsp->direct_dsp_popup, 
					MESSAGE,
					"You must specify a data value.",
				NULL);
				send_busy(FALSE);
				return -1;
			}
			return_value = dsp_command((DSP_ATTR *)dsp, board, command, data);
			break;
		case RDM:
			if (address == UNDEFINED)
			{
				message_popup(Direct_dsp->direct_dsp_popup, 
					MESSAGE,
					"You must specify an address value.",
				NULL);
				send_busy(FALSE);
				return -1;
			}
			return_value = dsp_command((DSP_ATTR *)dsp, board, command,
				mem_space, address);
			break;
		case WRM:
			if (address == UNDEFINED)
			{
				message_popup(Direct_dsp->direct_dsp_popup, 
					MESSAGE,
					"You must specify an address value.",
				NULL);
				send_busy(FALSE);
				return -1;
			}
			if (data == UNDEFINED)
			{
				message_popup(Direct_dsp->direct_dsp_popup, 
					MESSAGE,
					"You must specify a data value.",
				NULL);
				send_busy(FALSE);
				return -1;
			}
			return_value = dsp_command((DSP_ATTR *)dsp, board, command,
				mem_space, address, data);
			break;
#ifdef	SBUSTOOL
		case CSR:
		case ADR:
		case BCR:
			return_value = dsp_command((DSP_ATTR *)dsp, board, command);
			dma_value = 1;
			break;
		case Reset:
			return_value = dsp_command((DSP_ATTR *)dsp, board, command);
			break;
#else	/* VMETOOL */
		case SRA:
			if (address == UNDEFINED)
			{
				message_popup(Direct_dsp->direct_dsp_popup, 
					MESSAGE,
					"You must specify an address value.",
				NULL);
				send_busy(FALSE);
				return -1;
			}
			return_value=dsp_command((DSP_ATTR *)dsp, board, command, address);
			break;
		case Boot:
			vme_rev_num = (char *)dsp_get(dsp, VME_REVISION);
			if (strcmp(vme_rev_num, DEFAULT_VME_REVISION) == 0)
			{
				address = get_vme_value(ccd_obj->vme_obj,
					COMMAND_ADDR);
				if (address == UNDEFINED)
				{
				message_popup(Direct_dsp->direct_dsp_popup,
				MESSAGE,
				"You must specify a command address value.",
					NULL);
				send_busy(FALSE);
					return -1;
				}
				return_value = dsp_command((DSP_ATTR *)dsp, board,
					command, mem_space, address, data);
			}
			else
			{
				message_popup(Direct_dsp->direct_dsp_popup,
				MESSAGE,
				"Wrong VME to controller revision number. Cannot reset VME.",
					NULL);
				send_busy(FALSE);
				return -1;
			}
			break;
#endif	/* SBUSTOOL */

#ifdef	IRTOOL
		case MM1:
		case MM2:
			return_value = dsp_command((DSP_ATTR *)dsp, board, command,
						   IR_MOTOR_STEPS);
			break;
#endif	/* IRTOOL */
		default:
			return_value = dsp_command((DSP_ATTR *)dsp, board, command,NULL);
			break;
	}

	switch (return_value)
	{
		case DSP_ERROR:
			write_frame(Direct_dsp->direct_dsp_popup,
				FRAME_LEFT_FOOTER, "Reply: ERR");
			break;
		case DSP_OK:
			write_frame(Direct_dsp->direct_dsp_popup,
				FRAME_LEFT_FOOTER, "Reply: DON");
			break;
		case DSP_NO_EXPECTED_REPLY:
			write_frame(Direct_dsp->direct_dsp_popup,
				FRAME_LEFT_FOOTER,
				"Reply: None Expected");
			break;
		default:
			if (dma_value)
			{
				sprintf(string, "Returned value:  %08x",
					return_value);
				dma_value = 0;
			}
			else
			{
				sprintf(string, "Returned value:  %06x",
					return_value);
			}
			write_frame(Direct_dsp->direct_dsp_popup,
				FRAME_LEFT_FOOTER, string);
	}
	send_busy(FALSE);
}

/*
 *  MANUAL COMMAND
 */

int send_manual_command(void)
{
	int header;
	int command;
	int arg1;
	int arg2; 
	dsp_opaque *dsp;
	int return_value;
	int board_id;
	char string[255];

	header    = (int)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj, 
			DSP_ADDRESS);
	command   = (int)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj, 
			DSP_DATA);
	arg1      = (int)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj, DSP_ARG1_FIELD);
	arg2      = (int)get_direct_dsp_panel_value(ccd_obj->direct_dsp_obj, DSP_ARG2_FIELD);

        dsp       = ccd_obj->dsp_obj;
	
	if (header == UNDEFINED)
	  {
	  message_popup(Direct_dsp->direct_dsp_popup, MESSAGE,
		"You must specify a header.",
	  NULL);
	  send_busy(FALSE);
	  return -1;
	  }
	if (command == UNDEFINED)
	  {
	  message_popup(Direct_dsp->direct_dsp_popup, MESSAGE,
		"You must specify a command.",
	  NULL);
	  send_busy(FALSE);
	  return -1;
	  }


	if (arg1 == UNDEFINED) {
	  if (arg2 == UNDEFINED) {
	    send_command((DSP_ATTR*) dsp, header, command, DSP_END);
	    board_id = header >> 8;
	    return_value = dsp_get_reply((DSP_ATTR *) dsp, board_id, 
		DSP_ACTUAL_VALUE, DEFAULT_TIMEOUT);
	  }
	  else {
	    message_popup(Direct_dsp->direct_dsp_popup, MESSAGE,
		"You must specify arg1.",
	    NULL);
	    send_busy(FALSE);
	    return -1;
	  }
	}
	else {
	  if (arg2 == UNDEFINED) {
	    send_command((DSP_ATTR *) dsp, header, command, arg1, DSP_END);
	    board_id = header >> 8;
	    return_value = dsp_get_reply((DSP_ATTR *) dsp, board_id,
		DSP_ACTUAL_VALUE, DEFAULT_TIMEOUT);
	  }
	  else {
	    send_command((DSP_ATTR *) dsp, header, command, arg1, arg2, DSP_END);
	    board_id = header >>  8;
	    return_value = dsp_get_reply((DSP_ATTR *) dsp, board_id,
		DSP_ACTUAL_VALUE, DEFAULT_TIMEOUT);
	  }
	}
	 switch (return_value)
        {
                case DSP_ERROR:
                        write_frame(Direct_dsp->direct_dsp_popup,
                                FRAME_LEFT_FOOTER, "Reply: ERR");
                        break;
                case DSP_OK:
                        write_frame(Direct_dsp->direct_dsp_popup,
                                FRAME_LEFT_FOOTER, "Reply: DON");
                        break;
                case DSP_NO_EXPECTED_REPLY:
                        write_frame(Direct_dsp->direct_dsp_popup,
                                FRAME_LEFT_FOOTER,
                                "Reply: None Expected");
                        break;
                default:
                        sprintf(string, "Returned value:  %06x",
                                        return_value);
                        write_frame(Direct_dsp->direct_dsp_popup,
                                FRAME_LEFT_FOOTER, string);
        }
        send_busy(FALSE);
}



#ifdef	SBUSTOOL
/* These functions are for use with the SBUS board version */
#ifdef	__STDC__
void change_sbus_command(int value)
#else	/* K&R C */
void
change_sbus_command(value)
int	value;
#endif	/* __STDC__ */
{
	int	command;

	command = panel2sbus_command(value);
	set_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_COMMAND,
		command, NULL);
	update_direct_dsp_panel(ccd_obj->direct_dsp_obj, DSP_COMMAND);
}


#ifdef	__STDC__
int panel2sbus_command(int value)
#else	/* K&R C */
int
panel2sbus_command(value)
int	value;
#endif	/* __STDC__ */
{
	switch (value)
	{
		case -1:  /* NO_COMMAND */
			return(NO_COMMAND);
		case 0:  /* CSR */
			return(CSR);
		case 1:  /* ADR */
			return(ADR);
		case 2:  /* BCR */
			return(BCR);
		case 3:	 /* Reset */
			return(Reset);
		default:
			return(NO_COMMAND);
	}
}


#ifdef	__STDC__
int panel2board(int value)
#else	/* K&R C */
int
panel2board(value)
int	value;
#endif	/* __STDC__ */
{
        switch (value)
	{
                case 0:  /* SBUS */
			return(SBUS_ID);
                case 1:  /* Timing */
			return(TIM_ID);
                case 2:  /* Utility */
			return(UTIL_ID);
		case 3:  /* MANUAL */
			return(MANUAL);
		default:
			return(-1);
        }
}


#ifdef	__STDC__
int sbus_command2panel(int command)
#else	/* K&R C */
int
sbus_command2panel(command)
int	command;
#endif	/* __STDC__ */
{
	switch (command)
	{
		case NO_COMMAND:
			return -1;
		case CSR:
			return 0;
		case ADR:
			return 1;
		case BCR:
			return 2;
		case Reset:
			return 3;
		default:
			return -1;
	}
}


#else	/* VMETOOL */
/* These functions are for use in the VME version only */
#ifdef	__STDC__
void change_vme_command(int value)
#else	/* K&R C */
void
change_vme_command(value)
int	value;
#endif	/* __STDC__ */
{
	int	command;

	command = panel2vme_command(value);
	set_direct_dsp_value(ccd_obj->direct_dsp_obj, DSP_COMMAND,
		command, NULL);
	update_direct_dsp_panel(ccd_obj->direct_dsp_obj, DSP_COMMAND);
}


#ifdef	__STDC__
int panel2vme_command(int value)
#else	/* K&R C */
int
panel2vme_command(value)
int	value;
#endif	/* __STDC__ */
{
	switch (value)
	{
		case -1:  /* NO_COMMAND */
			return(NO_COMMAND);
		case 0:  /* ABR */
			return(ABR);
		case 1:  /* IRQ */
			return(IRQ);
		case 2:  /* SRA */
			return(SRA);
		case 3:	 /* Boot */
			return(Boot);
		default:
			return(NO_COMMAND);
	}
}


#ifdef	__STDC__
int vme_command2panel(int command)
#else	/* K&R C */
int
vme_command2panel(command)
int	command;
#endif	/* __STDC__ */
{
	switch (command)
	{
		case NO_COMMAND:
			return -1;
		case ABR:
			return 0;
		case IRQ:
			return 1;
		case SRA:
			return 2;
		case Boot:
			return 3;
		default:
			return -1;
	}
}

#endif	/* SBUSTOOL */
#ifdef  __STDC__
int send_busy(int value)
#else   /* K&R C */
int
send_busy(value )
int     value;
#endif  /* __STDC__ */
{
        ccdtool_busy(value);
 
        if (value) {
                xv_set(Direct_dsp->send_command_button, XV_SHOW, FALSE, NULL);
                xv_set(Direct_dsp->abort_button, XV_SHOW, TRUE, NULL);
        }
        else {
                xv_set(Direct_dsp->abort_button, XV_SHOW, FALSE, NULL);
                xv_set(Direct_dsp->send_command_button, XV_SHOW, TRUE, NULL);
        }
        dsp_set(ccd_obj->dsp_obj, DSP_ABORT, FALSE, NULL);
}

#ifdef	__STDC__
int abort_send(void)
#else	/* K&R C */
int
abort_send()
#endif	/* __STDC__ */
{

#       ifdef   SBUSTOOL
        send_reset(ccd_obj->dsp_obj);
#       endif   /* SBUSTOOL */
        dsp_set(ccd_obj->dsp_obj, DSP_ABORT, TRUE, NULL);
        ccd_obj->next_func_ptr = NULL;
}
 


/*
 * $Log: direct_dsp.c,v $
 * Revision 1.12  1996/02/05  18:26:24  gumrukcu
 * send_busy(FALSE) call is added to several palces in send_direct_dsp_command
 * function.
 *
 * Revision 1.11  1996/02/05  00:50:20  gumrukcu
 * Change in send_busy
 *
 * Revision 1.10  1996/02/05  00:26:37  gumrukcu
 * A change is made in send_busy function.
 *
 * Revision 1.9  1996/02/04  00:59:04  gumrukcu
 * The abort button is activated, or a callback is added for the abort button.
 *
 * Revision 1.8  1996/01/29  22:33:39  gumrukcu
 * Some changes in SBUS commands.
 *
 * Revision 1.7  1996/01/04  19:42:46  gumrukcu
 * test again on dsp_command.
 *
 * Revision 1.6  1996/01/03 20:21:07  gumrukcu
 * SEX has been corrected.
 *
 * Revision 1.5  1995/12/12  22:33:28  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.4  1995/08/30  20:02:50  tjk
 * Corrected K&R function headers...
 *
 * Revision 1.3  1995/08/21  18:42:10  tjk
 * converting to ANSI C standard
 *
 * Revision 1.2  1995/08/10  16:53:26  tjk
 * Changes for IRTOOL.
 *
 * Revision 1.1  1995/02/10  03:53:31  tjk
 * Initial revision
 *
 *
 */
