/* $Header: /rosie/src/ccd_utilities/tool/RCS/direct_dsp_panel.c,v 1.12 1996/02/05 20:45:11 gumrukcu Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "direct_dsp.h"
#include "ccd.h"

#ifdef	__STDC__
int update_direct_dsp_panel(DIRECT_DSP_OBJ *obj, int modifier);
void update_direct_dsp_board(DIRECT_DSP_OBJ *obj);
void update_direct_dsp_command(DIRECT_DSP_OBJ *obj);
direct_dsp_opaque get_direct_dsp_panel_value(...);
void set_manual_command(int flag);

#else	/* K&R C */
int update_direct_dsp_panel();
void update_direct_dsp_board();
void update_direct_dsp_command();
direct_dsp_opaque get_direct_dsp_panel_value();
void set_manual_command();

#endif	/* __STDC__ */


int previous_command = NO_COMMAND;
int previous_board = NO_BOARD;
int ACTIVE = FALSE;

#ifdef	__STDC__
int update_direct_dsp_panel(DIRECT_DSP_OBJ *obj, int modifier)
#else  /* K&R C */
int
update_direct_dsp_panel(obj, modifier)
DIRECT_DSP_OBJ	*obj;
int		modifier;
#endif	/* __STDC__ */
{
#ifdef SBUSTOOL
	if (obj->command == NO_COMMAND && obj->board == SBUS_ID)
	  obj->command = previous_command;
#else /* VMETOOL */
	if (obj->command == NO_COMMAND && obj->board == VME_ID)
	  obj->command = previous_command;
#endif /* SBUSTOOL */
        if (obj->board == MANUAL)
          obj->command = NO_COMMAND;

	if (modifier == DSP_BOARD) {
	  update_direct_dsp_board(obj);
	  if (obj->board != MANUAL)
	    update_direct_dsp_command(obj);
	}
	else if (modifier == DSP_COMMAND) {
	       update_direct_dsp_command(obj);
	}
#ifdef SBUSTOOL
	if(obj->command != CSR && obj->command != ADR && obj->command != BCR
        && obj->command != Reset)
		previous_command = obj->command;

#else /* VMETOOL */
	if(obj->command != ABR && obj->command != IRQ && obj->command !=SRA 
        && obj->command != Boot)
		previous_command = obj->command;
#endif /* SBUSTOOL */
}


#ifdef	__STDC__
void update_direct_dsp_board(DIRECT_DSP_OBJ *obj)
#else  /* K&R C */
void
update_direct_dsp_board(obj)
DIRECT_DSP_OBJ	*obj;
#endif	/* __STDC__ */
{
	switch (obj->board) {
           	case SBUS_ID:
			if(previous_command == NO_COMMAND)
				ACTIVE = FALSE;
			else
				ACTIVE = TRUE;
                        xv_set(Direct_dsp->timing_command_setting, XV_SHOW,
				FALSE, NULL);
                        xv_set(Direct_dsp->utility_command_setting, XV_SHOW,
				FALSE, NULL);
			xv_set(Direct_dsp->boot_command_setting,
                                PANEL_INACTIVE,TRUE,NULL);
                        xv_set(Direct_dsp->sbus_command_setting,
                                PANEL_CHOOSE_NONE, TRUE,
                                PANEL_VALUE, -1,
                                XV_SHOW, TRUE, NULL);
                        break;
		
		case TIM_ID:	
                        xv_set(Direct_dsp->sbus_command_setting, XV_SHOW,
				FALSE, NULL);
			xv_set(Direct_dsp->boot_command_setting, 
                                PANEL_INACTIVE,FALSE,NULL);
                        xv_set(Direct_dsp->utility_command_setting, XV_SHOW,
				FALSE, NULL);
                        xv_set(Direct_dsp->timing_command_setting,
                                PANEL_CHOOSE_NONE, TRUE,
                                PANEL_VALUE, -1,
                                XV_SHOW, TRUE, NULL);
                        break;
		case UTIL_ID:
                        xv_set(Direct_dsp->sbus_command_setting, XV_SHOW,
				FALSE, NULL);
 			xv_set(Direct_dsp->boot_command_setting, 
                                PANEL_INACTIVE,FALSE,NULL);
                        xv_set(Direct_dsp->timing_command_setting, XV_SHOW,
				FALSE, NULL);
                        xv_set(Direct_dsp->utility_command_setting,
                                PANEL_CHOOSE_NONE, TRUE,
                                PANEL_VALUE, -1,
                                XV_SHOW, TRUE, NULL);
                        break;
		case MANUAL:
                        xv_set(Direct_dsp->sbus_command_setting, XV_SHOW, 
                                FALSE, PANEL_VALUE, -1, NULL);
                        xv_set(Direct_dsp->boot_command_setting, XV_SHOW, 
				FALSE,  PANEL_VALUE, -1,NULL);
                        xv_set(Direct_dsp->timing_command_setting, XV_SHOW, 
				FALSE,  PANEL_VALUE, -1,NULL);
                        xv_set(Direct_dsp->utility_command_setting, XV_SHOW, 
				FALSE,  PANEL_VALUE, -1,NULL);
                        xv_set(Direct_dsp->data_text, PANEL_LABEL_STRING,
				"Command",PANEL_INACTIVE,FALSE, NULL); 
                        xv_set(Direct_dsp->mem_space_setting, XV_SHOW,FALSE,NULL); 
                        xv_set(Direct_dsp->address_text,PANEL_LABEL_STRING,
				"Header",PANEL_INACTIVE,FALSE,NULL);
			set_manual_command(TRUE);
			previous_board=MANUAL;
                        break;

        }
               if ((previous_board == MANUAL) && (obj->board != MANUAL)) {

                 xv_set(Direct_dsp->boot_command_setting, XV_SHOW, TRUE, NULL);
                 set_manual_command(FALSE);
		 xv_set(Direct_dsp->data_text, PANEL_LABEL_STRING,
			 "Data", PANEL_INACTIVE, TRUE, NULL);
                 xv_set(Direct_dsp->mem_space_setting, XV_SHOW, TRUE,
			 PANEL_INACTIVE, TRUE, NULL);
                 xv_set(Direct_dsp->address_text,PANEL_LABEL_STRING ,
			"Address", PANEL_INACTIVE, TRUE, NULL);
		 previous_board=NO_BOARD;
               }


	switch (obj->command) {
		case LDA:
		case RDM:
		case RST:
		case TDL:
		case WRM:
#ifdef SBUSTOOL
		case CSR:
		case ADR:
		case BCR:
		case Reset:
#else /* VMETOOL */
		case ABR:
		case IRQ:
		case SRA:
		case Boot:
#endif /* SBUSTOOL */
			break;
		default:
			obj->command = NO_COMMAND;
	}
}


#ifdef	__STDC__
void update_direct_dsp_command(DIRECT_DSP_OBJ *obj)
#else  /* K&R C */
void
update_direct_dsp_command(obj)
DIRECT_DSP_OBJ	*obj;
#endif	/* __STDC__ */
{
	if (obj->command == NO_COMMAND) {
		xv_set(Direct_dsp->send_command_button, PANEL_INACTIVE,
			TRUE, NULL);
	}
	else {
		xv_set(Direct_dsp->send_command_button, PANEL_INACTIVE,
			FALSE, NULL);
	}
start:
	switch (obj->command) {
		case LDA:
		case RDM:
		case RST:
		case TDL:
		case WRM:
		        xv_set(Direct_dsp->sbus_command_setting,
				PANEL_VALUE, -1, NULL);
        		xv_set(Direct_dsp->timing_command_setting,
				PANEL_VALUE, -1, NULL);
        		xv_set(Direct_dsp->utility_command_setting,
				PANEL_VALUE, -1, NULL);
			break;

		case CSR:
		case ADR:
		case BCR:
		case Reset:
		if(obj->board == SBUS_ID)
		{
			xv_set(Direct_dsp->boot_command_setting,
				PANEL_INACTIVE, TRUE, NULL);
			xv_set(Direct_dsp->timing_command_setting,
				PANEL_VALUE, -1, NULL);
			xv_set(Direct_dsp->utility_command_setting,
				PANEL_VALUE, -1, NULL);
		}
		else
		{
			obj->command = previous_command;	
			goto start;
		}
			break;

		case CLR:
		case HGN:
		case IDL:
		case LGN:
		case RAD:
		case RDC:
		case SBV:
		case STP:
			xv_set(Direct_dsp->sbus_command_setting,
				PANEL_VALUE, -1, NULL);
			xv_set(Direct_dsp->boot_command_setting,
				PANEL_VALUE, -1, NULL);
			xv_set(Direct_dsp->utility_command_setting,
				PANEL_VALUE, -1, NULL);
			break;
		case AEX:
		case CSH:
		case OSH:
		case PEX:
		case PON:
		case REX:
		case SEX:
		case SYR:
			xv_set(Direct_dsp->sbus_command_setting,
				PANEL_VALUE, -1, NULL);
			xv_set(Direct_dsp->timing_command_setting,
				PANEL_VALUE, -1, NULL);
			xv_set(Direct_dsp->boot_command_setting,
				PANEL_VALUE, -1, NULL);
			break;
	}

	switch (obj->command) {
		case LDA:
		case TDL:
                        xv_set(Direct_dsp->data_text, PANEL_INACTIVE,
				FALSE, NULL);
			xv_set(Direct_dsp->mem_space_setting,
				PANEL_INACTIVE, TRUE, NULL);
			xv_set(Direct_dsp->address_text, PANEL_INACTIVE,
				TRUE, NULL);
			break;
		case RDM:
                        xv_set(Direct_dsp->data_text, PANEL_INACTIVE,
				TRUE, NULL);
                        xv_set(Direct_dsp->mem_space_setting, PANEL_INACTIVE,
				FALSE, NULL);
                        xv_set(Direct_dsp->address_text, PANEL_INACTIVE,
				FALSE, NULL);
			break;
		case WRM:
                        xv_set(Direct_dsp->mem_space_setting, PANEL_INACTIVE,
				FALSE, NULL);
                        xv_set(Direct_dsp->address_text, PANEL_INACTIVE,
				FALSE, NULL);
                        xv_set(Direct_dsp->data_text, PANEL_INACTIVE,
				FALSE, NULL);
			break;
		default:
			xv_set(Direct_dsp->mem_space_setting, PANEL_INACTIVE,
				TRUE, NULL);
			xv_set(Direct_dsp->address_text, PANEL_INACTIVE,
				TRUE, NULL);
			xv_set(Direct_dsp->data_text, PANEL_INACTIVE,
				TRUE, NULL);
	}
	if(obj->board == SBUS_ID) 
	{	
			xv_set(Direct_dsp->mem_space_setting, PANEL_INACTIVE,
				TRUE, NULL);
			xv_set(Direct_dsp->address_text, PANEL_INACTIVE,
				TRUE, NULL);
			xv_set(Direct_dsp->data_text, PANEL_INACTIVE,
				TRUE, NULL);
	
	if(obj->command != CSR && obj->command != ADR && obj->command != BCR
        && obj->command != Reset)
			xv_set(Direct_dsp->send_command_button, PANEL_INACTIVE,
			TRUE, NULL);
	else
			xv_set(Direct_dsp->send_command_button, PANEL_INACTIVE,
			FALSE, NULL);
	}

	if(obj->board == TIM_ID || obj->board == UTIL_ID)
	{
        	if(ACTIVE == FALSE)
        	{
                	xv_set(Direct_dsp->send_command_button, PANEL_INACTIVE,
                        TRUE, NULL);
			ACTIVE = TRUE;
        	}
	}

}


#ifdef	__STDC__
direct_dsp_opaque get_direct_dsp_panel_value(...)
#else  /* K&R C */
direct_dsp_opaque
get_direct_dsp_panel_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	DIRECT_DSP_OBJ	*obj;
	int		modifier;
	int		int_value;
	char		char_value;
	char		*char_ptr;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	obj = va_arg(ap, DIRECT_DSP_OBJ *);
	modifier = va_arg(ap, int);

	switch (modifier) {
		case DSP_BOARD:
			printf("not implemented at this time.\n");
			break;
		case DSP_COMMAND:
			printf("not implemented at this time.\n");
			break;
		case DSP_MEM_SPACE:
			int_value = (int)xv_get(Direct_dsp->mem_space_setting,
				PANEL_VALUE);
			return (direct_dsp_opaque)panel2mem_space(int_value);
		case DSP_DATA:
			char_ptr = (char *)xv_get(Direct_dsp->data_text,
				PANEL_VALUE);
			return (direct_dsp_opaque)char2hex(char_ptr);
		case DSP_ADDRESS:
			char_ptr = (char *)xv_get(Direct_dsp->address_text,
				PANEL_VALUE);
			return (direct_dsp_opaque)char2hex(char_ptr);
		case DSP_ARG1_FIELD:
			char_ptr = (char *)xv_get(Direct_dsp->arg1_field,
                                PANEL_VALUE);
                        return (direct_dsp_opaque)char2hex(char_ptr);
                case DSP_ARG2_FIELD:
                        char_ptr = (char *)xv_get(Direct_dsp->arg2_field,
                                PANEL_VALUE);
                        return (direct_dsp_opaque)char2hex(char_ptr);
		default:
			printf("ERROR in get_direct_dsp_panel_value(): %d\n",
				modifier);
	}
}

#ifdef __STDC__
void set_manual_command(int flag)
#else /* K&R C */
void set_manual_command(flag)
int flag;
#endif /* __STDC__ */
{
  xv_set(Direct_dsp->arg1_field,XV_SHOW,flag,NULL);
  xv_set(Direct_dsp->arg2_field,XV_SHOW,flag,NULL);
  /*
  xv_set(Direct_dsp->argument3_field,XV_SHOW,flag,NULL);
  xv_set(Direct_dsp->argument4_field,XV_SHOW,flag,NULL);
  xv_set(Direct_dsp->argument5_field,XV_SHOW,flag,NULL);
  */
  xv_set(Direct_dsp->send_command_button, PANEL_INACTIVE,
                        FALSE, NULL);

}

/*
 * $Log: direct_dsp_panel.c,v $
 * Revision 1.12  1996/02/05  20:45:11  gumrukcu
 * Some changes in update_direct_dsp_command. When you click on SBUS or
 * VME button and after that send a command to the SBUS or VME then return
 * back to the UTILITY or TIMING boards, although there is no command send
 * in the previous session to either boards the sned command was active. This
 * is fixed.
 * /
 *
 * Revision 1.11  1996/01/28  00:37:12  gumrukcu
 * Some changes for the VME command settings.
 *
 * Revision 1.10  1996/01/26  22:20:10  gumrukcu
 * The same as the previous version. The dsp window is changed for
 * the VMETOOL exactly like the SBUSTOOL.
 *
 * Revision 1.8  1996/01/19  19:27:09  gumrukcu
 * When you click on for instance RDM for timing board and then inactivate
 * the RDM command, shortly when timing or utility board is chosen when RDM
 * is clicked on twice, send command and Addrees buttons were still active
 * even though there are not any commands at this point. This bug is fixed.
 *
 * Revision 1.7  1996/01/19  01:40:27  gumrukcu
 * Some changes in the update of the panels.
 *
 * Revision 1.6  1996/01/18  19:13:24  gumrukcu
 * The Memory space,Address and Data settings are made always inactive
 * whenever the SBUS button on the Board panel is pressed on.
 *
 * Revision 1.5  1995/12/27  23:39:09  gumrukcu
 * The update of boot command setting was not included. It is included
 * in this version.
 *
 * Revision 1.5  1995/12/27  23:39:09  gumrukcu
 * The update of boot command setting was not included. It is included
 * in this version.
 *
 * Revision 1.4  1995/12/12  22:33:29  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.3  1995/08/21  18:42:11  tjk
 * converting to ANSI C standard
 *
 * Revision 1.2  1995/08/01  16:26:15  tjk
 * Added commands for irtool.
 *
 * Revision 1.1  1995/02/10  03:54:29  tjk
 * Initial revision
 *
 *
 */
