/* $Header: /rosie/src/ccd_utilities/tool/RCS/expctl_data.c,v 1.16 1997/01/03 22:25:03 gumrukcu Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"

struct {
	int	tag;
	char	*string;
} expctlios[] = {
	{ DO_DUAL_IMAGE,	"doDualImage" },
	{ DO_READOUT_CCD, 	"doReadoutCCD" },
	{ DO_SAVE_IMAGE, 	"doSaveImage" },
	{ DO_BEEP,		"doBeep" },
	{ DO_DISPLAY_IMAGE, 	"doDisplayImage" },
	{ DO_AUTO_INCREMENT, 	"doAutoIncrement" },
	{ EXPOSURE_TIME, 	"exposureTime" },
	{ IMAGE_DIRECTORY, 	"imageDirectory" },
	{ IMAGE_FILENAME, 	"imageFilename" },
};

/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void		init_expctl_defaults(EXPCTL_OBJ *expctl);
int		set_expctl_value(...);
expctl_opaque	get_expctl_value(EXPCTL_OBJ *obj, EXPCTL_TAGS expctl_item);
int		download_gfm_proc();

extern char	*getcwd();

#else	/* K&R C */
void		init_expctl_defaults();
int		set_expctl_value();
expctl_opaque	get_expctl_value();
int		download_gfm_proc();

extern char	*getwd();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/

char		*expctl_io_strings[NUM_EXPCTL_TAGS];

#ifdef	__STDC__
void init_expctl_defaults(EXPCTL_OBJ *expctl)
#else	/* K&R C */
void
init_expctl_defaults(expctl)
EXPCTL_OBJ       *expctl;
#endif	/* __STDC__ */
{
	int	i, j;
	char	cwd[256];

#ifdef	__STDC__
	getcwd(cwd, 255);
#else	/* K&R C */
	getwd(cwd);
#endif	/* __STDC__ */
        set_expctl_value(expctl,
		DO_DUAL_IMAGE, DEFAULT_DO_DUAL_IMAGE,
		DO_READOUT_CCD, DEFAULT_DO_READOUT_CCD,
		DO_SAVE_IMAGE, DEFAULT_DO_SAVE_IMAGE,
		DO_BEEP, DEFAULT_DO_BEEP,
		DO_DISPLAY_IMAGE, DEFAULT_DO_DISPLAY_IMAGE,
		DO_AUTO_INCREMENT, DEFAULT_DO_AUTO_INCREMENT,
		EXPOSURE_TIME, DEFAULT_EXPOSURE_TIME,
		IMAGE_DIRECTORY, cwd,
		IMAGE_FILENAME, DEFAULT_IMAGE_FILENAME,
	0);
	free(cwd);

	for (i=0; i<NUM_EXPCTL_TAGS; i++) {
		for (j=0; j<NUM_EXPCTL_STRINGS; j++) {
			if (expctlios[j].tag == i)
				expctl_io_strings[i] = expctlios[j].string;
		}
	}
}


#ifdef	__STDC__
int set_expctl_value(...)
#else	/* K&R C */
int
set_expctl_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	EXPCTL_OBJ	*expctl;
	int		modifier;
	int		int_value;
	char		*char_value;
	mydb_opaque	*db;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	expctl = va_arg(ap, EXPCTL_OBJ *);
	modifier = va_arg(ap, int);
	while (modifier != 0)
	{
		switch (modifier)
		{
			case EXPCTL_DB:
				db = va_arg(ap, mydb_opaque *);
				if (expctl->db != NULL)
				{
					mydb_free(expctl->db);
				}
				expctl->db = db;
				break;
			case DO_DUAL_IMAGE:
				expctl->do_dual_image = va_arg(ap, int);
				break;
			case DO_READOUT_CCD:
				expctl->do_readout_ccd = va_arg(ap, int);
				break;
			case DO_SAVE_IMAGE:
				expctl->do_save = va_arg(ap, int);
				break;
			case DO_BEEP:
				expctl->do_beep = va_arg(ap, int);
				break;
			case DO_DISPLAY_IMAGE:
				expctl->do_display = va_arg(ap, int);
				break;
			case DO_AUTO_INCREMENT:
				expctl->do_auto_increment = va_arg(ap, int);
				break;
			case EXPOSURE_TIME:
				expctl->exposure_time = va_arg(ap, int);
				break;
			case IMAGE_DIRECTORY:
				/*if (expctl->directory != NULL)
					free(expctl->directory);*/
				expctl->directory = strdup(va_arg(ap, char *));
				break;
			case IMAGE_FILENAME:
				/*if (expctl->filename != NULL)
					free(expctl->filename);*/
				expctl->filename = strdup(va_arg(ap, char *));
				break;
			default:
				printf("bad set_setup_value\n");
		}

		modifier = va_arg(ap, int);
	}
}


#ifdef	__STDC__
expctl_opaque	get_expctl_value(EXPCTL_OBJ *obj, EXPCTL_TAGS expctl_item)
#else	/* K&R C */
expctl_opaque	
get_expctl_value(obj, expctl_item)
EXPCTL_OBJ	*obj;
EXPCTL_TAGS	expctl_item;
#endif	/* __STDC__ */
{
	switch (expctl_item)
	{
		case EXPCTL_DB:
			return (expctl_opaque)obj->db;
                case DO_DUAL_IMAGE:
			return (expctl_opaque)obj->do_dual_image;
                case DO_READOUT_CCD:
			return (expctl_opaque)obj->do_readout_ccd;
                case DO_SAVE_IMAGE:
			return (expctl_opaque)obj->do_save;
		case DO_BEEP:
			return (expctl_opaque)obj->do_beep;
                case DO_DISPLAY_IMAGE:
			return (expctl_opaque)obj->do_display;
                case DO_AUTO_INCREMENT:
			return (expctl_opaque)obj->do_auto_increment;
                case EXPOSURE_TIME:
			return (expctl_opaque)obj->exposure_time;
                case IMAGE_DIRECTORY:
			return (expctl_opaque)obj->directory;
                case IMAGE_FILENAME:
			return (expctl_opaque)obj->filename;
	}
}



/*
 * $Log: expctl_data.c,v $
 * Revision 1.16  1997/01/03 22:25:03  gumrukcu
 * ***ABDUL***
 * adding display function.
 *
 * Revision 1.15  1996/11/25 21:19:15  peker
 * Added new options, and cleared some buggs.
 *
 * Revision 1.14  1996/01/05  20:57:44  gumrukcu
 * Printf's for debugging purposes are cleared.
 *
 * Revision 1.13  1996/01/04 22:50:56  gumrukcu
 * test8 for seg fault.
 *
 * Revision 1.11  1996/01/04 22:33:19  gumrukcu
 * test6 for seg. fault.
 *
 * Revision 1.4  1996/01/03 01:09:29  gumrukcu
 * Some additions were made for N_setting.
 *
 * Revision 1.3  1995/12/12  22:33:31  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.2  1995/08/21  18:42:12  tjk
 * converting to ANSI C standard
 *
 * Revision 1.1  1995/02/10  03:56:44  tjk
 * Initial revision
 *
 *
 */
