/* $Header: /rosie/src/ccd_utilities/tool/RCS/expctl_io.c,v 1.5 1997/01/03 22:25:27 gumrukcu Exp $
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "expctl_io.h"
#include "gfm.h"
#include "conversion.h"


/*>>>>>  Function Prototypes  <<<<<*/
#ifdef	__STDC__
void	extract_expctl_setup(mydb_opaque *db);
int	extract_expctl_setup_value(EXPCTL_TAGS expctl_item, char *value);
#else	/* K&R C */
void	extract_expctl_setup();
int	extract_expctl_setup_value();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/

#ifdef	__STDC__
void extract_expctl_setup(mydb_opaque *db)
#else	/* K&R C */
void
extract_expctl_setup(db)
mydb_opaque     *db;
#endif	/* __STDC__ */
{
        EXPCTL_TAGS	expctl_item;
        char            *value;

        mydb_set(db, MYDB_RESOURCE_TYPE, EXPCTL_SETUP_RESOURCE);

        for (expctl_item=DO_DUAL_IMAGE;
	     expctl_item <= IMAGE_FILENAME;
	     expctl_item++)
	{
                value = (char *)mydb_get(db, MYDB_ATTRIBUTE,
					 expctl_io_strings[expctl_item]);
                if (value != NULL)
		{
                        extract_expctl_setup_value(expctl_item, value);
                }
        }
        reset_expctl_panel(ccd_obj->expctl_obj);
}



#ifdef	__STDC__
int extract_expctl_setup_value(EXPCTL_TAGS expctl_item, char *value)
#else	/* K&R C */
int
extract_expctl_setup_value(expctl_item, value)
EXPCTL_TAGS	expctl_item;
char		*value;
#endif	/* __STDC__ */
{
	int	int_value;

	switch (expctl_item) {
		case DO_DUAL_IMAGE:
		case DO_READOUT_CCD:
		case DO_SAVE_IMAGE:
		case DO_BEEP:
		case DO_DISPLAY_IMAGE:
		case DO_AUTO_INCREMENT:
			int_value = char2boolean(value);
			set_expctl_value(ccd_obj->expctl_obj, expctl_item, int_value, NULL);
			break;
		case EXPOSURE_TIME:
			int_value = char2int(value);
			set_expctl_value(ccd_obj->expctl_obj, expctl_item, int_value, NULL);
			break;
		case IMAGE_DIRECTORY:
		case IMAGE_FILENAME:
			set_expctl_value(ccd_obj->expctl_obj, expctl_item, value, NULL);
			break;
		default:
			message_write("extract_expctl_setup_value_error\n");
	}
}


/*
 * $Log: expctl_io.c,v $
 * Revision 1.5  1997/01/03 22:25:27  gumrukcu
 * ***ABDUL***
 * adding display function.
 *
 * Revision 1.4  1996/11/25 21:19:15  peker
 * Added new options, and cleared some buggs.
 *
 * Revision 1.3  1995/12/12  22:33:32  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.2  1995/08/21  18:42:13  tjk
 * converting to ANSI C standard
 *
 * Revision 1.1  1995/02/10  03:57:08  tjk
 * Initial revision
 *
 *
 */
