/* $Header: /rosie/src/ccd_utilities/tool/RCS/expctl_panel.c,v 1.6 1997/01/03 22:25:58 gumrukcu Exp $
 */

#include <stdio.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"
#include "expctl.h"
#include "conversion.h"

/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void set_expctl_panel(...);
void store_expctl_settings(EXPCTL_OBJ *expctl);
void reset_expctl_panel(EXPCTL_OBJ *expctl);

#else	/* K&R C */
void set_expctl_panel();
void store_expctl_settings();
void reset_expctl_panel();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/


#ifdef	__STDC__
void set_expctl_panel(...)
#else	/* K&R C */
void
set_expctl_panel(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	EXPCTL_OBJ	*expctl;
	int		modifier;
	int		value;
	char		buffer[255];

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */
	expctl = va_arg(ap, EXPCTL_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL) {
		switch (modifier) {
			case DO_DUAL_IMAGE:
				xv_set(Expctl->do_dual_image, PANEL_VALUE,
					va_arg(ap, int), NULL);
				break;
			case DO_READOUT_CCD:
				xv_set(Expctl->do_readout_ccd, PANEL_VALUE,
					va_arg(ap, int), NULL);
				break;
			case DO_SAVE_IMAGE:
				xv_set(Expctl->do_save, PANEL_VALUE,
					va_arg(ap, int), NULL);
				break;
			case DO_BEEP:
				xv_set(Expctl->do_beep, PANEL_VALUE,
					va_arg(ap, int), NULL);
				break;	
			case DO_DISPLAY_IMAGE:
				xv_set(Expctl->do_display, PANEL_VALUE,
					va_arg(ap, int), NULL);
				break;
			case DO_AUTO_INCREMENT:
				xv_set(Expctl->auto_increment_setting,
					PANEL_VALUE, va_arg(ap, int), NULL);
				break;
			case EXPOSURE_TIME:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Expctl->exposure_time_setting,
						PANEL_VALUE, "", NULL);
				else
				{
					sprintf(buffer, "%10.3f", value/1000.0);
					xv_set(Expctl->exposure_time_setting,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case IMAGE_DIRECTORY:
				xv_set(Expctl->directory_field, PANEL_VALUE,
					va_arg(ap, char *), NULL);
				break;
			case IMAGE_FILENAME:
				xv_set(Expctl->filename_field, PANEL_VALUE,
					va_arg(ap, char *), NULL);
				break;
			default:
				printf("ERROR:  set_expctl_panel(): %d\n",
					modifier);
		}

		modifier = va_arg(ap, int);

	}
}


#ifdef	__STDC__
void store_expctl_settings(EXPCTL_OBJ *expctl)
#else	/* K&R C */
void
store_expctl_settings(expctl)
EXPCTL_OBJ	*expctl;
#endif	/* __STDC__ */
{

	int	value, i;
	char	*buffer;
	double 	exp_time;

	exp_time = (double)char2float((char *)xv_get(Expctl->exposure_time_setting, PANEL_VALUE));
	
	set_expctl_value(expctl,
		DO_DUAL_IMAGE, (int)xv_get(Expctl->do_dual_image, PANEL_VALUE),
		DO_READOUT_CCD, (int)xv_get(Expctl->do_readout_ccd, PANEL_VALUE),
		DO_SAVE_IMAGE, (int)xv_get(Expctl->do_save, PANEL_VALUE),
		DO_BEEP, (int)xv_get(Expctl->do_beep, PANEL_VALUE),
		DO_DISPLAY_IMAGE, (int)xv_get(Expctl->do_display, PANEL_VALUE),
		DO_AUTO_INCREMENT, (int)xv_get(Expctl->auto_increment_setting, PANEL_VALUE),
#if 0
		EXPOSURE_TIME, char2int((char *)xv_get(Expctl->exposure_time_setting, PANEL_VALUE)),
		EXPOSURE_TIME, (double)char2float((char *)xv_get(Expctl->exposure_time_setting, PANEL_VALUE)),
#endif
		EXPOSURE_TIME, (int)(exp_time*1000.0),
		IMAGE_DIRECTORY, (char *)xv_get(Expctl->directory_field, PANEL_VALUE),
		IMAGE_FILENAME, (char *)xv_get(Expctl->filename_field, PANEL_VALUE),
	NULL);
}


#ifdef	__STDC__
void reset_expctl_panel(EXPCTL_OBJ *expctl)
#else	/* K&R C */
void
reset_expctl_panel(expctl)
EXPCTL_OBJ	*expctl;
#endif	/* __STDC__ */
{
	char	buffer[255];
	int	setting;

	set_expctl_panel(expctl,
		DO_DUAL_IMAGE, (int)get_expctl_value(expctl, DO_DUAL_IMAGE),
		DO_READOUT_CCD, (int)get_expctl_value(expctl, DO_READOUT_CCD),
		DO_SAVE_IMAGE, (int)get_expctl_value(expctl, DO_SAVE_IMAGE),
		DO_BEEP, (int)get_expctl_value(expctl, DO_BEEP),
		DO_DISPLAY_IMAGE, (int)get_expctl_value(expctl, DO_DISPLAY_IMAGE),
		DO_AUTO_INCREMENT, (int)get_expctl_value(expctl, DO_AUTO_INCREMENT),
		EXPOSURE_TIME, (int)get_expctl_value(expctl, EXPOSURE_TIME),
		IMAGE_DIRECTORY, (char *)get_expctl_value(expctl, IMAGE_DIRECTORY),
		IMAGE_FILENAME, (char *)get_expctl_value(expctl, IMAGE_FILENAME),
	NULL);
}

/*
 * $Log: expctl_panel.c,v $
 * Revision 1.6  1997/01/03 22:25:58  gumrukcu
 * ***ABDUL***
 * adding display function.
 *
 * Revision 1.5  1996/11/25 21:19:15  peker
 * Added new options, and cleared some buggs.
 *
 * Revision 1.4  1996/01/03  01:10:29  gumrukcu
 *  Some additions were made for N_setting.
 *
 * Revision 1.3  1995/12/12  22:33:32  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.2  1995/08/21  18:42:13  tjk
 * converting to ANSI C standard
 *
 * Revision 1.1  1995/02/10  03:57:33  tjk
 * Initial revision
 *
 *
 */
