/* $Header: /rosie/src/ccd_utilities/tool/RCS/initialize.c,v 1.23 1996/03/08 23:44:34 tjk Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/notice.h>
#include "ccd_error.h"
#include "ccd.h"
#include "dsp_conf.h"
#include "gfm.h"
#include "ccd_conf.h"
#include "ccd_utils.h"
#include "message.h"
#include "version.h"


/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
int			initialize(void);
int			*initialize_objects(void);
CCD_OBJ			*create_objects(void);
CCD_OBJ			*create_ccd_obj(void);
expctl_opaque		*create_expctl(void);
direct_dsp_opaque	*create_direct_dsp(void);
setup_opaque		*create_setup(void);
dsp_opaque		*create_dsp_obj(void);
fits_opaque		*create_fits_obj(void);
long_test_opaque	*create_long_test(void);
#ifdef	IRTOOL
ir_opaque		*create_ir(void);
#endif	IRTOOL
int			refresh(void);
int			load_startup_config();
int			load_config_db(char *file);
Notify_value		destroy(Notify_client client, Destroy_status status);
void			quit(void);
extern int		message_write();
#ifdef	SBUSTOOL
#else	/* VMETOOL */
vme_opaque		*create_vme(void);
#endif	/* SBUSTOOL */

#else	/* K&R C */
int			initialize();
int			*initialize_objects();
CCD_OBJ			*create_objects();
CCD_OBJ			*create_ccd_obj();
expctl_opaque		*create_expctl();
direct_dsp_opaque	*create_direct_dsp();
setup_opaque		*create_setup();
dsp_opaque		*create_dsp_obj();
fits_opaque		*create_fits_obj();
long_test_opaque	*create_long_test();
#ifdef	IRTOOL
ir_opaque		*create_ir();
#endif	IRTOOL
int			refresh();
int			load_startup_config();
int			load_config_db();
Notify_value		destroy();
void			quit();
extern int		message_write();
#ifdef	SBUSTOOL
#else	/* VMETOOL */
vme_opaque		*create_vme();
#endif	/* SBUSTOOL */

#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/

CCD_OBJ			*ccd_obj;


#ifdef	__STDC__
int initialize(void)
#else	/* K&R C */
int
initialize()
#endif	/* __STDC__ */
{
	ccd_obj = create_objects();
	ccdtool_debug_level(CCDTOOL_SHOW_ERRORS);

	ccd_obj->logfile = tempnam("/tmp", "ccd");
	xv_set(Ccd->messages,
		TEXTSW_AGAIN_RECORDING, FALSE,
		TEXTSW_BROWSING,        TRUE,
		TEXTSW_DISABLE_LOAD,    TRUE,
		TEXTSW_HISTORY_LIMIT,   0,
		TEXTSW_IGNORE_LIMIT,    TEXTSW_INFINITY,
		TEXTSW_READ_ONLY,       TRUE,
		TEXTSW_FILE,            ccd_obj->logfile,
	NULL);
	notify_interpose_destroy_func(Ccd->ccd, destroy);
	xv_set(Ccd->ccd,
		XV_LABEL, VERSION,
		XV_SHOW, TRUE, 
	NULL);

/* This section controls whether or not the DSP button is visible */
#ifndef	NO_DSP_BUTTON
	xv_set(Ccd->direct_dsp_button, XV_SHOW, TRUE, NULL);
#else
	xv_set(Ccd->direct_dsp_button, XV_SHOW, FALSE, NULL);
#endif	/* NO_DSP_BUTTON */

/* This controls whether or not the IR button is visible */
#ifdef	IRTOOL
	xv_set(Ccd->ir_button, XV_SHOW, TRUE, NULL);

	/* Relabel these buttons and windows */
	xv_set(About_about_popup->about_popup, XV_LABEL,
		"About NICMOS3 IRtool", NULL);

	xv_set(Direct_dsp->direct_dsp_popup, XV_LABEL,
		"NICMOS3 DSP Command", NULL);

	xv_set(Expctl->expctl_popup, XV_LABEL,
		"NICMOS3 Exposure Control", NULL);
	xv_set(Expctl->temperature_button,
		PANEL_LABEL_WIDTH, 82,
		PANEL_LABEL_STRING, " Array Temp",
		NULL);
	xv_set(Expctl->flush_ccd_button,
		PANEL_LABEL_WIDTH, 82,
		PANEL_LABEL_STRING, " Flush Array",
		NULL);
	xv_set(Expctl->do_readout_ccd, PANEL_CHOICE_STRING, 0,
		"Readout Array", NULL);

	xv_set(Long_test->hardware_long_test_popup, XV_LABEL,
		"NICMOS3 Long Test", NULL);

	xv_set(Properties_properties_popup->properties_popup, XV_LABEL,
		"NICMOS3 IRtool Properties", NULL);

	xv_set(Vme->vme_popup, XV_LABEL, "NICMOS3 VME Setup", NULL);

	/* Hide these CCD buttons for NICMOS3 Implementation */
	xv_set(Expctl->readout_ccd_button, XV_SHOW, FALSE, NULL);
	xv_set(Expctl->save_to_disk_button, XV_SHOW, FALSE, NULL);

	/* Checkmarked Items */
	xv_set(Expctl->do_dual_image, XV_SHOW, FALSE, NULL);

	/* Finally, hide DSP button */
#if 0
	xv_set(Ccd->direct_dsp_button, XV_SHOW, FALSE, NULL);
#endif
#else
#	ifndef	SBUSTOOL
	xv_set(Ccd->ir_button, XV_SHOW, FALSE, NULL);
#	endif	/* SBUSTOOL */
#endif	/* IRTOOL */

	textsw_reset(Ccd->messages, 0, 0);
	textsw_store_file(Ccd->messages, ccd_obj->logfile, 0, 0);
	message_write(WELCOME_MESSAGE);
	load_startup_config();
}



#ifdef	__STDC__
int *initialize_objects(void)
#else	/* K&R C */
int
*initialize_objects()
#endif	/* __STDC__ */
{

	ccd_obj = create_objects();
	load_startup_config();
}


#ifdef	__STDC__
CCD_OBJ *create_objects(void)
#else	/* K&R C */
CCD_OBJ
*create_objects()
#endif	/* __STDC__ */
{
        int		err_cond;
	CCD_OBJ		*ccd_obj;
	if ((ccd_obj = create_ccd_obj()) == NULL)
	{
		ccd_perror("create ccd obj");
		exit (-1);
	}

#ifdef	SBUSTOOL
#else	/* VMETOOL */
	if ((ccd_obj->vme_obj = create_vme()) == NULL)
	{
		ccd_perror("create vme");
		exit(-1);
	}
#endif	/* SBUSTOOL */

        if ((ccd_obj->expctl_obj = create_expctl()) == NULL)
	{
		ccd_perror("create expctl");
		exit(-1);
	}


        if ((ccd_obj->setup_obj = create_setup()) == NULL)
	{
		ccd_perror("create setup");
		exit(-1);
	}
	

        if ((ccd_obj->direct_dsp_obj = create_direct_dsp()) == NULL)
	{
		ccd_perror("create direct_dsp");
		exit(-1);
	}


        if ((ccd_obj->dsp_obj = create_dsp_obj()) == NULL)
	{
		ccd_perror("create dsp_obj");
		exit(-1);
	}
	

	if ((ccd_obj->fits_obj = create_fits_obj()) == NULL)
	{
		ccd_perror("create fits_obj");
		exit(-1);
	}


	if ((ccd_obj->long_test_obj = create_long_test()) == NULL)
	{
		ccd_perror("create long_test_obj");
		exit(-1);
	}

#ifdef	IRTOOL
	if ((ccd_obj->ir_obj = create_ir()) == NULL)
	{
		ccd_perror("create ir_obj");
		exit(-1);
	}

#endif	IRTOOL

        ccd_obj->Gfm = gfm_initialize(NULL, Setup->setup_popup, "Load");
        ccd_obj->ccd_dpy = (Display *)xv_get(Ccd->ccd, XV_DISPLAY);

	return ccd_obj;
}
 
#ifdef	__STDC__
CCD_OBJ *create_ccd_obj(void)
#else	/* K&R C */
CCD_OBJ
*create_ccd_obj()
#endif	/* __STDC__ */
{
	CCD_OBJ	*ccd_obj;

	if ((ccd_obj = (CCD_OBJ *)malloc(sizeof(CCD_OBJ))) == NULL) {
		ccd_errno = ATTRIBUTES_MEM_ERR;
		return NULL;
	}
	else {
		ccd_obj->expctl_obj = NULL;
		ccd_obj->setup_obj = NULL;
		ccd_obj->direct_dsp_obj = NULL;
		ccd_obj->dsp_obj = NULL;
		ccd_obj->fits_obj = NULL;
		ccd_obj->long_test_obj = NULL;
		ccd_obj->logfile = NULL;
		ccd_obj->next_func_ptr = NULL;
		ccd_obj->state = CCD_DEAD;
#ifdef	SBUSTOOL
#else	/* VMETOOL */
		ccd_obj->vme_obj = NULL;
#endif	/* SBUSTOOL */
		return ccd_obj;
	}
}


#ifdef	SBUSTOOL
#else	/* VMETOOL */
#ifdef	__STDC__
vme_opaque *create_vme(void)
#else	/* K&R C */
vme_opaque
*create_vme()
#endif	/* __STDC__ */
{
	VME_OBJ		*vme;

	if ((vme = (VME_OBJ *)malloc(sizeof(VME_OBJ))) == NULL)
	{
		ccd_errno = VME_MEM_ERR;
		return (vme_opaque *)NULL;
	}
	else
	{
		init_vme_defaults(vme);
		reset_vme_panel(vme);
#if 0
		store_vme_settings(vme);
#endif
		return (vme_opaque *)vme;
	}
}
#endif	/* SBUSTOOL */


#ifdef	__STDC__
expctl_opaque *create_expctl(void)
#else	/* K&R C */
expctl_opaque
*create_expctl()
#endif	/* __STDC__ */
{
	EXPCTL_OBJ	*expctl;

	if ((expctl = (EXPCTL_OBJ *)malloc(sizeof(EXPCTL_OBJ))) == NULL)
	{
		ccd_errno = EXPCTL_MEM_ERR;
		return (expctl_opaque *)NULL;
	}
	else
	{
		init_expctl_defaults(expctl);
		reset_expctl_panel(expctl);
		return (expctl_opaque *)expctl;
	}
}


#ifdef	__STDC__
direct_dsp_opaque *create_direct_dsp(void)
#else	/* K&R C */
direct_dsp_opaque
*create_direct_dsp()
#endif	/* __STDC__ */
{
	DIRECT_DSP_OBJ	*direct_dsp;

	if ((direct_dsp = (DIRECT_DSP_OBJ *)malloc(sizeof(DIRECT_DSP_OBJ))) == NULL)
	{
		ccd_errno = DIRECT_DSP_MEM_ERR;
		return (direct_dsp_opaque *)NULL;
	}
	else
	{
#		ifdef	SBUSTOOL
		direct_dsp->board = SBUS_ID;
#		else	/* VMETOOL */
		direct_dsp->board = VME_ID;
#		endif	/* SBUSTOOL */

		direct_dsp->command = NO_COMMAND;
		direct_dsp->data = UNDEFINED;
		direct_dsp->address = UNDEFINED;
		return (direct_dsp_opaque *)direct_dsp;
	}
}


#ifdef	__STDC__
setup_opaque *create_setup(void)
#else	/* K&R C */
setup_opaque
*create_setup()
#endif	/* __STDC__ */
{
	SETUP_OBJ	*setup;

	if ((setup = (SETUP_OBJ *)malloc(sizeof(SETUP_OBJ))) == NULL) {
		ccd_errno = SETUP_MEM_ERR;
		return (setup_opaque *)NULL;
	}
	else {
		init_setup_defaults(setup);
		reset_setup_panel(setup);
		return (setup_opaque *)setup;

	}
}


#ifdef	__STDC__
dsp_opaque *create_dsp_obj(void)
#else	/* K&R C */
dsp_opaque
*create_dsp_obj()
#endif	/* __STDC__ */
{
	dsp_opaque	*dsp_obj;

	if ((dsp_obj = dsp_create()) == NULL)
	{
		ccd_errno = DSP_CREATE_ERR;
		return (dsp_opaque *)NULL;
	}
#ifdef	SBUSTOOL
	dsp_set(dsp_obj,
		SBUS_DEVICE_ZERO, DEFAULT_SBUS_DEVICE_ZERO,
		SBUS_DEVICE_ONE, DEFAULT_SBUS_DEVICE_ONE,
		REPLY_ACTION, CALL_REPLY_FUNC,
		REPLY_FUNC_PTR, refresh,
		DSP_PRINT_PTR, message_write,
	NULL);

#else	/* VMETOOL */
        dsp_set(dsp_obj,
		REPLY_ACTION, CALL_REPLY_FUNC,
		REPLY_FUNC_PTR, refresh,
		DSP_PRINT_PTR, message_write,
	NULL);
#endif	/* SBUSTOOL */

	return dsp_obj;
}

#ifdef	__STDC__
fits_opaque *create_fits_obj(void)
#else	/* K&R C */
fits_opaque
*create_fits_obj()
#endif	/* __STDC__ */
{
	fits_opaque	*fits_obj;

	if ((fits_obj = fits_create()) == NULL) {
		ccd_errno = FITS_CREATE_ERR;
		return (fits_opaque *)NULL;
	}
	else
	{
		reset_fits_panel(fits_obj);
	}

	return (fits_opaque *) fits_obj;
}
#ifdef	__STDC__
long_test_opaque *create_long_test(void)
#else	/* K&R C */
long_test_opaque
*create_long_test()
#endif	/* __STDC__ */
{
	LONG_TEST_OBJ		*long_test;

	if ((long_test = (LONG_TEST_OBJ *)malloc(sizeof(LONG_TEST_OBJ))) == NULL) {
		ccd_errno = LONG_TEST_MEM_ERR;
		return (long_test_opaque *)NULL;
	}
	else {
		init_long_test_defaults(long_test);
		reset_long_test_panel(long_test);
		return (long_test_opaque *)long_test;
	}
}

#ifdef	IRTOOL
#ifdef	__STDC__
ir_opaque *create_ir(void)
#else	/* K&R C */
ir_opaque
*create_ir()
#endif	/* __STDC__ */
{
	IR_OBJ		*obj;

	if ((obj = (IR_OBJ *)malloc(sizeof(IR_OBJ))) == NULL) {
		ccd_errno = IR_MEM_ERR;
		return (ir_opaque *)NULL;
	}
	else {
		init_ir_defaults(obj);
		reset_ir_panel(obj);
#ifdef	DEBUG_IR_VALUES
	printf("obj->filter_wheel1 = %d\n", obj->filter_wheel1);
	printf("obj->filter_wheel2 = %d\n", obj->filter_wheel2);
#endif	DEBUG_IR_VALUES
		return (ir_opaque *)obj;
	}
}
#endif	IRTOOL

#ifdef	__STDC__
int refresh(void)
#else	/* K&R C */
int
refresh()
#endif	/* __STDC__ */
{
        notify_dispatch();
        XFlush(xv_get(Ccd_ccd->ccd, XV_DISPLAY));
}


#ifdef	__STDC__
int load_startup_config(void)
#else	/* K&R C */
int
load_startup_config()
#endif	/* __STDC__ */
{
	char		*char_ptr, buffer[255], configfile[255], rcfile[255];
	int		value;
	mydb_opaque	*db;
	char_ptr = getenv("HOME");
	if (char_ptr)
	{
		sprintf(rcfile, "%s/.ccdtoolrc", char_ptr);
	}
	sprintf(configfile, "%s", CONFIG_FILE);
	gethostname(buffer, 255);
	strcat(configfile, buffer);

	load_config_db(configfile);
	load_config_db(rcfile);

#ifdef	SBUSTOOL
	if (check_sbus() != 1)
	{
		message_popup(Ccd->ccd,
			MESSAGE, "You need to check your SBUS device",
			MESSAGE, "setup.  There seems to be a problem.",
			FOCUS_XY, 0, 0,
		NULL);
	}
	else
	{
		setup_sbus_interface();
	}

#else	/* VMETOOL */
	if (check_vme() != 1)
	{
		message_popup(Ccd->ccd,
			MESSAGE, "Not enough information to fully configure",
			MESSAGE, "the VME interface. You must do this manually",
			MESSAGE, "using the 'Configure VME...' option from",
			MESSAGE, "the Setup menu.",
			FOCUS_XY, 0, 0,
		NULL);
	}
	else
		setup_vme_interface();

#endif	/* SBUSTOOL */
}


#ifdef	__STDC__
int load_config_db(char *file)
#else	/* K&R C */
int
load_config_db(file)
char	*file;
#endif	/* __STDC__ */
{
	mydb_opaque	*db;
	int		value;

	db = mydb_create();
	if ((value = mydb_open(db, file)) == -1) {
		return -1;
	}

	extract_setup(db);

#ifdef	SBUSTOOL
#else	/* VMETOOL */
	extract_vme_setup(db);
#endif	/* SBUSTOOL */

	extract_expctl_setup(db);
	extract_long_test_setup(db);
	mydb_free(db);
	return 1;
}


#ifdef	__STDC__
Notify_value destroy(Notify_client client, Destroy_status status)
#else	/* K&R C */
Notify_value
destroy(client, status)
Notify_client	client;
Destroy_status	status;
#endif	/* __STDC__ */
{

	Xv_notice	notice;
	int		value;

	if (status == DESTROY_CHECKING) {
		notice = xv_create(Ccd->ccd, NOTICE,
			NOTICE_MESSAGE_STRINGS, 
				"Really Quit?",
				NULL,
			NOTICE_BUTTON, "No", 1,
			NOTICE_BUTTON, "Yes", 0,
			NOTICE_STATUS, &value,
			XV_SHOW, TRUE,
		NULL);

		if (value == NOTICE_YES) {
			notify_veto_destroy(client);
		}
		else {
        		unlink(ccd_obj->logfile);
			ccd_obj->next_func_ptr == NULL;
			dsp_set(ccd_obj->dsp_obj, REPLY_FUNC_PTR, quit, NULL);
			notify_veto_destroy(client);
			notify_stop();
		}
	}
	else if (status == DESTROY_CLEANUP) {
		return notify_next_destroy_func(client, status);
	}
	else {
        	unlink(ccd_obj->logfile);
		ccd_obj->next_func_ptr == NULL;
			dsp_set(ccd_obj->dsp_obj, REPLY_FUNC_PTR, quit, NULL);
			notify_veto_destroy(client);
		notify_stop();
	}

	return NOTIFY_DONE;
}

#ifdef	__STDC__
void quit(void)
#else	/* K&R C */
void quit()
#endif	/* __STDC__ */
{
	exit(1);
}

/*
 * $Log: initialize.c,v $
 * Revision 1.23  1996/03/08 23:44:34  tjk
 * Changed CCD to NICMOS3.
 *
 * Revision 1.22  1996/03/04 19:08:14  tjk
 * Added code to hide buttons not to be used in IRTOOL.
 *
 * Revision 1.21  1996/02/09  01:36:50  tjk
 * Changed the default QUIT answer to "No".
 *
 * Revision 1.20  1996/02/05  17:44:36  tjk
 * Changed hard-coded config file to CONFIG_FILE as defined in version.h
 *
 * Revision 1.19  1996/01/06  00:59:50  gumrukcu
 * Change in fits create.
 *
 * Revision 1.18  1996/01/05 18:21:17  gumrukcu
 * The seg fault is found. All the debug stuff is cleared.
 *
 * Revision 1.17  1996/01/04 23:36:22  gumrukcu
 * test for seg fault.
 *
 * Revision 1.16  1996/01/04 23:21:37  gumrukcu
 * test for seg fault.
 *
 * Revision 1.13  1996/01/04 23:04:23  gumrukcu
 * test for seg fault.
 *
 * Revision 1.12  1996/01/04 21:07:46  gumrukcu
 * test4.
 *
 * Revision 1.7  1996/01/02 20:40:37  gumrukcu
 * OBJ_FITS was not initialized for SBUSTOOL. It is initialized.
 *
 * Revision 1.6  1995/12/27  19:49:52  gumrukcu
 * *** empty log message ***
 *
 * Revision 1.5  1995/12/26  23:18:26  gumrukcu
 *  The functions of the fits window is taken care of for sbustool.
 *
 * Revision 1.4  1995/12/12  22:33:33  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.3  1995/08/21  18:42:15  tjk
 * converting to ANSI C standard
 *
 * Revision 1.2  1995/08/10  16:53:26  tjk
 * Changes for IRTOOL.
 *
 * Revision 1.1  1995/02/10  03:59:30  tjk
 * Initial revision
 *
 *
 */
