/* $Header: /rosie/src/ccd_utilities/tool/RCS/ir_data.c,v 0.3 1995/08/21 18:42:15 tjk Exp $ */
#ifndef IR_DATA_C
#define IR_DATA_C

#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd.h"
#include "ir.h"
#include "dsp.h"

/*>>>>> Global Flags <<<<<*/
int filter_position_known=0;

#ifdef	__STDC__
void init_ir_defaults(IR_OBJ *obj);
int set_ir_value(...);
ir_opaque get_ir_value(IR_OBJ *obj, int ir_item);
#else	/* K&R C */
void init_ir_defaults();
int set_ir_value();
ir_opaque get_ir_value();
#endif	__STDC__

#ifdef	__STDC__
void init_ir_defaults(IR_OBJ *obj)
#else	/* K&R C */
void
init_ir_defaults(obj)
IR_OBJ *obj;
#endif	__STDC__
{
	set_ir_value(obj,
		FILTER_WHEEL_1, IR_FILTER_HOME,
		FILTER_WHEEL_2, IR_FILTER_OPEN,
		NULL);
	return;
}

#ifdef	__STDC__
void init_filter_wheels(IR_OBJ *obj)
#else	/* K&R C */
void
init_filter_wheels(obj)
IR_OBJ *obj;
#endif	__STDC__
{
	DSP_ATTR *dsp;

	dsp = (DSP_ATTR *) ccd_obj->dsp_obj;

	deactivate_buttons(TRUE);

	dsp_command(dsp, UTIL_ID, MH1);

	dsp_command(dsp, UTIL_ID, MH2);
	dsp_command(dsp, UTIL_ID, MM2, IR_FILTER_OPEN * IR_MOTOR_STEPS);

	deactivate_buttons(FALSE);

	return;
}

#ifdef	__STDC__
int set_ir_value(...)
#else	/* K&R C */
int
set_ir_value(va_alist)
va_dcl
#endif	__STDC__
{
	va_list	ap;
	IR_OBJ	*obj;
	int	modifier;
	int	value;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	obj = va_arg(ap, IR_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL)
	{
		switch(modifier)
		{
			case FILTER_WHEEL_1:
				obj->filter_wheel1 = va_arg(ap, int);
#ifdef	DEBUG_IR_VALUES
printf("obj->filter_wheel1 = %d\n", obj->filter_wheel1);
#endif	DEBUG_IR_VALUES
				break;
			case FILTER_WHEEL_2:
				obj->filter_wheel2 = va_arg(ap, int);
#ifdef	DEBUG_IR_VALUES
printf("obj->filter_wheel2 = %d\n", obj->filter_wheel2);
#endif	DEBUG_IR_VALUES
				break;
			default:
				fprintf(stderr,
					"bad set_ir_value %d\n", 
					modifier);
		}

		modifier = va_arg(ap, int);
	}

	return;
}

#ifdef	__STDC__
ir_opaque get_ir_value(IR_OBJ *obj, int ir_item)
#else	/* K&R C */
ir_opaque
get_ir_value(obj, ir_item)
IR_OBJ	*obj;
int	ir_item;
#endif	__STDC__
{
	switch(ir_item)
	{
		case FILTER_WHEEL_1:
			return (ir_opaque) obj->filter_wheel1;

		case FILTER_WHEEL_2:
			return (ir_opaque) obj->filter_wheel2;

		default:
			fprintf(stderr,
				"***** bad get_ir_value %d\n",
				ir_item);
	}

	return;
}

#ifdef	__STDC__
void	move_home(int filter_wheel)
#else	/* K&R C */
void
move_home(filter_wheel)
int filter_wheel;
#endif	/* __STDC__ */
{
	switch (filter_wheel)
	{
		case FILTER_WHEEL_1:
			set_ir_panel_value(ccd_obj->ir_obj, FILTER_WHEEL_1,
				IR_FILTER_HOME, NULL);
			store_fw1_value();
			break;
		case FILTER_WHEEL_2:
			set_ir_panel_value(ccd_obj->ir_obj, FILTER_WHEEL_2,
				IR_FILTER_HOME, NULL);
			store_fw2_value();
			break;
		default:
			fprintf(stderr,
				"***** bad move_home value = %d\n",
				filter_wheel);
	}
}

/*
 * $Log: ir_data.c,v $
 * Revision 0.3  1995/08/21 18:42:15  tjk
 * converting to ANSI C standard
 *
 * Revision 0.2  1995/08/10  16:53:26  tjk
 * Changes for IRTOOL.
 *
 *
 */
#endif	IR_DATA_C
