/* $Header: /rosie/src/ccd_utilities/tool/RCS/ir_panel.c,v 0.4 1996/03/04 19:07:41 tjk Exp $ */

#include <xview/xview.h>
#include <xview/panel.h>

#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"
#include "ir.h"
#include "dsp.h"

/*>>>>> Function Prototypes <<<<<*/
#ifdef	__STDC__
ir_opaque set_ir_panel_value(...);
ir_opaque get_ir_panel_value(...);
void reset_ir_panel(IR_OBJ *obj);
void store_fw1_value(void);
void store_fw2_value(void);
void move_to_filter(int filter_wheel, int new_position, int old_position);
void deactivate_buttons(int value);
#else	/* K&R C */
ir_opaque set_ir_panel_value();
ir_opaque get_ir_panel_value();
void reset_ir_panel();
void store_fw1_value();
void store_fw2_value();
void move_to_filter();
void deactivate_buttons();
#endif	/* __STDC__ */

#ifdef	__STDC__
ir_opaque set_ir_panel_value(...)
#else	/* K&R C */
ir_opaque
set_ir_panel_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	int filter;

	va_list ap;
	int	modifier=0;
	int	value;
	IR_OBJ *obj;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	obj = va_arg(ap, IR_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL)
	{
		switch(modifier)
		{
			case FILTER_WHEEL_1:
				filter = va_arg(ap, int);
				xv_set(Ir_ir_popup->ir_filter_wheel_setting1,
					PANEL_VALUE, filter, NULL);
#ifdef DEBUG_IR_POPUP
printf("\n##### DEBUG IR POPUP\n");
printf("set Filter Wheel #1 value = %d\n", filter);
#endif DEBUG_IR_POPUP
				break;
			case FILTER_WHEEL_2:
				filter = va_arg(ap, int);
				xv_set(Ir_ir_popup->ir_filter_wheel_setting2,
					PANEL_VALUE, filter, NULL);
#ifdef DEBUG_IR_POPUP
printf("\n##### DEBUG IR POPUP\n");
printf("set Filter Wheel #2 value = %d\n", filter);
#endif DEBUG_IR_POPUP
				break;
			default:
				fprintf(stderr,
			"\nir_panel.c(set_ir_panel_value):  invalid tag %d\n",
					modifier);
		}

		modifier = va_arg(ap, int);
	}

	return;
}

#ifdef	__STDC__
ir_opaque get_ir_panel_value(...)
#else	/* K&R C */
ir_opaque
get_ir_panel_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	IR_OBJ		*obj;
	int		modifier;
	int		int_value;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	obj = va_arg(ap, IR_OBJ *);
	modifier = va_arg(ap, int);

	switch(modifier)
	{
		case FILTER_WHEEL_1:
			int_value = (int)
				 xv_get(Ir_ir_popup->ir_filter_wheel_setting1,
					PANEL_VALUE);
#ifdef DEBUG_IR_POPUP
printf("\n##### DEBUG IR POPUP\n");
printf("get Filter Wheel #1 value = %d\n", int_value);
#endif DEBUG_IR_POPUP
			break;
		case FILTER_WHEEL_2:
			int_value = (int)
				 xv_get(Ir_ir_popup->ir_filter_wheel_setting2,
					PANEL_VALUE);
#ifdef DEBUG_IR_POPUP
printf("\n##### DEBUG IR POPUP\n");
printf("get Filter Wheel #2 value = %d\n", int_value);
#endif DEBUG_IR_POPUP
			break;
		default:
			fprintf(stderr,
			"\nir_panel.c(get_ir_panel_value):  invalid tag %d\n",
				modifier);
	}

	return (int) int_value;
}

#ifdef	__STDC__
void reset_ir_panel(IR_OBJ *obj)
#else	/* K&R C */
void
reset_ir_panel(obj)
IR_OBJ *obj;
#endif	__STDC__
{
	set_ir_panel_value(obj,
		FILTER_WHEEL_1, obj->filter_wheel1,
		FILTER_WHEEL_2, obj->filter_wheel2,
		NULL);

	return;
}

#ifdef	__STDC__
void store_fw1_value(void)
#else	/* K&R C */
void
store_fw1_value()
#endif	__STDC__
{
	int previous_position[2];

	IR_OBJ	*obj;

	obj = (IR_OBJ *) ccd_obj->ir_obj;

	previous_position[0] = obj->filter_wheel1;
	previous_position[1] = obj->filter_wheel2;

	obj->filter_wheel1 = (int) get_ir_panel_value(obj, FILTER_WHEEL_1);

	if (previous_position[0] != obj->filter_wheel1)
	{
		move_to_filter(FILTER_WHEEL_1, obj->filter_wheel1,
			       previous_position[0]);
	}

	if (obj->filter_wheel1 != IR_FILTER_OPEN)
	{
		/* Check for the continuum filter special case */
		if (obj->filter_wheel1 == IR_CONTINUUM_FILTER)
			obj->filter_wheel2 = IR_BLOCKING_FILTER;
		else
			obj->filter_wheel2 = IR_FILTER_OPEN;

		set_ir_panel_value(obj, FILTER_WHEEL_2, obj->filter_wheel2,
			NULL);
		if (previous_position[1] != obj->filter_wheel2)
		{
			move_to_filter(FILTER_WHEEL_2, obj->filter_wheel2,
				       previous_position[1]);
		}
	}

	return;
}

#ifdef	__STDC__
void store_fw2_value(void)
#else	/* K&R C */
void
store_fw2_value()
#endif	__STDC__
{
	int previous_position[2];

	IR_OBJ	*obj;

	obj = (IR_OBJ *) ccd_obj->ir_obj;

	previous_position[0] = obj->filter_wheel1;
	previous_position[1] = obj->filter_wheel2;

	obj->filter_wheel2 = (int) get_ir_panel_value(obj, FILTER_WHEEL_2);

	if (previous_position[1] != obj->filter_wheel2)
	{
		move_to_filter(FILTER_WHEEL_2, obj->filter_wheel2,
			       previous_position[1]);
	}

	if (obj->filter_wheel2 != IR_FILTER_OPEN)
	{
		/* Check for the continuum filter special case */
		if (obj->filter_wheel2 == IR_BLOCKING_FILTER)
			obj->filter_wheel1 = IR_CONTINUUM_FILTER;
		else
			obj->filter_wheel1 = IR_FILTER_OPEN;

		set_ir_panel_value(obj, FILTER_WHEEL_1, obj->filter_wheel1,
			NULL);
		if (previous_position[0] != obj->filter_wheel1)
		{
			move_to_filter(FILTER_WHEEL_1, obj->filter_wheel1,
				       previous_position[0]);
		}
	}

	return;
}


#ifdef	__STDC__
void move_to_filter(int filter_wheel, int new_position, int old_position)
#else	/* K&R C */
void
move_to_filter(filter_wheel, new_position, old_position)
int	filter_wheel, new_position, old_position;
#endif	/* __STDC__ */
{
	int	dsp_return_value;

	int	position_offset;

	DSP_ATTR *dsp;

	dsp = (DSP_ATTR *) ccd_obj->dsp_obj;

	/* Disable buttons on all windows */
	deactivate_buttons(TRUE);

	switch(filter_wheel)
	{
		case FILTER_WHEEL_1:
			if (new_position > old_position)
			{
				position_offset = new_position - old_position;
				dsp_return_value = dsp_command(dsp,
					UTIL_ID, MM1,
					position_offset * IR_MOTOR_STEPS);
			}
			else if (new_position < old_position)
			{
				dsp_return_value = dsp_command(dsp,
					UTIL_ID, MH1);
				if ( new_position != 0)
					dsp_return_value = dsp_command(dsp,
						UTIL_ID, MM1,
						new_position * IR_MOTOR_STEPS);
			}
#ifdef	DEBUG_IR_MOVE_FILTER
printf("FW1:  move from %d to %d\n", old_position, new_position);
#endif
			break;
		case FILTER_WHEEL_2:
			if (new_position > old_position)
			{
				position_offset = new_position - old_position;
				dsp_return_value = dsp_command(dsp,
					UTIL_ID, MM2,
					position_offset * IR_MOTOR_STEPS);
			}
			else if (new_position < old_position)
			{
				dsp_return_value = dsp_command(dsp,
					UTIL_ID, MH2);
				if ( new_position != 0)
					dsp_return_value = dsp_command(dsp,
						UTIL_ID, MM2,
						new_position * IR_MOTOR_STEPS);
			}
#ifdef	DEBUG_IR_MOVE_FILTER
printf("FW2:  move from %d to %d\n", old_position, new_position);
#endif
			break;
		default:
			fprintf(stderr,
				"\nir_panel.c(move_to_filter):  %d invalid\n",
				filter_wheel);
	}

	/* Enable buttons */
	deactivate_buttons(FALSE);

	return;
}


#ifdef	__STDC__
void deactivate_buttons(int value)
#else	/* K&R C */
void
deactivate_buttons(value)
int	value;
#endif	/* __STDC__ */
{
	xv_set(Ccd->direct_dsp_button, PANEL_INACTIVE, value, NULL);
	xv_set(Ccd->expctl_button, PANEL_INACTIVE, value, NULL);
	xv_set(Ccd->fits_button, PANEL_INACTIVE, value, NULL);
	xv_set(Ccd->ir_button, PANEL_INACTIVE, value, NULL);
	xv_set(Ccd->setup_button, PANEL_INACTIVE, value, NULL);

	xv_set(Expctl->close_shutter_button, PANEL_INACTIVE, value, NULL);
	xv_set(Expctl->expose_button, PANEL_INACTIVE, value, NULL);
	xv_set(Expctl->open_shutter_button, PANEL_INACTIVE, value, NULL);
	xv_set(Expctl->temperature_button, PANEL_INACTIVE, value, NULL);

	xv_set(Fits->fits_file_button, PANEL_INACTIVE, value, NULL);
	xv_set(Fits->fits_apply_button, PANEL_INACTIVE, value, NULL);
	xv_set(Fits->fits_reset_button, PANEL_INACTIVE, value, NULL);

	xv_set(Ir_ir_popup->ir_filter_wheel_setting1, PANEL_INACTIVE,
		value, NULL);
	xv_set(Ir_ir_popup->ir_filter_wheel_setting2, PANEL_INACTIVE,
		value, NULL);
	xv_set(Ir_ir_popup->ir_move_home_button1, PANEL_INACTIVE,
		value, NULL);
	xv_set(Ir_ir_popup->ir_move_home_button2, PANEL_INACTIVE,
		value, NULL);

	xv_set(Setup->apply_button, PANEL_INACTIVE, value, NULL);
	xv_set(Setup->clear_all_button, PANEL_INACTIVE, value, NULL);
	xv_set(Setup->reset_button, PANEL_INACTIVE, value, NULL);
	xv_set(Setup->select_all_button, PANEL_INACTIVE, value, NULL);

	return;
}

/*
 * $Log: ir_panel.c,v $
 * Revision 0.4  1996/03/04 19:07:41  tjk
 * Added a special case for the blocking filter.
 *
 * Revision 0.3  1995/08/21  18:42:16  tjk
 * converting to ANSI C standard
 *
 * Revision 0.2  1995/08/10  16:53:26  tjk
 * Changes for IRTOOL.
 *
 * Revision 0.1  1995/08/01  16:47:30  tjk
 * irtool specific files - initial revision
 *
 *
 */

