#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"

struct {
	int	tag;
	char	*string;
} lios[] = {
	{ TIMING_LONG_SELECT,     "timingLongSelect"},
	{ TIMING_LONG_NUM,        "timingLongNum"},
};	


/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void	init_long_test_defaults(LONG_TEST_OBJ *long_test);
void	set_long_test_value(...);
long_test_opaque	get_long_test_value(LONG_TEST_OBJ *obj,
					    LONG_TEST_TAGS long_test_item);

#else	/* K&R C */
void  init_long_test_defaults();
void	set_long_test_value();
long_test_opaque  get_long_test_value();

#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/

char	*long_test_io_strings[NUM_LONG_TEST_TAGS+1];


#ifdef	__STDC__
void  init_long_test_defaults(LONG_TEST_OBJ *long_test)
#else	/* K&R C */
void
init_long_test_defaults(long_test)
LONG_TEST_OBJ       *long_test;
#endif	/* __STDC__ */
{
	int	i, j;

        set_long_test_value(long_test,
		TIMING_LONG_SELECT, DEFAULT_TIMING_LONG_SELECT,
		TIMING_LONG_NUM, DEFAULT_TIMING_LONG_NUM,
              	NULL);

	for (i=0; i<=NUM_LONG_TEST_TAGS; i++)
	{
		for (j=0; j<NUM_LONG_TEST_STRINGS; j++)
		{
			if (lios[j].tag == i)
				long_test_io_strings[i] = lios[j].string;
		}
	}

}


#ifdef	__STDC__
void  set_long_test_value(...)
#else	/* K&R C */
void
set_long_test_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	LONG_TEST_OBJ	*long_test;
	int		modifier;
	int		int_value;
	char		*char_value;
	mydb_opaque	*db;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */
	long_test = va_arg(ap, LONG_TEST_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL)
	{
		switch (modifier)
		{
			case LONG_DB:
				db = va_arg(ap, mydb_opaque *);
				if (long_test->db != NULL)
					mydb_free(long_test->db);
				long_test->db = db;
				break;
			case TIMING_LONG_SELECT:
				long_test->timing_long_select = va_arg(ap, int);
				break;
			case TIMING_LONG_NUM:
				long_test->timing_long_num = va_arg(ap, int);
				break;
			default:
				printf("ERROR:  set_long_test_value(): %d\n",
					modifier);
		}

		modifier = va_arg(ap, int);
	}
}


#ifdef	__STDC__
long_test_opaque  get_long_test_value(LONG_TEST_OBJ *obj,
				      LONG_TEST_TAGS long_test_item)
#else	/* K&R C */
long_test_opaque	
get_long_test_value(obj, long_test_item)
LONG_TEST_OBJ	*obj;
LONG_TEST_TAGS	long_test_item;
#endif	/* __STDC__ */
{
	switch (long_test_item)
	{
		case LONG_DB:
			return (long_test_opaque)obj->db;
                case TIMING_LONG_SELECT:
			return (long_test_opaque)obj->timing_long_select;
                case TIMING_LONG_NUM:
			return (long_test_opaque)obj->timing_long_num;
		default:
				printf("ERROR:  get_long_test_value(): %d\n",
					long_test_item);

	      }
}
