/* $Header: /rosie/src/ccd_utilities/tool/RCS/long_test_popup_io.c,v 1.3 1995/12/12 22:33:34 tjk Exp $
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "long_test_popup_io.h"
#include "gfm.h"
#include "conversion.h"
#include "message.h"


/*>>>>>  Function Prototypes  <<<<<*/
#ifdef	__STDC__
void	extract_long_test_setup(mydb_opaque  *db);
void	extract_long_test_setup_value(LONG_TEST_TAGS  long_test_item, char  *value);
void	save_long_test_setup(char  *filename, int  append);
char	*insert_long_test_setup(LONG_TEST_OBJ  *obj, LONG_TEST_TAGS  long_test_item);
#else	/* K&R C */
void	extract_long_test_setup();
void	extract_long_test_setup_value();
void	save_long_test_setup();
char	*insert_long_test_setup();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/


#ifdef	__STDC__
void	extract_long_test_setup(mydb_opaque  *db)
#else	/* K&R C */
void
extract_long_test_setup(db)
mydb_opaque	*db;
#endif	/* __STDC__ */
{
	LONG_TEST_TAGS	long_test_item;
	char		*value;

	mydb_set(db, MYDB_RESOURCE_TYPE, LONG_TEST_SETUP_RESOURCE);

	for (long_test_item=TIMING_LONG_SELECT;
		long_test_item <= TIMING_LONG_NUM;
		long_test_item++)
	{
		value = (char *)mydb_get(db, MYDB_ATTRIBUTE,
					long_test_io_strings[long_test_item]);
		if (value != NULL)
		{
			extract_long_test_setup_value(long_test_item, value);
		}
	}
	reset_long_test_panel(ccd_obj->long_test_obj);
}


#ifdef	__STDC__
void	extract_long_test_setup_value(LONG_TEST_TAGS long_test_item,
		char  *value)
#else	/* K&R C */
void
extract_long_test_setup_value(long_test_item, value)
LONG_TEST_TAGS	long_test_item;
char		*value;
#endif	/* __STDC__ */
{
	int	int_value;

	switch (long_test_item)
	{
#		ifdef	SBUSTOOL
#		else	/* VMETOOL */
		case VME_LONG_SELECT:
#		endif	/* SBUSTOOL */

		case TIMING_LONG_SELECT:
			int_value = char2boolean(value);
			set_long_test_value(ccd_obj->long_test_obj,
				long_test_item, int_value, NULL);
			break;

#		ifdef	SBUSTOOL
#		else	/* VMETOOL */
		case VME_LONG_NUM:
#		endif	/* SBUSTOOL */

		case TIMING_LONG_NUM:
			int_value = char2int(value);
			set_long_test_value(ccd_obj->long_test_obj,
				long_test_item, int_value, NULL);
			break;
		default:
			printf("ERROR>  extract_long_test_setup_value(): %d\n",
				long_test_item);
	}
}


#ifdef	__STDC__
void	save_long_test_setup(char  *filename, int  append)
#else	/* K&R C */
void
save_long_test_setup(filename, append)
char	*filename;
int	append;
#endif	/* __STDC__ */
{
	LONG_TEST_TAGS	long_test_item;
	char		*value;
	mydb_opaque	*db;

	store_long_test_settings(ccd_obj->long_test_obj);

	db = mydb_create();
	
	mydb_set(db, MYDB_FILENAME, filename);
	mydb_set(db, MYDB_RESOURCE_TYPE, LONG_TEST_SETUP_RESOURCE);

	for (long_test_item=TIMING_LONG_SELECT;
	     long_test_item <= TIMING_LONG_NUM;
	     long_test_item++)
	{
		value = insert_long_test_setup((LONG_TEST_OBJ *)
				ccd_obj->long_test_obj, long_test_item); 
		if (value != NULL)
		{
			mydb_set(db, MYDB_ATTRIBUTE,
				long_test_io_strings[long_test_item], value);
		}
	}

	mydb_set(db, MYDB_APPEND, append);
	mydb_write(db, NULL);
	mydb_free(db);
}


#ifdef	__STDC__
char	*insert_long_test_setup(LONG_TEST_OBJ  *obj,
				LONG_TEST_TAGS long_test_item)
#else	/* K&R C */
char
*insert_long_test_setup(obj, long_test_item)
LONG_TEST_OBJ	*obj;
LONG_TEST_TAGS	long_test_item;
#endif	/* __STDC__ */
{
	char	*value;
	int	int_value;

	switch (long_test_item)
	{
#	ifndef	SBUSTOOL
		case VME_LONG_SELECT:
#	endif	/* SBUSTOOL */

		case TIMING_LONG_SELECT:
			int_value = (int)get_long_test_value(obj,
						long_test_item);
			return (boolean2char(int_value));

#	ifndef	SBUSTOOL
		case VME_LONG_NUM:
#	endif	/* SBUSTOOL */

		case TIMING_LONG_NUM:
			int_value = (int)get_long_test_value(obj,
						long_test_item);
			if (int_value == UNDEFINED)
				return NULL;
			else
				return (int2char(int_value));
	}
}

/*
 * $Log: long_test_popup_io.c,v $
 * Revision 1.3  1995/12/12 22:33:34  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.2  1995/08/23  00:05:04  moore
 * ANSI conversion
 *
 * Revision 1.1  1995/02/10 04:02:13  tjk
 * Initial revision
 *
 *
 */
