/* $Header: /rosie/src/ccd_utilities/tool/RCS/message.c,v 1.2 1995/08/23 00:14:51 tjk Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "message.h"


/*>>>>>  Function Prototypes  <<<<<*/
#ifdef	__STDC__
void write_frame(Xv_object *frame, int position, char *string);
int message_popup(...);
void message_write(...);
#else	/* K&R C */
void write_frame();
int message_popup();
void message_write();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/


#ifdef	__STDC__
void write_frame(Xv_object *frame, int position, char *string)
#else	/* K&R C */
void write_frame(frame, position, string)
Xv_object	*frame;
int		position;
char		*string;
#endif	/* __STDC__ */
{
	xv_set((Xv_object) frame, position, string, NULL);
}

#ifdef	__STDC__
int message_popup(...)
#else	/* K&R C */
int
message_popup(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	int		modifier;
	int		button_num, message_num, do_focus, dual;
	int		status;
	int		focus_x, focus_y;
	char		*message[10];
	char		*button_string[2];
	Xv_notice	notice;
	Xv_object	*panel;

	message_num = 0;
	button_num = 0;
	do_focus = FALSE;
	dual = FALSE;
	button_string[0] = "Acknowledge";
	button_string[1] = NULL;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	panel = va_arg(ap, Xv_object *);
	modifier = va_arg(ap, int);

	while (modifier != NULL) {
		switch (modifier) {
			case MESSAGE:
				if (message_num > 9)
					break;
				message[message_num] = va_arg(ap, char *);
				message_num++;
				break;
			case FOCUS_XY:
				do_focus = TRUE;
				focus_x = va_arg(ap, int);
				focus_y = va_arg(ap, int);
				break;
			case BUTTON_STRING:
				if (button_num > 1)
					break;
				button_string[button_num] = va_arg(ap, char *);
				button_num++;
				break;
		}

		modifier = va_arg(ap, int);
	}

	message[message_num] = NULL;
	if (button_num > 1)
		dual = TRUE;

	if (dual) {
		if (do_focus) {
			notice = xv_create((Xv_object) panel, NOTICE,
				NOTICE_FOCUS_XY, focus_x, focus_y,
				NOTICE_LOCK_SCREEN,	TRUE,
				NOTICE_BLOCK_THREAD,	TRUE,
				NOTICE_MESSAGE_STRINGS_ARRAY_PTR,
					message,
				NOTICE_BUTTON_YES, button_string[0],
				NOTICE_BUTTON_NO, button_string[1],
				NOTICE_STATUS,	&status,
				XV_SHOW, TRUE,
			NULL);
		}
		else {
			notice = xv_create((Xv_object) panel, NOTICE,
				NOTICE_LOCK_SCREEN,	TRUE,
				NOTICE_BLOCK_THREAD,	TRUE,
				NOTICE_MESSAGE_STRINGS_ARRAY_PTR,
					message,
				NOTICE_BUTTON_YES, button_string[0],
				NOTICE_BUTTON_NO, button_string[1],
				NOTICE_STATUS,	&status,
				XV_SHOW, TRUE,
			NULL);
		}
	}
	else {
		if (do_focus) {
			notice = xv_create((Xv_object) panel, NOTICE,
				NOTICE_FOCUS_XY, focus_x, focus_y,
				NOTICE_LOCK_SCREEN,	TRUE,
				NOTICE_BLOCK_THREAD,	TRUE,
				NOTICE_MESSAGE_STRINGS_ARRAY_PTR,
					message,
				NOTICE_BUTTON_YES, button_string[0],
				NOTICE_STATUS,	&status,
				XV_SHOW, TRUE,
			NULL);
		}
		else {
			notice = xv_create((Xv_object) panel, NOTICE,
				NOTICE_LOCK_SCREEN,	TRUE,
				NOTICE_BLOCK_THREAD,	TRUE,
				NOTICE_MESSAGE_STRINGS_ARRAY_PTR,
					message,
				NOTICE_BUTTON_YES, button_string[0],
				NOTICE_STATUS,	&status,
				XV_SHOW, TRUE,
			NULL);
		}
	}

	xv_destroy_safe(notice);

	return status;
}


#ifdef	__STDC__
void message_write(...)
#else	/* K&R C */
void message_write(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	char		*format;
	static int	line_count=0;
	char		message[255];

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	format = va_arg(ap, char *);

	vsprintf(message, format, ap);
	textsw_insert(Ccd->messages, message, strlen(message));
	if (line_count++ > 400) {
		textsw_save(Ccd->messages, 0, 0);
		line_count = 0;
	}
}


/*
 * $Log: message.c,v $
 * Revision 1.2  1995/08/23 00:14:51  tjk
 * ANSI conversion...
 *
 * Revision 1.1  1995/02/10  03:59:59  tjk
 * Initial revision
 *
 *
 */
