/* $Header: /rosie/src/ccd_utilities/tool/RCS/sbus.c,v 1.11 1996/02/14 18:57:34 tjk Exp $ */
#include <stdio.h>
#include <fcntl.h>
#include <sys/param.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/notice.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "dsp_conf.h"
#include "message.h"
#include "sbus_error.h"
#include "ccd_error.h"


/*>>>>>  Function Prototypes  <<<<<*/
#ifdef   __STDC__
void	setup_sbus_interface(void);
int	check_sbus(void);
void	show_sbus_error(int  errno);
void	sbus_interface_open(int  value);
#else   /* K&R C */
void	setup_sbus_interface();
int	check_sbus();
void	show_sbus_error();
void	sbus_interface_open();
#endif  /* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/

 
#ifdef   __STDC__
void	setup_sbus_interface(void)
#else   /* K&R C */
void
setup_sbus_interface()
#endif  /* __STDC__ */
{
	dsp_opaque	*dsp;
	fits_opaque	*fits;
	int		errno;
	dsp = ccd_obj->dsp_obj;
	fits = ccd_obj->fits_obj;

	if (dsp_open((DSP_ATTR *)dsp) == DSP_ERROR) {
		message_popup(Ccd->ccd,
			MESSAGE, "Unable to open the SBUS interface.",
			FOCUS_XY, 0, 0,
		NULL);
		dsp_perror("setup_sbus_interface");
		sbus_interface_open(FALSE);
	}
	else {
		/* reset SBUS board on startup */
		dsp_command((DSP_ATTR *) dsp, SBUS_ID, Reset);
		sbus_interface_open(TRUE);
	}

	if (ccdtool_debug) {
		sbus_interface_open(TRUE);
	}
}


#ifdef   __STDC__
int	check_sbus(void)
#else   /* K&R C */
int
check_sbus()
#endif  /* __STDC__ */
{
	char		*interface;

	interface = (char *)DEFAULT_SBUS_DEVICE_ZERO;
	if ((interface == NULL) || (strlen(interface) == 0))
	{
		return SBUS_DEVICE_UNDEFINED;
	}
	interface = (char *)DEFAULT_SBUS_DEVICE_ONE;
	if ((interface == NULL) || (strlen(interface) == 0))
	{
		return SBUS_DEVICE_UNDEFINED;
	}

	return 1;
}


#ifdef   __STDC__
void	show_sbus_error(int  errno)
#else   /* K&R C */
void
show_sbus_error(errno)
int	errno;
#endif  /* __STDC__ */
{
	switch (errno) {
		case SBUS_DEVICE_UNDEFINED:
			message_popup(Ccd->ccd,
				MESSAGE, "You must specify an",
				MESSAGE, "SBUS device to open.",
				FOCUS_XY, 0, 0,
			NULL);
			break;
	}
}


#ifdef   __STDC__
void	sbus_interface_open(int  value)
#else   /* K&R C */
void
sbus_interface_open(value)
int	value;
#endif  /* __STDC__ */
{
	Menu		menu;
	Menu_item	item;

	menu = (Menu)xv_get(Ccd->setup_button, PANEL_ITEM_MENU);
	item = (Menu_item)xv_get(menu, MENU_NTH_ITEM, 1);

	if (value) {
		xv_set(item, MENU_INACTIVE, FALSE, NULL);
		xv_set(Ccd->expctl_button, PANEL_INACTIVE, FALSE, NULL);
		xv_set(Ccd->direct_dsp_button, PANEL_INACTIVE, FALSE, NULL);
	}
	else {
		dsp_close((DSP_ATTR *)ccd_obj->dsp_obj);
		xv_set(item, MENU_INACTIVE, TRUE, NULL);
		xv_set(Ccd->expctl_button, PANEL_INACTIVE, TRUE, NULL);
		xv_set(Ccd->direct_dsp_button, PANEL_INACTIVE, TRUE, NULL);
		xv_set(Direct_dsp->direct_dsp_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
		xv_set(Setup->setup_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
		xv_set(Expctl->expctl_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
	}
}


/*
 * $Log: sbus.c,v $
 * Revision 1.11  1996/02/14 18:57:34  tjk
 * Added typecast (DSP_ATTR *) dsp to dsp_command() call.
 *
 * Revision 1.10  1996/01/05 18:24:54  gumrukcu
 * The seg fault is found. All the debug stuff is cleared.
 *
 * Revision 1.9  1996/01/04 23:54:40  gumrukcu
 * working on the dsp_command.
 *
 * Revision 1.4  1996/01/04 19:49:46  gumrukcu
 * casting to DSP_ATTR * is made to dsp in dsp_command.
 *
 * Revision 1.3  1995/12/12 22:33:36  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.2  1995/08/23  00:05:44  moore
 * ANSI conversion
 *
 * Revision 1.1  1995/08/12 20:05:06  moore
 * Initial revision
 *
 *
 */

