/* $Header: /rosie/src/ccd_utilities/tool/RCS/setup_data.c,v 1.7 1997/01/03 22:23:25 gumrukcu Exp $
 */

#ifndef	__STDC__
#include <varargs.h>
#endif	/* __STDC__ */
#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"


struct {
	int	tag;
	char	*string;
} sios[] = {
	{ DO_HARDWARE_TEST, 	"doHardwareTest" },
	{ DO_TIMING_BOARD,	"doTimingBoard" },
	{ DO_CAMERA_ON,		"doCameraOn" },
        { DO_RESET_TIMING,      "doResetTiming"},
	{ DO_DIMENSIONS, 	"doDimensions" },
	{ HARDWARE_TEST_SETTING, "hardwareTestSetting" },
	{ TIMING_SETTING,	"timingSetting" },
	{ TIMING_LDA,		"timingLDA" },
	{ TIMING_FILENAME,	"timingFilename" },
	{ NCOLS,		"ncols" },
	{ NROWS,		"nrows" },
};

char	*setup_io_strings[NUM_SETUP_TAGS+1];

/*>>>>>  Function Prototypes  <<<<<*/
#ifdef	__STDC__
void init_setup_defaults(SETUP_OBJ *setup);
int set_setup_value(...);
setup_opaque	get_setup_value(SETUP_OBJ *obj, SETUP_TAGS setup_item);

#else	/* K&R C */
void init_setup_defaults();
int set_setup_value();
setup_opaque	get_setup_value();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/



#ifdef	__STDC__
void init_setup_defaults(SETUP_OBJ *setup)
#else	/* K&R C */
void
init_setup_defaults(setup)
SETUP_OBJ       *setup;
#endif	/* __STDC__ */
{
	int	i, j;

        set_setup_value(setup,
                DO_HARDWARE_TEST, DEFAULT_DO_HARDWARE_TEST,
                DO_CAMERA_ON, DEFAULT_DO_CAMERA_ON,
		DO_RESET_TIMING, DEFAULT_DO_RESET_TIMING,	
                DO_TIMING_BOARD, DEFAULT_DO_TIMING_BOARD,
                DO_DIMENSIONS, DEFAULT_DO_DIMENSIONS,
		HARDWARE_TEST_SETTING, DEFAULT_HARDWARE_TEST_SETTING,
                TIMING_SETTING, DEFAULT_TIMING_SETTING,
                TIMING_LDA, DEFAULT_TIMING_LDA,
                TIMING_FILENAME, DEFAULT_TIMING_FILENAME,
                NCOLS, DEFAULT_NCOLS,
                NROWS, DEFAULT_NROWS,
		CCD_SETUP_COMPLETE, FALSE,
	NULL);

	for (i=1; i<=NUM_SETUP_TAGS; i++) {
		for (j=0; j<NUM_SETUP_STRINGS; j++) {
			if (sios[j].tag == i)
				setup_io_strings[i] = sios[j].string;
		}
	}

}



#ifdef	__STDC__
int set_setup_value(...)
#else	/* K&R C */
int
set_setup_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	SETUP_OBJ	*setup;
	int		modifier;
	int		int_value;
	char		*char_value;
	mydb_opaque	*db;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */
	setup = va_arg(ap, SETUP_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL)
	{
		switch (modifier)
		{
			case DB:
				db = va_arg(ap, mydb_opaque *);
				if (setup->db != NULL)
				{
					mydb_free(setup->db);
				}
				setup->db = db;
				break;
			case DO_HARDWARE_TEST:
				setup->do_hardware_test = va_arg(ap, int);
				break;
			case DO_CAMERA_ON:
				setup->do_camera_on = va_arg(ap, int);
				break;
			case DO_RESET_TIMING:
                                setup->do_reset_timing = va_arg(ap, int);
                                break;
			case DO_TIMING_BOARD:
				setup->do_timing_board = va_arg(ap, int);
				break;
			case DO_DIMENSIONS:
				setup->do_dimensions = va_arg(ap, int);
				break;
			case HARDWARE_TEST_SETTING:
				setup->hardware_test_setting = va_arg(ap, int);
				break;
			case TIMING_SETTING:
				setup->timing_setting = va_arg(ap, int);
				break;
			case TIMING_LDA:
				setup->timing_lda = va_arg(ap, int);
				break;
			case TIMING_FILENAME:
				setup->timing_filename =
						strdup(va_arg(ap, char *));
				break;
			case NCOLS:
				setup->ncols = va_arg(ap, int);
				break;
			case NROWS:
				setup->nrows = va_arg(ap, int);
				break;
			case CCD_SETUP_COMPLETE:
				setup->ccd_setup_complete = va_arg(ap, int);
				break;
			default:
				printf("(setup_data) bad set_setup_value %d\n",
					modifier);
		}

		modifier = va_arg(ap, int);
	}
}


#ifdef	__STDC__
setup_opaque	get_setup_value(SETUP_OBJ *obj, SETUP_TAGS setup_item)
#else	/* K&R C */
setup_opaque	
get_setup_value(obj, setup_item)
SETUP_OBJ	*obj;
SETUP_TAGS	setup_item;
#endif	/* __STDC__ */
{
	char floats[20];

	switch (setup_item)
	{
		case DB:
			return (setup_opaque)obj->db;
                case DO_HARDWARE_TEST:
			return (setup_opaque)obj->do_hardware_test;
                case DO_CAMERA_ON:
			return (setup_opaque)obj->do_camera_on;
		case DO_RESET_TIMING:
                        return (setup_opaque)obj->do_reset_timing;
                case DO_TIMING_BOARD:
			return (setup_opaque)obj->do_timing_board;
                case DO_DIMENSIONS:
			return (setup_opaque)obj->do_dimensions;
		case HARDWARE_TEST_SETTING:
			return (setup_opaque)obj->hardware_test_setting;
                case TIMING_SETTING:
			return (setup_opaque)obj->timing_setting;
                case TIMING_LDA:
			return (setup_opaque)obj->timing_lda;
                case NCOLS:
			return (setup_opaque)obj->ncols;
                case NROWS:
			return (setup_opaque)obj->nrows;
                case TIMING_FILENAME:
			return (setup_opaque)obj->timing_filename;
		case CCD_SETUP_COMPLETE:
			return (setup_opaque)obj->ccd_setup_complete;
		default:
			printf("(setup_data) bad get_setup_value %d\n",
				setup_item);
	}

	return -1;
}



/*
 * $Log: setup_data.c,v $
 * Revision 1.7  1997/01/03 22:23:25  gumrukcu
 * ***ABDUL***
 * adding reset function.
 *
 * Revision 1.6  1996/06/20 22:13:02  peker
 * recovered from previous errors
 *
 * Revision 1.5  1996/06/14 21:53:34  peker
 * test12
 *
 * Revision 1.4  1996/01/05  21:00:45  gumrukcu
 * if (setup->vme_filename != NULL)
 * free(setup->vme_filename); is commented out.
 * Don't know why it is put there.
 *
 * Revision 1.1  1996/01/05 01:41:58  gumrukcu
 * Initial revision
 *
 * Revision 1.1  1996/01/05 01:11:58  gumrukcu
 * Initial revision
 *
 * Revision 1.5  1996/01/04 23:00:02  gumrukcu
 * test0 for seg. fault.
 *
 * Revision 1.4  1995/12/12 22:33:39  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.3  1995/08/22  23:06:54  tjk
 * ANSI conversion.
 *
 * Revision 1.2  1995/05/23  21:51:35  tjk
 * completed temperature upgrade.
 *
 * Revision 1.1  1995/02/10  04:05:16  tjk
 * Initial revision
 *
 *
 */
