/* $Header: /rosie/src/ccd_utilities/tool/RCS/setup_io.c,v 1.8 1996/06/14 21:54:40 peker Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "setup_io.h"
#include "gfm.h"
#include "conversion.h"
#include "message.h"


/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void load_setup(void);
int load_setup_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
void extract_setup(mydb_opaque *db);
void save_as_setup(void);
int save_as_setup_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
int extract_setup_value(SETUP_TAGS setup_item, char *value);
void save_setup(char *filename, int append);
char *insert_setup(SETUP_OBJ *obj, SETUP_TAGS setup_item);

#else	/* K&R C */
void load_setup();
int load_setup_gfm_proc();
void extract_setup();
void save_as_setup();
int save_as_setup_gfm_proc();
int extract_setup_value();
void save_setup();
char *insert_setup();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/


#ifdef	__STDC__
void load_setup(void)
#else	/* K&R C */
void load_setup()
#endif	/* __STDC__ */
{
	xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, "Load Setup", NULL);
	gfm_activate(ccd_obj->Gfm, NULL, "^.*\\.setup$", NULL,
        		 load_setup_gfm_proc, NULL, GFM_LOAD);
}


#ifdef	__STDC__
int load_setup_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
load_setup_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif	/* __STDC__ */
{
	char		filename[255];
	mydb_opaque	*db;

	sprintf(filename, "%s/%s", dir, file);

	message_write("Loading CCD setup: %s\n", filename);

	db = mydb_create();
	if ((mydb_open(db, filename)) == -1)
	{
		message_popup(Setup->setup_popup,
			MESSAGE, "Cannot open the specified",
			MESSAGE, "configuration file.",
		NULL);
		message_write("Load ABORTED.\n");
	}
	else
	{
		extract_setup(db);
		extract_long_test_setup(db);
		message_write("Load complete.\n");
	}

	mydb_free(db);
	return(GFM_OK);
}


#ifdef	__STDC__
void extract_setup(mydb_opaque *db)
#else	/* K&R C */
void
extract_setup(db)
mydb_opaque	*db;
#endif	/* __STDC__ */
{
	SETUP_TAGS	setup_item;
	char		*value;

	mydb_set(db, MYDB_RESOURCE_TYPE, SETUP_RESOURCE);

	for (setup_item=DO_HARDWARE_TEST;
	     setup_item < CCD_SETUP_COMPLETE;
	     setup_item++)
	{
		value = (char *)mydb_get(db, MYDB_ATTRIBUTE,
				setup_io_strings[setup_item]);
		if (value != NULL)
		{
			extract_setup_value(setup_item, value);
		}
	}
	reset_setup_panel(ccd_obj->setup_obj);
}



#ifdef	__STDC__
void save_as_setup(void)
#else	/* K&R C */
void save_as_setup()
#endif	/* __STDC__ */
{

	xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, "Save Setup As...", NULL);
	gfm_activate(ccd_obj->Gfm, NULL, "^.*\\.setup$", NULL,
         save_as_setup_gfm_proc,   NULL, GFM_SAVE);
}


#ifdef	__STDC__
int save_as_setup_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
save_as_setup_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif	/* __STDC__ */
{
	char	filename[255], *value;

	sprintf(filename, "%s/%s", dir, file);

	save_setup(filename, FALSE);
	save_long_test_setup(filename, TRUE);
	return(GFM_OK);
}



#ifdef	__STDC__
int extract_setup_value(SETUP_TAGS setup_item, char *value)
#else	/* K&R C */
int
extract_setup_value(setup_item, value)
SETUP_TAGS	setup_item;
char		*value;
#endif	/* __STDC__ */
{
	int	int_value;
	float	float_value;
	char	str_value[20];

	switch (setup_item)
	{
		case DO_HARDWARE_TEST:
	        case HARDWARE_TEST_SETTING:
		case DO_CAMERA_ON:
		case DO_TIMING_BOARD:
		case DO_DIMENSIONS:
		case DO_RESET_TIMING:
			int_value = char2boolean(value);
			set_setup_value(ccd_obj->setup_obj, setup_item,
				int_value, NULL);
			break;
		case TIMING_SETTING:
			int_value = board_setting2int(value);
			set_setup_value(ccd_obj->setup_obj, setup_item,
				int_value, NULL);
			break;
		case TIMING_LDA:
		case NCOLS:
		case NROWS:
			int_value = char2int(value);
			set_setup_value(ccd_obj->setup_obj, setup_item,
				int_value, NULL);
			break;
		case TIMING_FILENAME:
			set_setup_value(ccd_obj->setup_obj, setup_item,
				value, NULL);
			break;
		default:
			printf("extract_setup_value() error: %d\n",
				setup_item);
	}
}


#ifdef	__STDC__
void save_setup(char *filename, int append)
#else	/* K&R C */
void save_setup(filename, append)
char	*filename;
int	append;
#endif	/* __STDC__ */
{
	SETUP_TAGS	setup_item;
	char		*value;
	mydb_opaque	*db;

	message_write("Saving CCD setup as: %s\n", filename);

	store_setup_settings(ccd_obj->setup_obj);

	db = mydb_create();
	
	mydb_set(db, MYDB_FILENAME, filename);
	mydb_set(db, MYDB_RESOURCE_TYPE, SETUP_RESOURCE);

	for (setup_item=DO_HARDWARE_TEST;
	     setup_item < CCD_SETUP_COMPLETE;
	     setup_item++)
	{
		value = insert_setup((SETUP_OBJ *)ccd_obj->setup_obj,
				     setup_item); 
		if (value != NULL)
		{
			mydb_set(db, MYDB_ATTRIBUTE,
				setup_io_strings[setup_item], value);
		}
	}

	mydb_set(db, MYDB_APPEND, append);
	if ((mydb_write(db, NULL)) == -1)
	{
		message_popup(Setup->setup_popup,
			MESSAGE, "Cannot write to the specified",
			MESSAGE, "configuration file.",
		NULL);
		message_write("Save ABORTED.\n");
	}
	else
	{
		message_write("Save Complete.\n");
	}

	mydb_free(db);
}


#ifdef	__STDC__
char *insert_setup(SETUP_OBJ *obj, SETUP_TAGS setup_item)
#else	/* K&R C */
char
*insert_setup(obj, setup_item)
SETUP_OBJ	*obj;
SETUP_TAGS	setup_item;
#endif	/* __STDC__ */
{
	char	*value;
	int	int_value;
	float	float_value;

	switch (setup_item)
	{
                case DO_HARDWARE_TEST:
                case DO_CAMERA_ON:
                case DO_TIMING_BOARD:
                case DO_DIMENSIONS:
		case DO_RESET_TIMING:
			int_value = (int)get_setup_value(obj, setup_item);
			return (boolean2char(int_value));
		case TIMING_SETTING:
			int_value = (int)get_setup_value(obj, setup_item);
			return (int2board_setting(int_value));
                case TIMING_LDA:
                case NCOLS:
                case NROWS:
			int_value = (int)get_setup_value(obj, setup_item);
			if (int_value == UNDEFINED)
				return NULL;
			else
				return (int2char(int_value));
                case TIMING_FILENAME:
			return (char *)get_setup_value(obj, setup_item);
		default:
			/*printf("insert_setup() error: %d\n", setup_item);*/
			return NULL;
	}
}


/*
 * $Log: setup_io.c,v $
 * Revision 1.8  1996/06/14 21:54:40  peker
 * test 12
 *
 * Revision 1.7  1996/03/08  23:41:54  tjk
 * Added NICMOS3 to load/save setup.
 *
 * Revision 1.6  1996/01/11 19:24:02  gumrukcu
 * Seg fault is fixed. NULL is returned from default in insert_setup
 * function.
 *
 * Revision 1.4  1995/12/12  22:33:40  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.3  1995/08/22  23:06:54  tjk
 * ANSI conversion.
 *
 * Revision 1.2  1995/05/23  21:51:54  tjk
 * completed temperature upgrade.
 *
 * Revision 1.1  1995/02/10  04:05:41  tjk
 * Initial revision
 *
 *
 */
