/* $Header: /rosie/src/ccd_utilities/tool/RCS/setup_panel.c,v 1.7 1997/01/03 22:24:04 gumrukcu Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"


/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void store_setup_settings(SETUP_OBJ *setup);
void set_setup_panel(...);
void setup_panel_buttons(int board, int setting);
void reset_setup_panel(SETUP_OBJ *setup);
void set_setup_checkmarks(int value);
void filename_browse(char *header);
int download_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);

#else	/* K&R C */
void store_setup_settings();
void set_setup_panel();
void setup_panel_buttons();
void reset_setup_panel();
void set_setup_checkmarks();
void filename_browse();
int download_gfm_proc();

#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/


#ifdef	__STDC__
void store_setup_settings(SETUP_OBJ *setup)
#else	/* K&R C */
void
store_setup_settings(setup)
SETUP_OBJ	*setup;
#endif	/* __STDC__ */
{

	set_setup_value (setup,
		DO_HARDWARE_TEST,
		   (int)xv_get(Setup->hardware_test_select, PANEL_VALUE),
		DO_RESET_TIMING,
                   (int)xv_get(Setup->reset_select, PANEL_VALUE),
		DO_CAMERA_ON,
		   (int)xv_get(Setup->camera_on_select, PANEL_VALUE),
		DO_TIMING_BOARD,
		   (int)xv_get(Setup->timing_board_select, PANEL_VALUE),
		DO_DIMENSIONS,
		   (int)xv_get(Setup->dimensions_select, PANEL_VALUE),
		HARDWARE_TEST_SETTING,
		   (int)xv_get(Setup->hardware_test_setting, PANEL_VALUE),
		TIMING_SETTING,
		   (int)xv_get(Setup->timing_board_setting, PANEL_VALUE),
		TIMING_LDA,
		   char2int((char *)xv_get(Setup->timing_board_lda_value,
			PANEL_VALUE)),
		TIMING_FILENAME,
		   (char *)xv_get(Setup->timing_board_filename_value,
			PANEL_VALUE),
		NCOLS,
		   char2int((char *)xv_get(Setup->ncols_text, PANEL_VALUE)),
		NROWS,
		   char2int((char *)xv_get(Setup->nrows_text, PANEL_VALUE)),
		NULL);
	
}


#ifdef	__STDC__
void set_setup_panel(...)
#else	/* K&R C */
void
set_setup_panel(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	SETUP_OBJ 	*setup;
	int		modifier;
	int		value;
	char		buffer[255];

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	setup = va_arg(ap, SETUP_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL)
	{
		switch (modifier)
		{
			case DO_HARDWARE_TEST:
				xv_set(Setup->hardware_test_select,
					PANEL_VALUE, va_arg(ap, int), NULL);
				break;
			case DO_CAMERA_ON:
				xv_set(Setup->camera_on_select,
					PANEL_VALUE, va_arg(ap, int), NULL);
				break;
			case DO_RESET_TIMING:
                                xv_set(Setup->reset_select,
                                        PANEL_VALUE, va_arg(ap, int), NULL);
                                break;
			case DO_TIMING_BOARD:
				xv_set(Setup->timing_board_select,
					PANEL_VALUE, va_arg(ap, int), NULL);
				break;
			case DO_DIMENSIONS:
				xv_set(Setup->dimensions_select,
					PANEL_VALUE, va_arg(ap, int), NULL);
				break;
                        case HARDWARE_TEST_SETTING:
				value = va_arg(ap, int);
				xv_set(Setup->hardware_test_setting,
					PANEL_VALUE, value, NULL);
				setup_panel_buttons(HARDWARE_TEST_SETTING,
					value);
				break;
			case TIMING_SETTING:
				value = va_arg(ap, int);
				xv_set(Setup->timing_board_setting,
					PANEL_VALUE, value, NULL);
				setup_panel_buttons(TIMING_SETTING, value);
				break;
			case TIMING_LDA:
				value = va_arg(ap, int);
				if (value == UNDEFINED) 
					xv_set(Setup->timing_board_lda_value,
						PANEL_VALUE, "", NULL);
				else
				{
					sprintf(buffer, "%d", value);
					xv_set(Setup->timing_board_lda_value,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case TIMING_FILENAME:
				xv_set(Setup->timing_board_filename_value,
					PANEL_VALUE, va_arg(ap, char *), NULL);
				break;
			case NCOLS:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Setup->ncols_text,
						PANEL_VALUE, "", NULL);
				else
				{
					sprintf(buffer, "%d", value);
					xv_set(Setup->ncols_text,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case NROWS:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Setup->nrows_text,
						PANEL_VALUE, "", NULL);
				else
				{
					sprintf(buffer, "%d", value);
					xv_set(Setup->nrows_text,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			default:
				printf("Invalid tag %d in %s\n",
					"set_setup_value");
		}

		modifier = va_arg(ap, int);
	}
}



#ifdef	__STDC__
void setup_panel_buttons(int board, int setting)
#else	/* K&R C */
void setup_panel_buttons(board, setting)
int		board;
int		setting;
#endif	/* __STDC__ */
{

	if (setting == CCD_LDA_SETTING)
	{
		if (board == TIMING_SETTING)
		{
			xv_set(Setup->timing_board_filename_value, XV_SHOW,
				FALSE, NULL);
			xv_set(Setup->timing_browse_button, XV_SHOW,
				FALSE, NULL);
			xv_set(Setup->timing_board_lda_value, XV_SHOW,
				TRUE, NULL);
		}

	}
	else if (setting == CCD_FILENAME_SETTING)
	{
	        if (board == HARDWARE_TEST_SETTING)
		{
		        xv_set(Long_test->hardware_long_test_popup,
				FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
			xv_set(Long_test->hardware_long_test_popup,
				XV_SHOW, TRUE, NULL);
	        }
		else if (board == TIMING_SETTING)
		{
			xv_set(Setup->timing_board_lda_value, XV_SHOW,
				FALSE, NULL);
			xv_set(Setup->timing_board_filename_value, XV_SHOW,
				TRUE, NULL);
			xv_set(Setup->timing_browse_button, XV_SHOW,
				TRUE, NULL);
		}

	}
}


#ifdef	__STDC__
void reset_setup_panel(SETUP_OBJ *setup)
#else	/* K&R C */
void
reset_setup_panel(setup)
SETUP_OBJ	*setup;
#endif	/* __STDC__ */
{
	char	buffer[255];
	int	setting;

	set_setup_panel(setup, 
		DO_HARDWARE_TEST, (int)get_setup_value(setup, DO_HARDWARE_TEST),
		DO_CAMERA_ON, (int)get_setup_value(setup, DO_CAMERA_ON),
		DO_RESET_TIMING, (int)get_setup_value(setup, DO_RESET_TIMING),
		DO_TIMING_BOARD, (int)get_setup_value(setup, DO_TIMING_BOARD),
		DO_DIMENSIONS, (int)get_setup_value(setup, DO_DIMENSIONS),
		HARDWARE_TEST_SETTING,
		  (int)get_setup_value(setup, HARDWARE_TEST_SETTING),
		TIMING_SETTING, (int)get_setup_value(setup, TIMING_SETTING),
		TIMING_LDA, (int)get_setup_value(setup, TIMING_LDA),
		TIMING_FILENAME,
		  (char *)get_setup_value(setup, TIMING_FILENAME),
		NROWS, (int)get_setup_value(setup, NROWS),
		NCOLS, (int)get_setup_value(setup, NCOLS),
	NULL);
}


#ifdef	__STDC__
void set_setup_checkmarks(int value)
#else	/* K&R C */
void
set_setup_checkmarks(value)
int	value;
#endif	/* __STDC__ */
{
	xv_set(Setup->reset_select, PANEL_VALUE, value, NULL);
	xv_set(Setup->hardware_test_select, PANEL_VALUE, value, NULL);
	xv_set(Setup->camera_on_select, PANEL_VALUE, value, NULL);
	xv_set(Setup->timing_board_select, PANEL_VALUE, value, NULL);
	xv_set(Setup->dimensions_select, PANEL_VALUE, value, NULL);
}



#ifdef	__STDC__
void filename_browse(char *header)
#else	/* K&R C */
void filename_browse(header)
char	*header;
#endif	/* __STDC__ */
{
	xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, header, NULL);
	gfm_activate(ccd_obj->Gfm, NULL, "^.*\\.lod$", NULL,
		download_gfm_proc, NULL, GFM_SET_FILENAME);
}

#ifdef	__STDC__
int download_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
download_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char			*dir;
char			*file;
#endif	/* __STDC__ */
{
	char    *ptr, buf[255];

	ptr = (char *)xv_get(ip->popup, FRAME_LABEL);
	sprintf(buf, "%s/%s", dir, file);

	if (strncmp(ptr, "Tim", 3) == 0)
	{
		xv_set(Setup->timing_board_filename_value,
			PANEL_VALUE, buf, NULL);
	}

	fprintf(stderr, "download gfm_proc:  %s\n",buf);
	return(GFM_OK);
}


/*
 * $Log: setup_panel.c,v $
 * Revision 1.7  1997/01/03 22:24:04  gumrukcu
 * ***ABDUL***
 * adding reset function.
 *
 * Revision 1.6  1996/06/14 21:55:45  peker
 * test 12
 *
 * Revision 1.5  1995/12/12  22:33:40  tjk
 * Merged SBUS and VME versions
 *
 * Revision 1.4  1995/08/23  00:15:34  tjk
 * Corrected Log message for new RCS version.
 *
 * Revision 1.3  1995/08/22  23:06:54  tjk
 * ANSI conversion.
 *
 * Revision 1.2  1995/08/10  16:53:26  tjk
 * Changes for IRTOOL.
 *
 * Revision 1.1  1995/02/10  04:07:09  tjk
 * Initial revision
 *
 *
 */
