/* $Header: /rosie/src/ccd_utilities/tool/RCS/vme.c,v 1.7 1996/01/05 20:14:43 gumrukcu Exp $
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/notice.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "message.h"
#include "vme_error.h"
#include "ccd_error.h"


/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
int apply_vme(void);
int setup_vme_interface(void);
int check_vme(void);
int show_vme_error(int errno);
int vme_interface_open(int value);

#else	/* K&R C */
int apply_vme();
int setup_vme_interface();
int check_vme();
int show_vme_error();
int vme_interface_open();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/

#ifdef	__STDC__
int apply_vme(void)
#else	/* K&R C */
int
apply_vme()
#endif	/* __STDC__ */
{
	vme_opaque	*vme;
	dsp_opaque	*dsp;
	int		errno, value;

	vme = ccd_obj->vme_obj;
	dsp = ccd_obj->dsp_obj;

	if ((int)get_vme_value(vme, VME_OPEN)) {
		value = message_popup(Vme->vme_popup,
			MESSAGE, 	"VME interface already configured.",
			MESSAGE, 	"Reconfigure?",
			BUTTON_STRING, 	"Yes",
			BUTTON_STRING,  "No",
		NULL);

		if (value == NOTICE_NO) {
			reset_vme_panel(vme);
			return;
		}
	}
	store_vme_settings(vme);
	vme_interface_open(FALSE);
	if ((errno = check_vme()) != 1) {
		show_vme_error(errno);
	}
	else {
		setup_vme_interface();
	}
}


#ifdef	__STDC__
int setup_vme_interface(void)
#else	/* K&R C */
int
setup_vme_interface()
#endif	/* __STDC__ */
{
	vme_opaque	*vme;
	dsp_opaque	*dsp;
	fits_opaque	*fits;
	int		errno;
	int		vme_rec_addr, *image_addr;
	char		*vme_rev_num;

	vme = ccd_obj->vme_obj;
	dsp = ccd_obj->dsp_obj;
	fits = ccd_obj->fits_obj;

	dsp_set(dsp, 
		VME_DEV,	(char *)get_vme_value(vme, VME_INTERFACE),
		VME_MEM_START, 	(int)get_vme_value(vme, BASE_MEMORY_ADDR),
		VME_MEM_OFFSET, (int)get_vme_value(vme, MEMORY_OFFSET),
		VME_MEM_SIZE, 	(int)get_vme_value(vme, MEMORY_SIZE),
		VME_SEND_START, (int)get_vme_value(vme, COMMAND_ADDR),
		VME_DATA_START, (int)get_vme_value(vme, IMAGE_ADDR),
		VME_REC_START,	(int)get_vme_value(vme, REPLY_ADDR),
		VME_REVISION,	(char *)get_vme_value(vme, VME_TO_CONTROLLER_REV),
	NULL);

	
	if (dsp_open((DSP_ATTR *)dsp) == DSP_ERROR) {
		if ((int)xv_get(Vme->vme_popup, XV_SHOW)) {
			message_popup(Vme->vme_popup,
				MESSAGE, "Unable to open the VME interface.",
			NULL);
		dsp_perror("setup_vme_interface");
		}
		else {
			message_popup(Ccd->ccd,
				MESSAGE, "Unable to open the VME interface.",
				FOCUS_XY, 0, 0,
			NULL);
		dsp_perror("setup_vme_interface");
		}
		set_vme_value(vme, VME_OPEN, FALSE, NULL);
		vme_interface_open(FALSE);
	}
	else {
		set_vme_value(vme, VME_OPEN, TRUE, NULL);
		vme_rev_num = (char *)dsp_get(dsp, VME_REVISION);
		/* reset VME board on startup */
		if (strcmp(vme_rev_num, DEFAULT_VME_REVISION) == 0)
			dsp_command((DSP_ATTR *)dsp, VME_ID, Boot);
		vme_rec_addr = (int)dsp_get(dsp, VME_REC_START);
		dsp_command((DSP_ATTR *)dsp, VME_ID, SRA, vme_rec_addr);
		image_addr = (int *)dsp_get(dsp, DATA_ADDR);
		fits_set(fits, FITS_IMAGE_ADDR, image_addr, NULL);
		vme_interface_open(TRUE);
	}

	if (ccdtool_debug) {
		set_vme_value(vme, VME_OPEN, TRUE, NULL);
		vme_rec_addr = (int)dsp_get(dsp, VME_REC_START);
		dsp_command((DSP_ATTR *)dsp, VME_ID, SRA, vme_rec_addr);
		image_addr = (int *)dsp_get(dsp, DATA_ADDR);
		fits_set(fits, FITS_IMAGE_ADDR, image_addr, NULL);
		vme_interface_open(TRUE);
	}
}


#ifdef	__STDC__
int check_vme(void)
#else	/* K&R C */
int
check_vme()
#endif	/* __STDC__ */
{
	vme_opaque	*vme;
	char		*interface;

	vme = ccd_obj->vme_obj;
	interface = (char *)get_vme_value(vme, VME_INTERFACE);

	if ((interface == NULL) || (strlen(interface) == 0))
		return VME_INTERFACE_UNDEFINED;

	if ((int)get_vme_value(vme, BASE_MEMORY_ADDR) == UNDEFINED)
		return BASE_MEMORY_ADDR_UNDEFINED;
	if ((int)get_vme_value(vme, MEMORY_OFFSET) == UNDEFINED)
		return MEMORY_OFFSET_UNDEFINED;
	if ((int)get_vme_value(vme, MEMORY_SIZE) == UNDEFINED)
		return MEMORY_SIZE_UNDEFINED;
	if ((int)get_vme_value(vme, COMMAND_ADDR) == UNDEFINED)
		return COMMAND_ADDR_UNDEFINED;
	if ((int)get_vme_value(vme, REPLY_ADDR) == UNDEFINED)
		return REPLY_ADDR_UNDEFINED;
	if ((int)get_vme_value(vme, IMAGE_ADDR) == UNDEFINED)
		return IMAGE_ADDR_UNDEFINED;

	return 1;
}


#ifdef	__STDC__
int show_vme_error(int errno)
#else	/* K&R C */
int
show_vme_error(errno)
int	errno;
#endif	/* __STDC__ */
{
	switch (errno) {
		case VME_INTERFACE_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "VME interface.",
			NULL);
			break;
		case BASE_MEMORY_ADDR_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "base memory address.",
			NULL);
			break;
		case MEMORY_OFFSET_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "memory offset.",
			NULL);
			break;
		case MEMORY_SIZE_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "memory size.",
			NULL);
			break;
		case COMMAND_ADDR_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "command address.",
			NULL);
			break;
		case REPLY_ADDR_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "reply address.",
			NULL);
			break;
		case IMAGE_ADDR_UNDEFINED:
			message_popup(Vme->vme_popup,
				MESSAGE, "You must specify a",
				MESSAGE, "image address.",
			NULL);
			break;
	}
}


#ifdef	__STDC__
int vme_interface_open(int value)
#else	/* K&R C */
int
vme_interface_open(value)
int	value;
#endif	/* __STDC__ */
{
	Menu		menu;
	Menu_item	item;

	menu = (Menu)xv_get(Ccd->setup_button, PANEL_ITEM_MENU);
	item = (Menu_item)xv_get(menu, MENU_NTH_ITEM, 1);

	if (value) {
		xv_set(item, MENU_INACTIVE, FALSE, NULL);
		xv_set(Ccd->direct_dsp_button, PANEL_INACTIVE, FALSE, NULL);
		xv_set(Ccd->expctl_button, PANEL_INACTIVE, FALSE, NULL);
		xv_set(Ccd->fits_button, PANEL_INACTIVE, FALSE, NULL);
#ifdef	IRTOOL
		xv_set(Ccd->ir_button, PANEL_INACTIVE, FALSE, NULL);
#endif	/* IRTOOL */
	}
	else {
		dsp_close((DSP_ATTR *)ccd_obj->dsp_obj);
		xv_set(item, MENU_INACTIVE, TRUE, NULL);
		xv_set(Ccd->direct_dsp_button, PANEL_INACTIVE, TRUE, NULL);
		xv_set(Ccd->expctl_button, PANEL_INACTIVE, TRUE, NULL);
		xv_set(Ccd->ir_button, PANEL_INACTIVE, TRUE, NULL);
		xv_set(Direct_dsp->direct_dsp_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
		xv_set(Setup->setup_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
		xv_set(Expctl->expctl_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
#ifdef	IRTOOL
		xv_set(Ir_ir_popup->ir_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
#endif	/* IRTOOL */
		xv_set(Fits->fits_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
/*
		xv_set(Fits_comments->fits_user_comment_popup,
			FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_OUT,
			XV_SHOW, FALSE,
		NULL);
*/
	}
}


/*
 * $Log: vme.c,v $
 * Revision 1.7  1996/01/05 20:14:43  gumrukcu
 * Castinf is put back to dsp_command(dsp,..).
 * If not put I keep getting a warning about apassing the first argument.
 *
 * Revision 1.6  1996/01/05 18:28:25  gumrukcu
 * Casting to dsp in "dsp_command" is removed.
 *
 * Revision 1.5  1996/01/05 00:43:36  gumrukcu
 * cast is made to dsp.
 *
 * Revision 1.4  1995/08/21 23:30:11  tjk
 * ANSI conversion.
 *
 * Revision 1.3  1995/08/10  16:53:26  tjk
 * Changes for IRTOOL.
 *
 * Revision 1.2  1995/08/01  16:53:02  tjk
 * "Added
 *
 * Revision 1.1  1995/02/10  04:09:01  tjk
 * Initial revision
 *
 *
 */
