/* $Header: /rosie/src/ccd_utilities/tool/RCS/vme_data.c,v 1.3 1995/08/23 00:17:38 tjk Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"

struct {
	int	tag;
	char	*string;
} vmeios[] = {
	{ VME_INTERFACE, 	"VMEInterface" },
	{ BASE_MEMORY_ADDR,	"baseMemoryAddr" },
	{ MEMORY_OFFSET,	"memoryOffset" },
	{ MEMORY_SIZE,		"memorySize" },
	{ COMMAND_ADDR, 	"commandAddr" },
	{ REPLY_ADDR, 		"replyAddr" },
	{ IMAGE_ADDR,		"imageAddr" },
	{ VME_TO_CONTROLLER_REV,	"VMEtoControllerRev" }
};

char	*vme_io_strings[NUM_VME_TAGS+1];

/*>>>>>  Function Prototypes <<<<<*/
#ifdef	__STDC__
void init_vme_defaults(VME_OBJ *vme);
void set_vme_value(...);
vme_opaque get_vme_value(VME_OBJ *vme, VME_TAGS vme_item);
#else	/* K&R C */
void init_vme_defaults();
void set_vme_value();
vme_opaque get_vme_value();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes <<<<<*/


#ifdef	__STDC__
void init_vme_defaults(VME_OBJ *vme)
#else	/* K&R C */
void
init_vme_defaults(vme)
VME_OBJ		*vme;
#endif	/* __STDC__ */
{
	int	i, j;

	for (i=1; i<=NUM_VME_TAGS; i++) {
		for (j=0; j<NUM_VME_STRINGS; j++) {
			if (vmeios[j].tag == i)
				vme_io_strings[i] = vmeios[j].string;
		}
	}
	vme->vme_interface = NULL;
	vme->base_memory_addr = UNDEFINED;
	vme->memory_offset = UNDEFINED;
	vme->memory_size = UNDEFINED;
	vme->command_addr = UNDEFINED;
	vme->reply_addr = UNDEFINED;
	vme->image_addr = UNDEFINED;
	vme->open = FALSE;
	vme->vme_to_controller_rev = DEFAULT_VME_REVISION;
}


#ifdef	__STDC__
void set_vme_value(...)
#else	/* K&R C */
void
set_vme_value(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	VME_OBJ		*vme;
	int		modifier;
	int		int_value;
	char		*char_value;

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	vme = va_arg(ap, VME_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL) {
		switch (modifier) {
			case VME_INTERFACE:
				if (vme->vme_interface != NULL)
					free(vme->vme_interface);
				vme->vme_interface = strdup(va_arg(ap, char *));
				break;
			case BASE_MEMORY_ADDR:
				vme->base_memory_addr = va_arg(ap, int);
				break;
			case MEMORY_OFFSET:
				vme->memory_offset = va_arg(ap, int);
				break;
			case MEMORY_SIZE:
				vme->memory_size = va_arg(ap, int);
				break;
			case COMMAND_ADDR:
				vme->command_addr = va_arg(ap, int);
				break;
			case REPLY_ADDR:
				vme->reply_addr = va_arg(ap, int);
				break;
			case IMAGE_ADDR:
				vme->image_addr = va_arg(ap, int);
				break;
			case VME_OPEN:
				vme->open = va_arg(ap, int);
				break;
			case VME_TO_CONTROLLER_REV:
				if (vme->vme_to_controller_rev != NULL)
					free(vme->vme_to_controller_rev);
				vme->vme_to_controller_rev = strdup(va_arg(ap, char *));
				break;
			default:
				printf("ERROR!\n");
		}

		modifier = va_arg(ap, int);
	}
}


#ifdef	__STDC__
vme_opaque get_vme_value(VME_OBJ *vme, VME_TAGS vme_item)
#else	/* K&R C */
vme_opaque
get_vme_value(vme, vme_item)
VME_OBJ		*vme;
VME_TAGS	vme_item;
#endif	/* __STDC__ */
{
	switch (vme_item) {
		case VME_INTERFACE:
			return (vme_opaque)vme->vme_interface;
		case BASE_MEMORY_ADDR:
			return (vme_opaque)vme->base_memory_addr;
		case MEMORY_OFFSET:
			return (vme_opaque)vme->memory_offset;
		case MEMORY_SIZE:
			return (vme_opaque)vme->memory_size;
		case COMMAND_ADDR:
			return (vme_opaque)vme->command_addr;
		case REPLY_ADDR:
			return (vme_opaque)vme->reply_addr;
		case IMAGE_ADDR:
			return (vme_opaque)vme->image_addr;
		case VME_OPEN:
			return (vme_opaque)vme->open;
		case VME_TO_CONTROLLER_REV:
			return (vme_opaque)vme->vme_to_controller_rev;
	}
}


/*
 * $Log: vme_data.c,v $
 * Revision 1.3  1995/08/23 00:17:38  tjk
 * Corrected Log for new RCS version.
 *
 * Revision 1.2  1995/08/21  23:30:11  tjk
 * ANSI conversion.
 *
 * Revision 1.1  1995/02/10  04:09:28  tjk
 * Initial revision
 *
 *
 */
