/* $Header: /rosie/src/ccd_utilities/tool/RCS/vme_io.c,v 1.2 1995/08/21 23:30:11 tjk Exp $
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccd.h"
#include "ccd_conf.h"
#include "vme_io.h"
#include "gfm.h"
#include "conversion.h"


/*>>>>>  Function Prototypes  <<<<<*/
#ifdef	__STDC__
void load_vme_setup(void);
int load_vme_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
void extract_vme_setup(mydb_opaque *db);
int extract_vme_setup_value(VME_TAGS vme_item, char *value);
void save_as_vme_setup(void);
int save_as_vme_gfm_proc(gfm_popup_objects *ip, char *dir, char *file);
void save_vme_setup(char *filename, int append);
char *insert_vme_setup(VME_OBJ *obj, VME_TAGS vme_item);

#else	/* K&R C */
void load_vme_setup();
int load_vme_gfm_proc();
void extract_vme_setup();
int extract_vme_setup_value();
void save_as_vme_setup();
int save_as_vme_gfm_proc();
void save_vme_setup();
char *insert_vme_setup();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/

#ifdef	__STDC__
void load_vme_setup(void)
#else	/* K&R C */
void load_vme_setup()
#endif	/* __STDC__ */
{
	xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, "Load VME Setup", NULL);
	gfm_activate(ccd_obj->Gfm, NULL, "", NULL, load_vme_gfm_proc, NULL,
		GFM_LOAD);
}


#ifdef	__STDC__
int load_vme_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
load_vme_gfm_proc(ip, dir, file)
gfm_popup_objects	*ip;
char                    *dir;
char                    *file;
#endif	/* __STDC__ */
{
        char            filename[255];
        mydb_opaque     *db;

        sprintf(filename, "%s/%s", dir, file);

	message_write("Loading VME setup: %s\n", filename);

        db = mydb_create();
        mydb_open(db, filename);
        extract_vme_setup(db);
        mydb_free(db);

        return(GFM_OK);
}


#ifdef	__STDC__
void extract_vme_setup(mydb_opaque *db)
#else	/* K&R C */
void
extract_vme_setup(db)
mydb_opaque     *db;
#endif	/* __STDC__ */
{
        VME_TAGS	vme_item;
        char            *value;

        mydb_set(db, MYDB_RESOURCE_TYPE, VME_SETUP_RESOURCE);

        for (vme_item=VME_INTERFACE;
	     vme_item <= VME_TO_CONTROLLER_REV;
	     vme_item++)
	{
                value = (char *)mydb_get(db, MYDB_ATTRIBUTE,
			vme_io_strings[vme_item]);
                if (value != NULL) {
                        extract_vme_setup_value(vme_item, value);
                }
        }
        reset_vme_panel(ccd_obj->vme_obj);
}



#ifdef	__STDC__
int extract_vme_setup_value(VME_TAGS vme_item, char *value)
#else	/* K&R C */
int
extract_vme_setup_value(vme_item, value)
VME_TAGS	vme_item;
char		*value;
#endif	/* __STDC__ */
{
	int	int_value;

	switch (vme_item) {
		case VME_INTERFACE:
			set_vme_value(ccd_obj->vme_obj, vme_item, value, NULL);
			break;
		case BASE_MEMORY_ADDR:
		case MEMORY_OFFSET:
		case MEMORY_SIZE:
		case COMMAND_ADDR:
		case REPLY_ADDR:
		case IMAGE_ADDR:
			int_value = char2hex(value);
			set_vme_value(ccd_obj->vme_obj, vme_item, int_value,
				NULL);
			break;
		case VME_TO_CONTROLLER_REV:
			set_vme_value(ccd_obj->vme_obj, vme_item, value, NULL);
			break;
	}
}


#ifdef	__STDC__
void save_as_vme_setup(void)
#else	/* K&R C */
void
save_as_vme_setup()
#endif	/* __STDC__ */
{

        xv_set(ccd_obj->Gfm->popup, FRAME_LABEL, "Save VME Setup As...", NULL);
        gfm_activate(ccd_obj->Gfm, NULL, "", NULL, save_as_vme_gfm_proc,
		NULL, GFM_SAVE);
}


#ifdef	__STDC__
int save_as_vme_gfm_proc(gfm_popup_objects *ip, char *dir, char *file)
#else	/* K&R C */
int
save_as_vme_gfm_proc(ip, dir, file)
gfm_popup_objects       *ip;
char                    *dir;
char                    *file;
#endif	/* __STDC__ */
{
        char    filename[255], *value;

        sprintf(filename, "%s/%s", dir, file);

        save_vme_setup(filename, FALSE);
        return(GFM_OK);
}


#ifdef	__STDC__
void save_vme_setup(char *filename, int append)
#else	/* K&R C */
void
save_vme_setup(filename, append)
char	*filename;
int	append;
#endif	/* __STDC__ */
{
	VME_TAGS	vme_item;
	char		*char_value;
	mydb_opaque	*db;

	message_write("Saving VME setup as: %s\n", filename);
	store_vme_settings(ccd_obj->vme_obj);
	db = mydb_create();

	mydb_set(db, MYDB_FILENAME, filename);
	mydb_set(db, MYDB_RESOURCE_TYPE, VME_SETUP_RESOURCE);

	for (vme_item=VME_INTERFACE;
	     vme_item<=VME_TO_CONTROLLER_REV;
	     vme_item++)
	{
		char_value = insert_vme_setup((VME_OBJ *)ccd_obj->vme_obj,
				vme_item);
		if (char_value != NULL) {
			mydb_set(db, MYDB_ATTRIBUTE, vme_io_strings[vme_item],
				char_value);
		}
	}

	mydb_set(db, MYDB_APPEND, append);
	mydb_write(db, NULL);
	mydb_free(db);
}


#ifdef	__STDC__
char *insert_vme_setup(VME_OBJ *obj, VME_TAGS vme_item)
#else	/* K&R C */
char
*insert_vme_setup(obj, vme_item)
VME_OBJ		*obj;
VME_TAGS	vme_item;
#endif	/* __STDC__ */
{
	int	int_value;

	switch (vme_item) {
		case VME_INTERFACE:
			return (char *)get_vme_value(obj, vme_item);
                case BASE_MEMORY_ADDR:
                case MEMORY_OFFSET:
                case MEMORY_SIZE:
                case COMMAND_ADDR:
                case REPLY_ADDR:
                case IMAGE_ADDR:
			int_value = (int)get_vme_value(obj, vme_item);
			if (int_value == UNDEFINED)
				return NULL;
			else
				return (hex2char(int_value));
		case VME_TO_CONTROLLER_REV:
			return (char *)get_vme_value(obj, vme_item);
	}
}

/*
 * $Log: vme_io.c,v $
 * Revision 1.2  1995/08/21 23:30:11  tjk
 * ANSI conversion.
 *
 * Revision 1.1  1995/02/10  04:10:45  tjk
 * Initial revision
 *
 *
 */
