/* $Header: /rosie/src/ccd_utilities/tool/RCS/vme_panel.c,v 1.3 1995/08/23 00:17:38 tjk Exp $
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include "ccd_error.h"
#include "ccd.h"
#include "gfm.h"
#include "ccd_conf.h"


/*>>>>>  Function Prototypes  <<<<<*/
#ifdef	__STDC__
void store_vme_settings(VME_OBJ *vme);
void set_vme_panel(...);
void reset_vme_panel(VME_OBJ *vme);
#else	/* K&R C */
void store_vme_settings();
void set_vme_panel();
void reset_vme_panel();
#endif	/* __STDC__ */
/*>>>>>  End Function Prototypes  <<<<<*/


#ifdef	__STDC__
void store_vme_settings(VME_OBJ *vme)
#else	/* K&R C */
void
store_vme_settings(vme)
VME_OBJ		*vme;
#endif	/* __STDC__ */
{

	set_vme_value (vme,
		VME_INTERFACE, (char *)xv_get(Vme->vme_interface, PANEL_VALUE),
		BASE_MEMORY_ADDR,
		  char2hex((char *)xv_get(Vme->base_memory_addr, PANEL_VALUE)),
		MEMORY_OFFSET,
		  char2hex((char *)xv_get(Vme->memory_offset, PANEL_VALUE)),
		MEMORY_SIZE,
		  char2hex((char *)xv_get(Vme->memory_size, PANEL_VALUE)),
		COMMAND_ADDR,
		  char2hex((char *)xv_get(Vme->command_addr, PANEL_VALUE)),
		REPLY_ADDR,
		  char2hex((char *)xv_get(Vme->reply_addr, PANEL_VALUE)),
		IMAGE_ADDR,
		  char2hex((char *)xv_get(Vme->image_addr, PANEL_VALUE)),
		VME_TO_CONTROLLER_REV,
		  (char *)xv_get(Vme->vme_to_controller_rev, PANEL_VALUE),
	NULL);
}


#ifdef	__STDC__
void set_vme_panel(...)
#else	/* K&R C */
void
set_vme_panel(va_alist)
va_dcl
#endif	/* __STDC__ */
{
	va_list		ap;
	VME_OBJ		*vme;
	int		modifier;
	int		value;
	char		buffer[255];

#ifdef	__STDC__
	va_start(ap, NULL);
#else	/* K&R C */
	va_start(ap);
#endif	/* __STDC__ */

	vme = va_arg(ap, VME_OBJ *);
	modifier = va_arg(ap, int);

	while (modifier != NULL) {
		switch (modifier) {
			case VME_INTERFACE:
				xv_set(Vme->vme_interface, PANEL_VALUE,
					va_arg(ap, char *), NULL);
				break;
			case BASE_MEMORY_ADDR:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Vme->base_memory_addr,
						PANEL_VALUE, "", NULL);
				else {
					sprintf(buffer, "%08x", value);
					xv_set(Vme->base_memory_addr,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case MEMORY_OFFSET:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Vme->memory_offset,
						PANEL_VALUE, "", NULL);
				else {
					sprintf(buffer, "%08x", value);
					xv_set(Vme->memory_offset,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case MEMORY_SIZE:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Vme->memory_size,
						PANEL_VALUE, "", NULL);
				else {
					sprintf(buffer, "%08x", value);
					xv_set(Vme->memory_size,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case COMMAND_ADDR:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Vme->command_addr,
						PANEL_VALUE, "", NULL);
				else {
					sprintf(buffer, "%08x", value);
					xv_set(Vme->command_addr,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case REPLY_ADDR:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Vme->reply_addr,
						PANEL_VALUE, "", NULL);
				else {
					sprintf(buffer, "%08x", value);
					xv_set(Vme->reply_addr,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case IMAGE_ADDR:
				value = va_arg(ap, int);
				if (value == UNDEFINED)
					xv_set(Vme->image_addr,
						PANEL_VALUE, "", NULL);
				else {
					sprintf(buffer, "%08x", value);
					xv_set(Vme->image_addr,
						PANEL_VALUE, buffer, NULL);
				}
				break;
			case VME_TO_CONTROLLER_REV:
				xv_set(Vme->vme_to_controller_rev,
					PANEL_VALUE, va_arg(ap, char *), NULL);
				break;
			default:
				printf("ERROR\n");
		}

		modifier = va_arg(ap, int);
	}
}


#ifdef	__STDC__
void reset_vme_panel(VME_OBJ *vme)
#else	/* K&R C */
void
reset_vme_panel(vme)
VME_OBJ		*vme;
#endif	/* __STDC__ */
{
	set_vme_panel(vme,
		VME_INTERFACE, (char *)get_vme_value(vme, VME_INTERFACE),
		BASE_MEMORY_ADDR, (char *)get_vme_value(vme, BASE_MEMORY_ADDR),
		MEMORY_OFFSET, (char *)get_vme_value(vme, MEMORY_OFFSET),
		MEMORY_SIZE, (char *)get_vme_value(vme, MEMORY_SIZE),
		COMMAND_ADDR, (char *)get_vme_value(vme, COMMAND_ADDR),
		REPLY_ADDR, (char *)get_vme_value(vme, REPLY_ADDR),
		IMAGE_ADDR, (char *)get_vme_value(vme, IMAGE_ADDR),
		VME_TO_CONTROLLER_REV,
		  (char *)get_vme_value(vme, VME_TO_CONTROLLER_REV),
	NULL);
}


/*
 * $Log: vme_panel.c,v $
 * Revision 1.3  1995/08/23 00:17:38  tjk
 * Corrected Log for new RCS version.
 *
 * Revision 1.2  1995/08/21  23:30:11  tjk
 * ANSI conversion.
 *
 * Revision 1.1  1995/02/10  04:11:07  tjk
 * Initial revision
 *
 *
 */
